{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {
    "cell_id": "49239d7b109d4980a99763d1ba4332d0",
    "deepnote_cell_type": "markdown",
    "tags": []
   },
   "source": [
    "# Week 9 Monday"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "cell_id": "5d3edd25bc054977acb5d772208c16b2",
    "deepnote_cell_type": "markdown",
    "owner_user_id": "02be19f8-8497-4212-b8d0-46ca9f1d48b9",
    "tags": []
   },
   "source": [
    "## Announcements\n",
    "\n",
    "* Online Quiz 6 is available.  See Friday's notebook and my Canvas message for more details.\n",
    "* I have office hours after class today at 11am, next door in ALP 3610.\n",
    "* Worksheets due by 11:59pm tomorrow.\n",
    "* Videos and video quizzes posted; due Monday before lecture.\n",
    "* On Wednesday we will discuss the Course Project.  Instructions are posted in the [course notes](https://christopherdavisuci.github.io/UCI-Math-10-F22/Proj/CourseProject.html).  See also the accompanying Worksheet 16.\n",
    "* In today's worksheet, we use a random forest to classify handwritten digits.  Take a moment to think about how difficult that would be to do by hand.  We are producing a function $\\mathbb{R}^{784} \\rightarrow \\{0,1,2,3,4,5,6,7,8,9\\}$."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "cell_id": "d9e487d1c0a04b5f835d8d8267ba0a77",
    "deepnote_cell_type": "markdown",
    "tags": []
   },
   "source": [
    "## Simulated data for classification\n",
    "\n",
    "We didn't talk about most of this code during lecture.  It is here just to give us some data to work with, data that can be used to show how random forests work."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {
    "cell_id": "46f0a38352f6470eb1eedebe3f973308",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 1255,
    "execution_start": 1669053479844,
    "source_hash": "46e6bd77",
    "tags": []
   },
   "outputs": [],
   "source": [
    "import pandas as pd\n",
    "import altair as alt"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "metadata": {
    "cell_id": "ca13b0beeba742a28cdc955e831f4f82",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 1111,
    "execution_start": 1669053853665,
    "source_hash": "537af973",
    "tags": []
   },
   "outputs": [],
   "source": [
    "from sklearn.datasets import make_blobs\n",
    "from sklearn.model_selection import train_test_split"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {
    "cell_id": "b48eb97a0bb24350b7f0e05b4a579016",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 3,
    "execution_start": 1669053855591,
    "source_hash": "b85b0507",
    "tags": []
   },
   "outputs": [],
   "source": [
    "X,y = make_blobs(n_samples=500, n_features=2, centers=[[0,0],[2,2]], random_state=13)\n",
    "X_train, X_test, y_train, y_test = train_test_split(X,y, train_size=0.9, random_state=0)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "metadata": {
    "cell_id": "d05594ff53dd4ac4962ad132a8095ed9",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 684,
    "execution_start": 1669053913006,
    "output_cleared": false,
    "source_hash": "d9095fea",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "\n",
       "<div id=\"altair-viz-c91b553142fc42ef87aaafac21a95400\"></div>\n",
       "<script type=\"text/javascript\">\n",
       "  var VEGA_DEBUG = (typeof VEGA_DEBUG == \"undefined\") ? {} : VEGA_DEBUG;\n",
       "  (function(spec, embedOpt){\n",
       "    let outputDiv = document.currentScript.previousElementSibling;\n",
       "    if (outputDiv.id !== \"altair-viz-c91b553142fc42ef87aaafac21a95400\") {\n",
       "      outputDiv = document.getElementById(\"altair-viz-c91b553142fc42ef87aaafac21a95400\");\n",
       "    }\n",
       "    const paths = {\n",
       "      \"vega\": \"https://cdn.jsdelivr.net/npm//vega@5?noext\",\n",
       "      \"vega-lib\": \"https://cdn.jsdelivr.net/npm//vega-lib?noext\",\n",
       "      \"vega-lite\": \"https://cdn.jsdelivr.net/npm//vega-lite@4.17.0?noext\",\n",
       "      \"vega-embed\": \"https://cdn.jsdelivr.net/npm//vega-embed@6?noext\",\n",
       "    };\n",
       "\n",
       "    function maybeLoadScript(lib, version) {\n",
       "      var key = `${lib.replace(\"-\", \"\")}_version`;\n",
       "      return (VEGA_DEBUG[key] == version) ?\n",
       "        Promise.resolve(paths[lib]) :\n",
       "        new Promise(function(resolve, reject) {\n",
       "          var s = document.createElement('script');\n",
       "          document.getElementsByTagName(\"head\")[0].appendChild(s);\n",
       "          s.async = true;\n",
       "          s.onload = () => {\n",
       "            VEGA_DEBUG[key] = version;\n",
       "            return resolve(paths[lib]);\n",
       "          };\n",
       "          s.onerror = () => reject(`Error loading script: ${paths[lib]}`);\n",
       "          s.src = paths[lib];\n",
       "        });\n",
       "    }\n",
       "\n",
       "    function showError(err) {\n",
       "      outputDiv.innerHTML = `<div class=\"error\" style=\"color:red;\">${err}</div>`;\n",
       "      throw err;\n",
       "    }\n",
       "\n",
       "    function displayChart(vegaEmbed) {\n",
       "      vegaEmbed(outputDiv, spec, embedOpt)\n",
       "        .catch(err => showError(`Javascript Error: ${err.message}<br>This usually means there's a typo in your chart specification. See the javascript console for the full traceback.`));\n",
       "    }\n",
       "\n",
       "    if(typeof define === \"function\" && define.amd) {\n",
       "      requirejs.config({paths});\n",
       "      require([\"vega-embed\"], displayChart, err => showError(`Error loading script: ${err.message}`));\n",
       "    } else {\n",
       "      maybeLoadScript(\"vega\", \"5\")\n",
       "        .then(() => maybeLoadScript(\"vega-lite\", \"4.17.0\"))\n",
       "        .then(() => maybeLoadScript(\"vega-embed\", \"6\"))\n",
       "        .catch(showError)\n",
       "        .then(() => displayChart(vegaEmbed));\n",
       "    }\n",
       "  })({\"config\": {\"view\": {\"continuousWidth\": 400, \"continuousHeight\": 300}}, \"data\": {\"name\": \"data-d967f945ec1fd21aa301ce8244c45961\"}, \"mark\": \"circle\", \"encoding\": {\"color\": {\"field\": \"Class\", \"type\": \"nominal\"}, \"x\": {\"field\": \"x\", \"type\": \"quantitative\"}, \"y\": {\"field\": \"y\", \"type\": \"quantitative\"}}, \"title\": \"True values\", \"$schema\": \"https://vega.github.io/schema/vega-lite/v4.17.0.json\", \"datasets\": {\"data-d967f945ec1fd21aa301ce8244c45961\": [{\"x\": 1.4559540371135231, \"y\": 1.2225321299541925, \"Class\": 1}, {\"x\": 0.14375578038446712, \"y\": 0.9051715331786675, \"Class\": 0}, {\"x\": -0.8670155109522104, \"y\": 0.3711592574799248, \"Class\": 0}, {\"x\": 2.236716247035387, \"y\": 1.7613912870250954, \"Class\": 1}, {\"x\": 1.2839076010237616, \"y\": 1.0493530134308715, \"Class\": 1}, {\"x\": 2.4119441266475636, \"y\": 0.8885655192985291, \"Class\": 1}, {\"x\": 0.6085923102841594, \"y\": -1.393525225748726, \"Class\": 0}, {\"x\": -0.5672394268341736, \"y\": -0.6847900441875194, \"Class\": 0}, {\"x\": 1.3396178056849557, \"y\": 2.444527547552682, \"Class\": 1}, {\"x\": 1.6036421369444245, \"y\": 2.9838660218731716, \"Class\": 1}, {\"x\": 3.2132364327523555, \"y\": 1.3270613788768748, \"Class\": 1}, {\"x\": 3.552345691172357, \"y\": 2.2096037598723535, \"Class\": 1}, {\"x\": 1.762714296497166, \"y\": -1.0740807545618982, \"Class\": 0}, {\"x\": -0.17830606215500272, \"y\": -1.5232135953524801, \"Class\": 0}, {\"x\": 2.765631512603937, \"y\": 2.902379378160018, \"Class\": 1}, {\"x\": 1.710537988461506, \"y\": 3.1701766375339, \"Class\": 1}, {\"x\": -0.20734969827652708, \"y\": -0.37591996120915105, \"Class\": 0}, {\"x\": 1.6145821893115024, \"y\": 2.9366532186221868, \"Class\": 1}, {\"x\": 1.9489926716237493, \"y\": 2.8234675712472987, \"Class\": 1}, {\"x\": 2.710041698724246, \"y\": 2.7724887435364485, \"Class\": 1}, {\"x\": 2.8662962472055105, \"y\": 2.2472179530453955, \"Class\": 1}, {\"x\": -1.2231117488973633, \"y\": 0.3685950822771125, \"Class\": 0}, {\"x\": 0.9425397724411325, \"y\": -0.5351465926388975, \"Class\": 0}, {\"x\": 1.8105902612798963, \"y\": 0.9911354587932695, \"Class\": 1}, {\"x\": 1.2750575903893269, \"y\": 1.2567430683363894, \"Class\": 0}, {\"x\": 1.8496125662057936, \"y\": -0.08165155616424355, \"Class\": 0}, {\"x\": 3.3474469652692624, \"y\": 2.2989958455256603, \"Class\": 1}, {\"x\": -0.404357671797137, \"y\": 1.5418077084686126, \"Class\": 0}, {\"x\": 1.3613709645591259, \"y\": -0.5226347611202428, \"Class\": 0}, {\"x\": 0.01997092245414585, \"y\": 0.8628168935353443, \"Class\": 0}, {\"x\": 3.1409091213318314, \"y\": 1.6155005913792657, \"Class\": 1}, {\"x\": 0.4531586132388156, \"y\": -0.33267577528589565, \"Class\": 0}, {\"x\": 0.014155839014434735, \"y\": 2.4057380021060357, \"Class\": 1}, {\"x\": -0.6209797023155086, \"y\": -0.4537523812416193, \"Class\": 0}, {\"x\": 0.8001528559058803, \"y\": 1.147309002011903, \"Class\": 0}, {\"x\": 0.7061888116045445, \"y\": 0.005043898069076926, \"Class\": 0}, {\"x\": 2.3728809703734113, \"y\": 0.7710822511106976, \"Class\": 1}, {\"x\": 0.9386034698816718, \"y\": -1.1466886495167958, \"Class\": 0}, {\"x\": -0.9041049314828216, \"y\": 0.7027533792191322, \"Class\": 0}, {\"x\": -0.10321862725194576, \"y\": -1.0790126956031663, \"Class\": 0}, {\"x\": -2.187115273247333, \"y\": 0.7219650574076287, \"Class\": 0}, {\"x\": 1.3503059959308692, \"y\": 2.0152208250443837, \"Class\": 0}, {\"x\": -0.5090008972919337, \"y\": 0.7718870234868406, \"Class\": 0}, {\"x\": 0.18070066767270676, \"y\": 2.2999911375745055, \"Class\": 1}, {\"x\": 2.453790011195825, \"y\": 1.363023132904219, \"Class\": 1}, {\"x\": 2.8140013785687983, \"y\": 2.1846723505590755, \"Class\": 1}, {\"x\": 1.360256947928347, \"y\": 2.015146597571547, \"Class\": 1}, {\"x\": 2.2460915770315415, \"y\": 2.7906135726951207, \"Class\": 1}, {\"x\": -1.6495595298995447, \"y\": 0.2754714469462586, \"Class\": 0}, {\"x\": 1.9008108222400648, \"y\": 1.1564180679309823, \"Class\": 1}, {\"x\": 2.664623054390154, \"y\": 4.004287815624176, \"Class\": 1}, {\"x\": -0.6871472120485602, \"y\": 1.8366742207237288, \"Class\": 0}, {\"x\": -0.34112117132031883, \"y\": 1.0898461110532707, \"Class\": 0}, {\"x\": -0.5778416564893406, \"y\": -0.8416715368715004, \"Class\": 0}, {\"x\": -0.31726597100271015, \"y\": 1.1383330474921514, \"Class\": 0}, {\"x\": -0.16224855290821893, \"y\": -1.0747468405930436, \"Class\": 0}, {\"x\": -0.7996871994715307, \"y\": -0.8446924471317016, \"Class\": 0}, {\"x\": 4.533515015693821, \"y\": 2.623685545416536, \"Class\": 1}, {\"x\": 0.35597848750624017, \"y\": 1.343515172028458, \"Class\": 1}, {\"x\": 1.4042924673121555, \"y\": 1.8165586817591046, \"Class\": 1}, {\"x\": 2.5540970339269764, \"y\": 2.4567176993334394, \"Class\": 1}, {\"x\": 0.8829763673845581, \"y\": 3.504528948312634, \"Class\": 1}, {\"x\": 1.9655603796185876, \"y\": 0.32512544079981365, \"Class\": 1}, {\"x\": -0.7209996734353815, \"y\": 0.5622617060581323, \"Class\": 0}, {\"x\": 2.039590841798837, \"y\": 3.4492266397277627, \"Class\": 1}, {\"x\": 0.44976720755395455, \"y\": -1.430396701578305, \"Class\": 0}, {\"x\": 1.7696665248700298, \"y\": 0.847425723606837, \"Class\": 1}, {\"x\": 2.184310481955429, \"y\": 2.502355940359632, \"Class\": 1}, {\"x\": 1.3501878997225267, \"y\": 0.8612113741693206, \"Class\": 0}, {\"x\": 1.9475261519089524, \"y\": 3.2034922322952664, \"Class\": 1}, {\"x\": 0.9031540597999508, \"y\": 2.484118419846157, \"Class\": 1}, {\"x\": 1.3852536804012796, \"y\": 1.7577995454226543, \"Class\": 1}, {\"x\": -1.0670398044692198, \"y\": -0.059260833836361, \"Class\": 0}, {\"x\": -0.19049578315740576, \"y\": 0.6722721224549026, \"Class\": 0}, {\"x\": 1.5606669550207917, \"y\": 1.7147110417443479, \"Class\": 1}, {\"x\": 3.7056421167090754, \"y\": 1.6251868522955508, \"Class\": 1}, {\"x\": -1.1205068713840005, \"y\": -0.3466067875476209, \"Class\": 0}, {\"x\": 0.7909698216528814, \"y\": -1.391766084294036, \"Class\": 0}, {\"x\": 0.6350869000947228, \"y\": -0.2688785015946833, \"Class\": 0}, {\"x\": -0.712390662050588, \"y\": 0.753766378659703, \"Class\": 0}, {\"x\": 2.7678507375866435, \"y\": 1.84486501727544, \"Class\": 1}, {\"x\": -0.13752826816152028, \"y\": -1.8003657016978516, \"Class\": 0}, {\"x\": 0.080866188394344, \"y\": -2.319847554388968, \"Class\": 0}, {\"x\": 0.4979639779852594, \"y\": 2.749678337984768, \"Class\": 1}, {\"x\": 2.1072911932669545, \"y\": 2.4347700117360502, \"Class\": 1}, {\"x\": 1.7496400449660001, \"y\": 1.8036383271590657, \"Class\": 1}, {\"x\": 2.692214884564876, \"y\": 1.187279706485618, \"Class\": 1}, {\"x\": 2.3071132822078066, \"y\": 0.9303479927054046, \"Class\": 1}, {\"x\": 0.4813399523048028, \"y\": 0.3080908624754918, \"Class\": 0}, {\"x\": 1.2022930609701978, \"y\": 2.3357265984452713, \"Class\": 1}, {\"x\": -0.15579970816999872, \"y\": -1.4634777566193453, \"Class\": 0}, {\"x\": -0.9626608287669728, \"y\": -0.7013680441849037, \"Class\": 0}, {\"x\": 0.7435452461317569, \"y\": -0.6625811650314397, \"Class\": 0}, {\"x\": 0.1406138453747909, \"y\": 0.019892207578106016, \"Class\": 0}, {\"x\": 1.7405406203764353, \"y\": 3.3756491396961157, \"Class\": 1}, {\"x\": 0.636539037502539, \"y\": 2.2014015005452823, \"Class\": 1}, {\"x\": 0.8624014081512591, \"y\": 0.5232452162507775, \"Class\": 0}, {\"x\": -0.025645745936127125, \"y\": -0.9590398006025731, \"Class\": 0}, {\"x\": -0.11723949907063196, \"y\": 1.100836264556602, \"Class\": 0}, {\"x\": 2.3927390062646094, \"y\": 0.18548973091234577, \"Class\": 1}, {\"x\": -0.19422133384463808, \"y\": 0.5877885293013254, \"Class\": 0}, {\"x\": -0.2918113875232261, \"y\": 0.12677274472597902, \"Class\": 0}, {\"x\": -1.3825474846365924, \"y\": 0.23254262542334578, \"Class\": 0}, {\"x\": 0.6558615323233493, \"y\": -0.22467908543381457, \"Class\": 0}, {\"x\": 3.870349907724047, \"y\": 3.1109274374798166, \"Class\": 1}, {\"x\": 0.9528306110451948, \"y\": -1.0871815907509188, \"Class\": 0}, {\"x\": -0.4371456556814915, \"y\": 0.5479183096073379, \"Class\": 0}, {\"x\": -0.16127395672832917, \"y\": 0.44951651436299817, \"Class\": 0}, {\"x\": 2.997813029717478, \"y\": 3.231244588814504, \"Class\": 1}, {\"x\": 2.2250075222163606, \"y\": 0.4688637055535052, \"Class\": 1}, {\"x\": 1.853407493274361, \"y\": 2.078487613593274, \"Class\": 1}, {\"x\": -0.7709685285300425, \"y\": -0.41395371382728313, \"Class\": 0}, {\"x\": 0.6129550677145995, \"y\": 0.23966318182680454, \"Class\": 0}, {\"x\": 2.3005952863784875, \"y\": 1.0472838605961088, \"Class\": 1}, {\"x\": 1.436570669708498, \"y\": -0.5795082893291696, \"Class\": 0}, {\"x\": -1.054657177172913, \"y\": -0.9776990052219913, \"Class\": 0}, {\"x\": 1.4798744615901476, \"y\": 1.7356680561833622, \"Class\": 1}, {\"x\": -1.9241594490929896, \"y\": -0.757453225587536, \"Class\": 0}, {\"x\": 2.1563577719221985, \"y\": 4.365673555946404, \"Class\": 1}, {\"x\": 0.7884285840121856, \"y\": 0.5685312896803145, \"Class\": 1}, {\"x\": 3.740933814341995, \"y\": -0.03556415619944708, \"Class\": 1}, {\"x\": 3.38509438533557, \"y\": 1.88933556101016, \"Class\": 1}, {\"x\": -2.4957528823141972, \"y\": 1.3043577797963937, \"Class\": 0}, {\"x\": 2.736058077736053, \"y\": 2.666016362052516, \"Class\": 1}, {\"x\": 1.592827313909267, \"y\": 3.621161963396762, \"Class\": 1}, {\"x\": 2.599269524155709, \"y\": 2.9696621383994226, \"Class\": 1}, {\"x\": 2.271330979002925, \"y\": 4.611365466501027, \"Class\": 1}, {\"x\": 1.2321130918482257, \"y\": 2.772256448671617, \"Class\": 1}, {\"x\": 4.199320450880061, \"y\": 2.7617220943402283, \"Class\": 1}, {\"x\": 4.438510067019951, \"y\": 1.9501456048622783, \"Class\": 1}, {\"x\": 0.9399792195744116, \"y\": 0.9506069961060607, \"Class\": 0}, {\"x\": 0.4403789105928676, \"y\": -0.8384801402483328, \"Class\": 0}, {\"x\": 1.8758843070900657, \"y\": 2.023663980551364, \"Class\": 1}, {\"x\": 1.227322247613268, \"y\": 2.7321707051874116, \"Class\": 1}, {\"x\": -0.3236790297502634, \"y\": -0.11145904212515595, \"Class\": 0}, {\"x\": 2.3338773158710833, \"y\": 2.173174617420775, \"Class\": 1}, {\"x\": 1.3896197630118723, \"y\": 1.8389429159103785, \"Class\": 1}, {\"x\": 1.2655617879171142, \"y\": 1.326472834693644, \"Class\": 1}, {\"x\": 2.6494568961145273, \"y\": 2.034031096576255, \"Class\": 1}, {\"x\": 2.0541840739491852, \"y\": 2.6806681362126463, \"Class\": 1}, {\"x\": 0.47518769779384906, \"y\": -0.07236315822392445, \"Class\": 0}, {\"x\": 1.556495068521696, \"y\": 0.7868004452776833, \"Class\": 1}, {\"x\": 2.4151904657340686, \"y\": 1.3817176162952216, \"Class\": 1}, {\"x\": 2.230402823356569, \"y\": 2.431946895391424, \"Class\": 1}, {\"x\": 0.337447649965678, \"y\": 3.190858387393793, \"Class\": 1}, {\"x\": 1.194687665488288, \"y\": 1.1558162413648083, \"Class\": 1}, {\"x\": -0.34921913811594835, \"y\": 0.843842055045005, \"Class\": 0}, {\"x\": 1.4207461108249517, \"y\": 2.576007496726984, \"Class\": 1}, {\"x\": 0.15647674659188437, \"y\": 0.20425480457441636, \"Class\": 0}, {\"x\": -0.911344781357355, \"y\": -0.7461352526666984, \"Class\": 0}, {\"x\": -0.0012405611429540924, \"y\": 0.08134367638997905, \"Class\": 0}, {\"x\": -0.1522965744944709, \"y\": 0.704626894626221, \"Class\": 0}, {\"x\": 3.178170580363296, \"y\": 1.7109649913220648, \"Class\": 1}, {\"x\": 0.2532205247585785, \"y\": 0.9407870683897978, \"Class\": 0}, {\"x\": 1.1790347434852069, \"y\": -1.0760914658121563, \"Class\": 0}, {\"x\": 0.18494595039221876, \"y\": -0.6510564789536804, \"Class\": 0}, {\"x\": 0.4076688308069256, \"y\": 2.32353471469165, \"Class\": 1}, {\"x\": 1.9642845933830628, \"y\": 3.0039302837615773, \"Class\": 1}, {\"x\": 1.4028588731444431, \"y\": 1.6045726106064209, \"Class\": 1}, {\"x\": 0.8893585338418935, \"y\": 3.717926200674824, \"Class\": 1}, {\"x\": 0.6367185907707327, \"y\": 1.6782942647037324, \"Class\": 1}, {\"x\": -1.0669628403806435, \"y\": 3.4011057189806557, \"Class\": 0}, {\"x\": 0.2673819755787573, \"y\": -1.0319348271510602, \"Class\": 0}, {\"x\": -1.7207954551375861, \"y\": 0.017982138806439393, \"Class\": 0}, {\"x\": 1.4267264504853654, \"y\": -0.048697610640109204, \"Class\": 0}, {\"x\": -0.057532387873538586, \"y\": 0.5646542880869975, \"Class\": 0}, {\"x\": 1.1950253748410917, \"y\": -1.4615058094923734, \"Class\": 0}, {\"x\": 3.068200909048942, \"y\": 3.9006478804863063, \"Class\": 1}, {\"x\": 0.7304710721169607, \"y\": 0.8996130611234683, \"Class\": 1}, {\"x\": 3.0082325821645153, \"y\": 1.1312706815969824, \"Class\": 1}, {\"x\": 4.208480738141941, \"y\": 2.5871061449468176, \"Class\": 1}, {\"x\": 1.3992384201681904, \"y\": -1.6151079632521659, \"Class\": 0}, {\"x\": 0.36003178759974036, \"y\": -0.43820143730669325, \"Class\": 0}, {\"x\": 2.5915110533990484, \"y\": -0.27102844335797016, \"Class\": 1}, {\"x\": 1.3204048067975092, \"y\": 0.04066528515761626, \"Class\": 0}, {\"x\": 0.4394946907472934, \"y\": 1.7672366043893282, \"Class\": 1}, {\"x\": 0.8486534061441413, \"y\": 1.4169071306933088, \"Class\": 1}, {\"x\": 0.9734403648680088, \"y\": 0.9335892631796991, \"Class\": 1}, {\"x\": -0.9738381295272108, \"y\": 0.8048850955179162, \"Class\": 0}, {\"x\": -0.7640339696578627, \"y\": 0.1012697856437548, \"Class\": 0}, {\"x\": 2.8617222068747257, \"y\": 3.849776385866146, \"Class\": 1}, {\"x\": 0.45053117920927527, \"y\": -0.49429864739786794, \"Class\": 0}, {\"x\": -0.7046047621786199, \"y\": 0.4553185270261121, \"Class\": 0}, {\"x\": 0.1486981280629037, \"y\": 1.4460230634069287, \"Class\": 0}, {\"x\": -1.41124263188717, \"y\": 1.2047437309657716, \"Class\": 0}, {\"x\": 0.4820872038580639, \"y\": 3.3317589492355393, \"Class\": 1}, {\"x\": 0.20156945957526934, \"y\": -0.1650355232064671, \"Class\": 0}, {\"x\": -0.14908830964479858, \"y\": 1.8005179738889225, \"Class\": 1}, {\"x\": 1.7941257462609899, \"y\": 1.0823176653816473, \"Class\": 1}, {\"x\": 1.9434940241593952, \"y\": 1.862979444034073, \"Class\": 1}, {\"x\": -0.4192603220087837, \"y\": 2.386745800499031, \"Class\": 0}, {\"x\": 1.5794502314089767, \"y\": 0.8872219039413722, \"Class\": 1}, {\"x\": -0.5534026175135522, \"y\": -0.24150531238917375, \"Class\": 0}, {\"x\": -1.01700202554413, \"y\": -0.5269892532991041, \"Class\": 0}, {\"x\": -1.9453906815188249, \"y\": 0.8309056578021413, \"Class\": 0}, {\"x\": -0.28410380510716565, \"y\": 0.15003366373872756, \"Class\": 0}, {\"x\": 1.9649289132456702, \"y\": 2.321508194455287, \"Class\": 1}, {\"x\": 0.9000849971172967, \"y\": 0.8890323725239309, \"Class\": 0}, {\"x\": -0.644619180730499, \"y\": -1.1702444249284003, \"Class\": 0}, {\"x\": 3.0737033225195978, \"y\": 2.9818520300440294, \"Class\": 1}, {\"x\": 0.2614395928205015, \"y\": 0.46893464927171374, \"Class\": 0}, {\"x\": -0.8444764142538497, \"y\": -0.5164428497021851, \"Class\": 0}, {\"x\": 1.3116180465656415, \"y\": -1.2548603914775587, \"Class\": 0}, {\"x\": -0.5334945027167617, \"y\": -1.9323560015091858, \"Class\": 0}, {\"x\": 1.1384956408918423, \"y\": 1.1258379535900915, \"Class\": 1}, {\"x\": 1.4786857374358966, \"y\": -1.0453771305385342, \"Class\": 0}, {\"x\": 0.7085245177855963, \"y\": -0.9824603525381572, \"Class\": 0}, {\"x\": -1.8552666603782968, \"y\": -0.11032172211623395, \"Class\": 0}, {\"x\": 0.015174920002897885, \"y\": 0.117052488790469, \"Class\": 0}, {\"x\": 1.3823109341357713, \"y\": 1.3211814156031616, \"Class\": 1}, {\"x\": -1.055658897711565, \"y\": -0.308375994286531, \"Class\": 0}, {\"x\": 0.3650517980270081, \"y\": -0.04520588860236072, \"Class\": 0}, {\"x\": 2.6125269393847117, \"y\": 3.085007239316771, \"Class\": 1}, {\"x\": 3.3363234842354315, \"y\": 1.605563899655047, \"Class\": 1}, {\"x\": -0.6779772552780428, \"y\": 0.1106188085540423, \"Class\": 0}, {\"x\": -0.5361687068333683, \"y\": -2.6939563172399312, \"Class\": 0}, {\"x\": -0.7889890249515489, \"y\": -1.261605945319069, \"Class\": 0}, {\"x\": -0.38445768500357647, \"y\": -0.530327407582726, \"Class\": 0}, {\"x\": 0.41730231988738953, \"y\": 0.26955855330903167, \"Class\": 0}, {\"x\": -0.7320583853311774, \"y\": 0.5751509658063075, \"Class\": 0}, {\"x\": 2.226690771658064, \"y\": 2.311882011998303, \"Class\": 1}, {\"x\": -0.19163168438548278, \"y\": 0.4838288394495532, \"Class\": 0}, {\"x\": 1.9680077421958235, \"y\": 3.0527207346654532, \"Class\": 1}, {\"x\": -1.81842142065901, \"y\": 0.05569219339294779, \"Class\": 0}, {\"x\": 2.4473251505619094, \"y\": 1.1594630002615673, \"Class\": 1}, {\"x\": 1.8050515828561202, \"y\": 1.6736370209291347, \"Class\": 1}, {\"x\": 1.214463504631698, \"y\": 2.034938838643822, \"Class\": 1}, {\"x\": 1.8351757766163321, \"y\": 1.7021931993107415, \"Class\": 1}, {\"x\": 3.325466891523719, \"y\": 3.3007610258555466, \"Class\": 1}, {\"x\": 0.44080738731842145, \"y\": -1.812024553173441, \"Class\": 0}, {\"x\": 0.6070648197036337, \"y\": 2.3086244961655735, \"Class\": 1}, {\"x\": -2.3269262116155196, \"y\": -0.4158113660344991, \"Class\": 0}, {\"x\": -0.4654414831035872, \"y\": 0.4004773841168456, \"Class\": 0}, {\"x\": 1.0784289197973278, \"y\": 2.3187895017249587, \"Class\": 1}, {\"x\": 2.428214351090788, \"y\": 2.229010774428565, \"Class\": 1}, {\"x\": 2.300842716403956, \"y\": 2.1974559832484015, \"Class\": 1}, {\"x\": -0.19651664300377936, \"y\": -0.2648908941443411, \"Class\": 0}, {\"x\": 1.6069637071946876, \"y\": 1.429133723362852, \"Class\": 1}, {\"x\": -0.8732591793851744, \"y\": 0.5560180812944249, \"Class\": 0}, {\"x\": 3.853505633543313, \"y\": 3.1507460321250718, \"Class\": 1}, {\"x\": 0.12730328020698067, \"y\": 2.1503829673811126, \"Class\": 0}, {\"x\": 0.35953229551797367, \"y\": -0.511965094194221, \"Class\": 0}, {\"x\": 3.4465143940508334, \"y\": 5.101863538312319, \"Class\": 1}, {\"x\": 0.8579051809684236, \"y\": 0.40976548500449694, \"Class\": 0}, {\"x\": 0.37467317185190585, \"y\": 3.15456589083811, \"Class\": 1}, {\"x\": 1.3406793435446662, \"y\": 1.466546252991804, \"Class\": 1}, {\"x\": 1.4609918659634333, \"y\": 2.0542065312864928, \"Class\": 1}, {\"x\": 0.7420478267454842, \"y\": 1.1114411280385852, \"Class\": 0}, {\"x\": -0.41998581004543123, \"y\": -0.0285337341330573, \"Class\": 0}, {\"x\": 1.8462176390292164, \"y\": 1.0886226105354244, \"Class\": 1}, {\"x\": 0.48039822370628693, \"y\": 2.669508434914504, \"Class\": 1}, {\"x\": -0.5465767417188724, \"y\": 0.29202648981800744, \"Class\": 0}, {\"x\": 0.9962094669993536, \"y\": -0.04995254339686802, \"Class\": 0}, {\"x\": 0.8971332024654173, \"y\": 1.544007515956213, \"Class\": 1}, {\"x\": 2.506356748813186, \"y\": 2.016462481587103, \"Class\": 1}, {\"x\": 0.7133254192320697, \"y\": -0.9466364609859, \"Class\": 0}, {\"x\": 1.2040703250429852, \"y\": 1.3470353682509972, \"Class\": 1}, {\"x\": -1.0526677980507988, \"y\": -0.5586105579100125, \"Class\": 0}, {\"x\": -0.44151223119024857, \"y\": 0.9552466924396553, \"Class\": 0}, {\"x\": 1.6399277115282798, \"y\": 1.5146525907585886, \"Class\": 1}, {\"x\": -1.469634625209567, \"y\": -0.1463693097462854, \"Class\": 0}, {\"x\": 1.0525318150652148, \"y\": -1.5340965702283584, \"Class\": 0}, {\"x\": -1.639093411201915, \"y\": -0.27813451650877447, \"Class\": 0}, {\"x\": 2.135946763233126, \"y\": 2.247660788661511, \"Class\": 1}, {\"x\": 3.8522909678430186, \"y\": 2.3281097780522138, \"Class\": 1}, {\"x\": 3.3594580312665707, \"y\": 1.3844667369168193, \"Class\": 1}, {\"x\": 1.5892922570199843, \"y\": 4.30578448459959, \"Class\": 1}, {\"x\": -2.233052848438117, \"y\": 0.14202678794857176, \"Class\": 0}, {\"x\": 2.429672594447642, \"y\": 2.042853859669679, \"Class\": 1}, {\"x\": 0.9728507916505504, \"y\": 2.6075086014714084, \"Class\": 1}, {\"x\": 2.842312886127444, \"y\": 1.3091502290657346, \"Class\": 1}, {\"x\": -0.06434314961587694, \"y\": 0.7387144235342626, \"Class\": 0}, {\"x\": 0.3487505938690223, \"y\": -0.3386182541020083, \"Class\": 0}, {\"x\": 3.0222386729565907, \"y\": 3.4916874624264516, \"Class\": 1}, {\"x\": -0.45896716822932365, \"y\": 1.1515287731761275, \"Class\": 0}, {\"x\": 0.23082017281823, \"y\": 0.5467579110457865, \"Class\": 0}, {\"x\": 0.6062886568962988, \"y\": -0.026771649986440726, \"Class\": 0}, {\"x\": -0.5956856051072797, \"y\": 0.7958769911591804, \"Class\": 0}, {\"x\": 2.115737227318506, \"y\": 0.36735386905122724, \"Class\": 1}, {\"x\": -0.2642474112620271, \"y\": -0.9323592637202481, \"Class\": 0}, {\"x\": -1.6003841181528236, \"y\": -0.22205672759554324, \"Class\": 0}, {\"x\": 1.3303169236725105, \"y\": -0.6575172676978901, \"Class\": 0}, {\"x\": 3.1000197097589526, \"y\": 4.801153155014196, \"Class\": 1}, {\"x\": -0.928335225810039, \"y\": -0.7746600331288077, \"Class\": 0}, {\"x\": 2.8223656402267268, \"y\": 3.4418656691638247, \"Class\": 1}, {\"x\": 0.946348007431648, \"y\": 0.39254793773535773, \"Class\": 0}, {\"x\": 1.2690580976875576, \"y\": 0.2572490050399525, \"Class\": 0}, {\"x\": 2.032226881139099, \"y\": 4.567122577428944, \"Class\": 1}, {\"x\": -1.220671903715444, \"y\": -0.565046518309226, \"Class\": 0}, {\"x\": 1.1621877051255987, \"y\": 2.8309427428150205, \"Class\": 1}, {\"x\": 1.985355394382256, \"y\": 0.5389091609733734, \"Class\": 1}, {\"x\": 0.9137407048596775, \"y\": 0.31735092273633597, \"Class\": 0}, {\"x\": 3.147812051000587, \"y\": 1.154813468270937, \"Class\": 1}, {\"x\": 1.3978022435984774, \"y\": 1.8396679985237319, \"Class\": 1}, {\"x\": -1.5120214739877849, \"y\": 0.4446977161029871, \"Class\": 0}, {\"x\": 0.1549035962020594, \"y\": 0.277836156413196, \"Class\": 0}, {\"x\": 2.360380445279691, \"y\": 3.368154875156878, \"Class\": 1}, {\"x\": 0.11163027156564224, \"y\": 0.2829905076675621, \"Class\": 0}, {\"x\": 0.1687210624313978, \"y\": -1.4889501692875957, \"Class\": 0}, {\"x\": 0.9118946811654338, \"y\": 2.551469174853076, \"Class\": 1}, {\"x\": 0.747371595544824, \"y\": 1.075681534164297, \"Class\": 0}, {\"x\": 1.2571257313814808, \"y\": 0.18248209713031777, \"Class\": 0}, {\"x\": -0.7574771053093196, \"y\": -0.5108262341824535, \"Class\": 0}, {\"x\": -0.16240072992892313, \"y\": 1.3391315836256719, \"Class\": 0}, {\"x\": 1.0712974056744988, \"y\": 2.124654858947829, \"Class\": 1}, {\"x\": -0.018421809137576996, \"y\": 0.10767464455391365, \"Class\": 0}, {\"x\": 0.5467334374800554, \"y\": 0.750423475071857, \"Class\": 1}, {\"x\": -0.19380492240705713, \"y\": 1.5666402273744786, \"Class\": 0}, {\"x\": 2.3104323874656347, \"y\": 0.22399592783418343, \"Class\": 1}, {\"x\": 0.45348104026746144, \"y\": 0.9223441482568703, \"Class\": 0}, {\"x\": 2.2487456886625603, \"y\": 1.7232575132248926, \"Class\": 1}, {\"x\": -0.33240947257420594, \"y\": 2.0921686012929617, \"Class\": 0}, {\"x\": 0.9929491259546886, \"y\": -0.6437970571220203, \"Class\": 0}, {\"x\": 0.2676098967321498, \"y\": 0.8784598910238555, \"Class\": 0}, {\"x\": 0.9450577461588743, \"y\": 1.8378156974976747, \"Class\": 1}, {\"x\": 0.7571112741306737, \"y\": -1.2085723310812708, \"Class\": 0}, {\"x\": 2.095520834264214, \"y\": 2.3200664601730594, \"Class\": 1}, {\"x\": 0.5253295997343811, \"y\": -1.2768778466596493, \"Class\": 0}, {\"x\": 0.7419006788952703, \"y\": -0.3519968223496652, \"Class\": 0}, {\"x\": -0.044503078338053455, \"y\": 0.45181233874578974, \"Class\": 0}, {\"x\": -0.7068190812919728, \"y\": -0.6861465851073458, \"Class\": 0}, {\"x\": -1.7385178655572635, \"y\": 0.5704933453211514, \"Class\": 0}, {\"x\": 2.998899886332779, \"y\": 0.634248698991208, \"Class\": 1}, {\"x\": 0.15420459268584072, \"y\": 0.8173055190310792, \"Class\": 0}, {\"x\": -1.9774177085108056, \"y\": 2.2386487591829325, \"Class\": 0}, {\"x\": 1.5013438169373443, \"y\": 1.6045531391802799, \"Class\": 1}, {\"x\": -0.2324258720274623, \"y\": 0.7109747948581455, \"Class\": 0}, {\"x\": 2.0551775521900577, \"y\": 2.4190681047807843, \"Class\": 1}, {\"x\": -1.6642564360602479, \"y\": -0.1217464334245328, \"Class\": 0}, {\"x\": -0.23181317888607783, \"y\": -0.1165749870881772, \"Class\": 0}, {\"x\": 3.415864945921144, \"y\": 0.5329883064330754, \"Class\": 1}, {\"x\": -0.407616632784632, \"y\": -0.668307894421939, \"Class\": 0}, {\"x\": 1.7477370760676236, \"y\": 1.20634705787289, \"Class\": 1}, {\"x\": 1.2751258373944747, \"y\": 0.4609946505605043, \"Class\": 0}, {\"x\": 0.31244125715700677, \"y\": 0.21920844617560786, \"Class\": 1}, {\"x\": 0.20522091485414617, \"y\": -0.045963992111946794, \"Class\": 1}, {\"x\": 1.4063603231723563, \"y\": 2.9410600435834002, \"Class\": 1}, {\"x\": 0.5628467852810314, \"y\": -0.24332625188556253, \"Class\": 0}, {\"x\": 0.5011676877836018, \"y\": 0.9199851312920041, \"Class\": 0}, {\"x\": 0.017446916303085782, \"y\": -0.7200583582807348, \"Class\": 0}, {\"x\": -0.3848490502028002, \"y\": -1.5509569211976624, \"Class\": 0}, {\"x\": 2.5005989239578374, \"y\": 1.6544858315564697, \"Class\": 1}, {\"x\": 2.208494645965929, \"y\": 0.9483154856821232, \"Class\": 1}, {\"x\": -0.5351833981652417, \"y\": 0.8683775099508642, \"Class\": 0}, {\"x\": -0.8541429534648363, \"y\": 0.46565797200403236, \"Class\": 0}, {\"x\": 2.5920840674002923, \"y\": 0.37476811336909965, \"Class\": 0}, {\"x\": 3.0388537536498363, \"y\": 1.1822453985407702, \"Class\": 1}, {\"x\": 2.0709735272198517, \"y\": 1.7885843905817853, \"Class\": 1}, {\"x\": 0.35021313455542263, \"y\": 0.47347563519013397, \"Class\": 0}, {\"x\": 0.8917941660323877, \"y\": -1.5390641198540729, \"Class\": 0}, {\"x\": -0.1452113325860197, \"y\": 0.23785783828501061, \"Class\": 0}, {\"x\": -2.2068670954994913, \"y\": -0.4031289968469349, \"Class\": 0}, {\"x\": -0.6359031894503993, \"y\": 0.1997790971313106, \"Class\": 0}, {\"x\": 2.9898112579100316, \"y\": 2.8909152648111034, \"Class\": 1}, {\"x\": -0.01335974789092953, \"y\": 1.2355527522919023, \"Class\": 1}, {\"x\": -0.5083432327925071, \"y\": -0.6862364377992013, \"Class\": 0}, {\"x\": 0.6398839732802036, \"y\": 2.0536932362953815, \"Class\": 0}, {\"x\": 2.5461421558243416, \"y\": 1.2625939497950327, \"Class\": 1}, {\"x\": 1.3052737165412949, \"y\": 4.091883216971763, \"Class\": 1}, {\"x\": 0.9901299572529987, \"y\": 2.0749485504359404, \"Class\": 1}, {\"x\": 0.38411581154380325, \"y\": 1.4122345812397805, \"Class\": 1}, {\"x\": 3.0697263031814166, \"y\": -0.2804598261590847, \"Class\": 1}, {\"x\": 0.35136152893488404, \"y\": 0.788570479116926, \"Class\": 0}, {\"x\": 0.7659110492252689, \"y\": 0.20780005335113885, \"Class\": 0}, {\"x\": 2.2009639538279697, \"y\": 1.272294725099329, \"Class\": 1}, {\"x\": 3.7868569004388535, \"y\": 1.6714447664628662, \"Class\": 1}, {\"x\": 1.6961871140730036, \"y\": 2.699506870262244, \"Class\": 1}, {\"x\": 0.542544026931158, \"y\": 0.6261672937955176, \"Class\": 0}, {\"x\": -0.557684623006479, \"y\": -0.9570655488171265, \"Class\": 0}, {\"x\": 2.1800817394030765, \"y\": 0.37012151528707427, \"Class\": 1}, {\"x\": 2.0854556487772595, \"y\": 3.136275128464981, \"Class\": 1}, {\"x\": 2.3056068400458085, \"y\": 2.3978884495586614, \"Class\": 1}, {\"x\": 2.170329118452739, \"y\": -0.0334652980293213, \"Class\": 1}, {\"x\": -1.0942595125916925, \"y\": 1.982925182595953, \"Class\": 0}, {\"x\": 0.3532107803002698, \"y\": -0.8912937922772961, \"Class\": 0}, {\"x\": 1.3149422380864075, \"y\": 1.8490054305793169, \"Class\": 1}, {\"x\": 0.49223250052885703, \"y\": 1.7253989475688583, \"Class\": 1}, {\"x\": 2.009512655017796, \"y\": 3.5201334154397417, \"Class\": 1}, {\"x\": 1.9980452901555539, \"y\": 2.303724390568587, \"Class\": 1}, {\"x\": 2.5723636214743255, \"y\": 0.7736503599904248, \"Class\": 1}, {\"x\": 1.4844656543417931, \"y\": 2.992559756677755, \"Class\": 1}, {\"x\": 1.9917624296046446, \"y\": 1.679432402454359, \"Class\": 1}, {\"x\": 2.855678786912586, \"y\": 2.292225674252774, \"Class\": 1}, {\"x\": 3.683495929813405, \"y\": 1.3855166043567386, \"Class\": 1}, {\"x\": 1.186979048375644, \"y\": 2.797672569082689, \"Class\": 1}, {\"x\": -1.4141544662915098, \"y\": 0.12673002941390707, \"Class\": 0}, {\"x\": -1.0259108732843625, \"y\": 0.20581615250656984, \"Class\": 0}, {\"x\": 1.7712398465971424, \"y\": 1.481672243119422, \"Class\": 1}, {\"x\": 0.29164051076463826, \"y\": -0.3896555250433101, \"Class\": 0}, {\"x\": 2.7668504972793944, \"y\": 1.5704062429021668, \"Class\": 1}, {\"x\": 1.4739316414007817, \"y\": 2.1693502758148995, \"Class\": 1}, {\"x\": 1.3451017084510097, \"y\": 0.5323378882945463, \"Class\": 0}, {\"x\": 2.202473172070938, \"y\": 1.1927704745729666, \"Class\": 1}, {\"x\": 0.1364330425598168, \"y\": 1.6547766001068898, \"Class\": 1}, {\"x\": 3.7281893840230502, \"y\": 1.1457280642521839, \"Class\": 1}, {\"x\": -0.9841607817725814, \"y\": 1.190705272505982, \"Class\": 0}, {\"x\": 3.052333378588207, \"y\": 1.5469353257425968, \"Class\": 1}, {\"x\": 1.1757285420219539, \"y\": 0.7078651140198504, \"Class\": 1}, {\"x\": 1.8188436537188366, \"y\": -0.0552061713027614, \"Class\": 1}, {\"x\": 3.7848212310913274, \"y\": 1.8713978097811776, \"Class\": 1}, {\"x\": -1.1527257504517598, \"y\": -0.913446285204153, \"Class\": 0}, {\"x\": 1.8260275987189714, \"y\": 0.6650746330128983, \"Class\": 1}, {\"x\": 0.2283352044566521, \"y\": -0.6753750576188053, \"Class\": 0}, {\"x\": 2.4276671452734377, \"y\": 1.793206065362875, \"Class\": 1}, {\"x\": 2.7702785657932285, \"y\": 0.6327607703571645, \"Class\": 1}, {\"x\": 0.9630313786660784, \"y\": -1.9278777352364316, \"Class\": 0}, {\"x\": -0.6191847305942658, \"y\": 1.2125948226530212, \"Class\": 0}, {\"x\": -0.08809626952746996, \"y\": -0.36184796336959735, \"Class\": 0}, {\"x\": 3.723386352013055, \"y\": 0.5734760719351109, \"Class\": 1}, {\"x\": -1.0835914658230943, \"y\": -0.0001493927548569246, \"Class\": 0}, {\"x\": 2.7546480021839517, \"y\": 0.8294406857458252, \"Class\": 1}, {\"x\": 3.548200204010281, \"y\": 1.4076847120803713, \"Class\": 1}, {\"x\": 2.2625682294037417, \"y\": 2.396449917961715, \"Class\": 1}, {\"x\": 1.6380195259704862, \"y\": 2.5114604025401603, \"Class\": 1}, {\"x\": 0.5022857779517222, \"y\": 0.839193535320577, \"Class\": 0}, {\"x\": 2.53313595254121, \"y\": 1.7073139503965051, \"Class\": 1}, {\"x\": -0.5231642148972904, \"y\": -0.48137141579474935, \"Class\": 0}, {\"x\": 1.9906249118224364, \"y\": 0.16605400369245205, \"Class\": 1}, {\"x\": 1.2144508157368235, \"y\": 1.9506801724468557, \"Class\": 1}, {\"x\": 2.534649634454772, \"y\": 0.1469932950896291, \"Class\": 1}, {\"x\": -0.3221236569774085, \"y\": -0.37011607810475444, \"Class\": 0}, {\"x\": 2.7531069136156465, \"y\": 1.4426703238756096, \"Class\": 1}, {\"x\": 1.842865943529341, \"y\": 1.9075822293664888, \"Class\": 1}, {\"x\": 0.8149954430712237, \"y\": -1.185418809153406, \"Class\": 0}, {\"x\": 0.21745165945019368, \"y\": 0.5143288551447859, \"Class\": 0}, {\"x\": 0.35033088498361975, \"y\": 1.8004397115563828, \"Class\": 1}, {\"x\": 1.0942750991001489, \"y\": 0.004613901175436712, \"Class\": 0}, {\"x\": -0.5338435604421259, \"y\": -0.07115124422410989, \"Class\": 0}, {\"x\": -0.4979713554723796, \"y\": 0.9384604688575977, \"Class\": 0}, {\"x\": 1.0172414890962727, \"y\": 0.5529783472619647, \"Class\": 1}, {\"x\": 0.489805675723485, \"y\": 1.3007227251380344, \"Class\": 1}, {\"x\": -0.3148580761325759, \"y\": -0.42989708186880404, \"Class\": 0}, {\"x\": 4.221653853655571, \"y\": 1.8180194889356027, \"Class\": 1}, {\"x\": 3.4145035166500803, \"y\": 1.4537352027795598, \"Class\": 1}, {\"x\": 0.07299114797407072, \"y\": -0.24006071463865328, \"Class\": 0}, {\"x\": -0.9802743185258672, \"y\": -0.002389025600514556, \"Class\": 0}, {\"x\": 1.9176476860844183, \"y\": 0.8990088769612876, \"Class\": 1}, {\"x\": -0.15170019141369395, \"y\": -1.2368377011017966, \"Class\": 0}, {\"x\": 0.9995238627794718, \"y\": 0.33912166991349607, \"Class\": 0}, {\"x\": 2.7971698357380883, \"y\": 0.4284961677589696, \"Class\": 1}, {\"x\": 0.3303022703226134, \"y\": 1.2795087343766578, \"Class\": 0}, {\"x\": 0.6793203874098627, \"y\": 2.4897075316883863, \"Class\": 0}, {\"x\": 3.1801316897135203, \"y\": -0.0025192964192513045, \"Class\": 1}, {\"x\": 0.49087183250951594, \"y\": 1.8927422187767202, \"Class\": 0}, {\"x\": 2.823953492083943, \"y\": 1.8754466148450735, \"Class\": 1}, {\"x\": 0.40865864630465626, \"y\": -0.8677998149261569, \"Class\": 0}, {\"x\": 0.7998766732572836, \"y\": 0.6790266830356967, \"Class\": 0}, {\"x\": 3.16457816375343, \"y\": 2.5299278264194656, \"Class\": 1}, {\"x\": 3.0824789636044114, \"y\": 4.966250097193541, \"Class\": 1}, {\"x\": 1.1722774270578469, \"y\": 1.1490631884147902, \"Class\": 0}, {\"x\": 1.0369968080399357, \"y\": -1.3189645536049885, \"Class\": 0}, {\"x\": 3.7280110563709856, \"y\": 3.6421336258852905, \"Class\": 1}, {\"x\": 0.6386749234055078, \"y\": 0.17851926932176165, \"Class\": 1}, {\"x\": -0.7686270207784495, \"y\": 0.7291654706806434, \"Class\": 0}, {\"x\": 0.4006736681660438, \"y\": -0.764593898622952, \"Class\": 0}, {\"x\": 4.503354046947538, \"y\": 2.838073066693751, \"Class\": 1}, {\"x\": 2.9113751643607433, \"y\": 2.1412893173639698, \"Class\": 1}, {\"x\": 3.294056296712104, \"y\": -0.36469608065789894, \"Class\": 1}, {\"x\": 0.31287871866605876, \"y\": 0.13679032249522113, \"Class\": 0}, {\"x\": 0.5319765561553507, \"y\": -1.3703642428009506, \"Class\": 0}, {\"x\": 0.8672126651998152, \"y\": -0.5209590207114089, \"Class\": 0}, {\"x\": -0.5136792046662925, \"y\": -1.257253734973249, \"Class\": 0}, {\"x\": 2.7212519457943585, \"y\": 0.050249003899367484, \"Class\": 1}, {\"x\": 0.3972413264075336, \"y\": -1.5128451152607716, \"Class\": 0}, {\"x\": 2.531723565932997, \"y\": 2.239581604376858, \"Class\": 1}, {\"x\": -1.830354023073999, \"y\": 0.6019355688249879, \"Class\": 0}, {\"x\": 1.9452558917173377, \"y\": 0.3598283935608044, \"Class\": 1}, {\"x\": 0.7622308225590424, \"y\": -0.25251758817880776, \"Class\": 0}, {\"x\": 1.4977015999604872, \"y\": 0.6446988633003452, \"Class\": 1}, {\"x\": 0.6598257388547495, \"y\": 3.6128983277731725, \"Class\": 1}, {\"x\": 2.0945008750379053, \"y\": 1.267184830290836, \"Class\": 1}, {\"x\": 1.717175959710519, \"y\": 0.7778483925521874, \"Class\": 0}, {\"x\": 2.328566455889293, \"y\": 0.7208853070121146, \"Class\": 1}, {\"x\": 2.921435479755555, \"y\": 1.7071197902880657, \"Class\": 1}, {\"x\": -3.210430797268423, \"y\": 0.4777660895774647, \"Class\": 0}, {\"x\": 1.564791953399383, \"y\": 2.3255322669728162, \"Class\": 1}, {\"x\": 1.0441306350285604, \"y\": 2.1003552832079437, \"Class\": 1}, {\"x\": 1.4992193438668884, \"y\": 4.04414288098479, \"Class\": 1}, {\"x\": 1.749241790081012, \"y\": 0.5011372949374676, \"Class\": 0}, {\"x\": 3.3974402689876415, \"y\": 2.5031037927644775, \"Class\": 1}, {\"x\": 2.379428273695179, \"y\": 2.3775040758320616, \"Class\": 1}, {\"x\": 2.836948426757939, \"y\": 1.1309460946801244, \"Class\": 1}, {\"x\": 0.4349760219816502, \"y\": 0.7588944642911625, \"Class\": 0}, {\"x\": 0.3902203816463774, \"y\": 3.4041647200248475, \"Class\": 1}, {\"x\": 1.1097851050648244, \"y\": 2.856810097997084, \"Class\": 1}, {\"x\": -0.882490391596822, \"y\": -0.6606324986051187, \"Class\": 0}, {\"x\": -0.3051810275934747, \"y\": 0.041447402165011596, \"Class\": 0}, {\"x\": 2.7287649446028355, \"y\": 0.6998183159944318, \"Class\": 1}, {\"x\": -2.236053777261358, \"y\": 0.5833276501518617, \"Class\": 0}, {\"x\": 0.7547050088790299, \"y\": -0.7598847788231394, \"Class\": 0}, {\"x\": -1.247336156644393, \"y\": 0.31717096074155054, \"Class\": 0}, {\"x\": 3.3984769733544002, \"y\": 1.787254142967087, \"Class\": 1}, {\"x\": -0.0051374179562285, \"y\": -0.15956287406705108, \"Class\": 0}, {\"x\": 0.6353546579819151, \"y\": 1.8771104516000663, \"Class\": 1}, {\"x\": 0.5451054177509091, \"y\": 1.3168720121050563, \"Class\": 1}, {\"x\": 0.6586660668217251, \"y\": 1.0461644964376338, \"Class\": 0}, {\"x\": 1.6601644225247327, \"y\": 1.1558746731720393, \"Class\": 1}, {\"x\": 0.6609032917196628, \"y\": 0.8224723016354284, \"Class\": 0}, {\"x\": -0.8135337616981977, \"y\": -0.935955221598663, \"Class\": 0}, {\"x\": -0.030667987475674858, \"y\": -0.8814625655313383, \"Class\": 0}]}}, {\"mode\": \"vega-lite\"});\n",
       "</script>"
      ],
      "text/plain": [
       "alt.Chart(...)"
      ]
     },
     "execution_count": 7,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "df_true = pd.DataFrame(X, columns=[\"x\",\"y\"])\n",
    "df_true[\"Class\"] = y\n",
    "alt.Chart(df_true).mark_circle().encode(\n",
    "    x=\"x\",\n",
    "    y=\"y\",\n",
    "    color=\"Class:N\"\n",
    ").properties(\n",
    "    title=\"True values\"\n",
    ")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "cell_id": "b6d464dd537e44c49ae9287e609b9d8a",
    "deepnote_cell_type": "markdown",
    "tags": []
   },
   "source": [
    "Here is a helper function that can plot predictions for us."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "metadata": {
    "cell_id": "bb33c31435cc40e58025f5fa2466255d",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 4,
    "execution_start": 1669053980865,
    "source_hash": "584e8b4",
    "tags": []
   },
   "outputs": [],
   "source": [
    "# clf should already be fit before calling this function\n",
    "def make_chart(clf, X):\n",
    "    outputs = clf.predict(X)\n",
    "    df = pd.DataFrame(X, columns=[\"x\", \"y\"])\n",
    "    df[\"pred\"] = outputs\n",
    "    c = alt.Chart(df).mark_circle().encode(\n",
    "        x=\"x\",\n",
    "        y=\"y\",\n",
    "        color=\"pred:N\"\n",
    "    )\n",
    "    return c"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "cell_id": "8cab754aeeef4ad7bbee9cd4528b1b0f",
    "deepnote_cell_type": "markdown",
    "tags": []
   },
   "source": [
    "## Decision trees for the above data\n",
    "\n",
    "* Plot the predictions for a Decision Tree Classifier with `max_leaf_nodes=3`.\n",
    "* What is the accuracy on the training data and on the test data?  What is the log loss on the training data and on the test data?  Use the following:\n",
    "```\n",
    "print(f''' \n",
    "Train score: {clf.score(X_train, y_train)}\n",
    "Test score: {clf.score(X_test, y_test)}\n",
    "Train log loss: {log_loss(y_train, clf.predict_proba(X_train))}\n",
    "Test log loss: {log_loss(y_test, clf.predict_proba(X_test))}\n",
    "''')\n",
    "```"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "metadata": {
    "cell_id": "0665f76db29f47129446a25a0aab1efc",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 0,
    "execution_start": 1669054044487,
    "source_hash": "e189f2c2",
    "tags": []
   },
   "outputs": [],
   "source": [
    "from sklearn.tree import DecisionTreeClassifier\n",
    "from sklearn.metrics import log_loss"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 10,
   "metadata": {
    "cell_id": "4ee7653ec6734c07a9eb8b102cdd14bc",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 1,
    "execution_start": 1669054063891,
    "source_hash": "d7855bb6",
    "tags": []
   },
   "outputs": [],
   "source": [
    "clf = DecisionTreeClassifier(max_leaf_nodes=3)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "metadata": {
    "cell_id": "d30f42d225d04835942df4c7cb1d9e34",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 6,
    "execution_start": 1669054085690,
    "source_hash": "e7844c31",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<style>#sk-container-id-1 {color: black;background-color: white;}#sk-container-id-1 pre{padding: 0;}#sk-container-id-1 div.sk-toggleable {background-color: white;}#sk-container-id-1 label.sk-toggleable__label {cursor: pointer;display: block;width: 100%;margin-bottom: 0;padding: 0.3em;box-sizing: border-box;text-align: center;}#sk-container-id-1 label.sk-toggleable__label-arrow:before {content: \"▸\";float: left;margin-right: 0.25em;color: #696969;}#sk-container-id-1 label.sk-toggleable__label-arrow:hover:before {color: black;}#sk-container-id-1 div.sk-estimator:hover label.sk-toggleable__label-arrow:before {color: black;}#sk-container-id-1 div.sk-toggleable__content {max-height: 0;max-width: 0;overflow: hidden;text-align: left;background-color: #f0f8ff;}#sk-container-id-1 div.sk-toggleable__content pre {margin: 0.2em;color: black;border-radius: 0.25em;background-color: #f0f8ff;}#sk-container-id-1 input.sk-toggleable__control:checked~div.sk-toggleable__content {max-height: 200px;max-width: 100%;overflow: auto;}#sk-container-id-1 input.sk-toggleable__control:checked~label.sk-toggleable__label-arrow:before {content: \"▾\";}#sk-container-id-1 div.sk-estimator input.sk-toggleable__control:checked~label.sk-toggleable__label {background-color: #d4ebff;}#sk-container-id-1 div.sk-label input.sk-toggleable__control:checked~label.sk-toggleable__label {background-color: #d4ebff;}#sk-container-id-1 input.sk-hidden--visually {border: 0;clip: rect(1px 1px 1px 1px);clip: rect(1px, 1px, 1px, 1px);height: 1px;margin: -1px;overflow: hidden;padding: 0;position: absolute;width: 1px;}#sk-container-id-1 div.sk-estimator {font-family: monospace;background-color: #f0f8ff;border: 1px dotted black;border-radius: 0.25em;box-sizing: border-box;margin-bottom: 0.5em;}#sk-container-id-1 div.sk-estimator:hover {background-color: #d4ebff;}#sk-container-id-1 div.sk-parallel-item::after {content: \"\";width: 100%;border-bottom: 1px solid gray;flex-grow: 1;}#sk-container-id-1 div.sk-label:hover label.sk-toggleable__label {background-color: #d4ebff;}#sk-container-id-1 div.sk-serial::before {content: \"\";position: absolute;border-left: 1px solid gray;box-sizing: border-box;top: 0;bottom: 0;left: 50%;z-index: 0;}#sk-container-id-1 div.sk-serial {display: flex;flex-direction: column;align-items: center;background-color: white;padding-right: 0.2em;padding-left: 0.2em;position: relative;}#sk-container-id-1 div.sk-item {position: relative;z-index: 1;}#sk-container-id-1 div.sk-parallel {display: flex;align-items: stretch;justify-content: center;background-color: white;position: relative;}#sk-container-id-1 div.sk-item::before, #sk-container-id-1 div.sk-parallel-item::before {content: \"\";position: absolute;border-left: 1px solid gray;box-sizing: border-box;top: 0;bottom: 0;left: 50%;z-index: -1;}#sk-container-id-1 div.sk-parallel-item {display: flex;flex-direction: column;z-index: 1;position: relative;background-color: white;}#sk-container-id-1 div.sk-parallel-item:first-child::after {align-self: flex-end;width: 50%;}#sk-container-id-1 div.sk-parallel-item:last-child::after {align-self: flex-start;width: 50%;}#sk-container-id-1 div.sk-parallel-item:only-child::after {width: 0;}#sk-container-id-1 div.sk-dashed-wrapped {border: 1px dashed gray;margin: 0 0.4em 0.5em 0.4em;box-sizing: border-box;padding-bottom: 0.4em;background-color: white;}#sk-container-id-1 div.sk-label label {font-family: monospace;font-weight: bold;display: inline-block;line-height: 1.2em;}#sk-container-id-1 div.sk-label-container {text-align: center;}#sk-container-id-1 div.sk-container {/* jupyter's `normalize.less` sets `[hidden] { display: none; }` but bootstrap.min.css set `[hidden] { display: none !important; }` so we also need the `!important` here to be able to override the default hidden behavior on the sphinx rendered scikit-learn.org. See: https://github.com/scikit-learn/scikit-learn/issues/21755 */display: inline-block !important;position: relative;}#sk-container-id-1 div.sk-text-repr-fallback {display: none;}</style><div id=\"sk-container-id-1\" class=\"sk-top-container\"><div class=\"sk-text-repr-fallback\"><pre>DecisionTreeClassifier(max_leaf_nodes=3)</pre><b>In a Jupyter environment, please rerun this cell to show the HTML representation or trust the notebook. <br />On GitHub, the HTML representation is unable to render, please try loading this page with nbviewer.org.</b></div><div class=\"sk-container\" hidden><div class=\"sk-item\"><div class=\"sk-estimator sk-toggleable\"><input class=\"sk-toggleable__control sk-hidden--visually\" id=\"sk-estimator-id-1\" type=\"checkbox\" checked><label for=\"sk-estimator-id-1\" class=\"sk-toggleable__label sk-toggleable__label-arrow\">DecisionTreeClassifier</label><div class=\"sk-toggleable__content\"><pre>DecisionTreeClassifier(max_leaf_nodes=3)</pre></div></div></div></div></div>"
      ],
      "text/plain": [
       "DecisionTreeClassifier(max_leaf_nodes=3)"
      ]
     },
     "execution_count": 11,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "clf.fit(X_train, y_train)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Notice the linear boundaries here.  That is always the case with decision trees, but sometimes there are so many linear boundaries that we can't actually recognize the boundaries.  Here we are using 3 leaf nodes, so there are only 3 regions in the space."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 13,
   "metadata": {
    "cell_id": "23b4173e7dbe4031bf52afaddd156d6f",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 527,
    "execution_start": 1669054140532,
    "source_hash": "14535e27",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "\n",
       "<div id=\"altair-viz-d1d2f0fc1f7142cf9c03eabab80127b8\"></div>\n",
       "<script type=\"text/javascript\">\n",
       "  var VEGA_DEBUG = (typeof VEGA_DEBUG == \"undefined\") ? {} : VEGA_DEBUG;\n",
       "  (function(spec, embedOpt){\n",
       "    let outputDiv = document.currentScript.previousElementSibling;\n",
       "    if (outputDiv.id !== \"altair-viz-d1d2f0fc1f7142cf9c03eabab80127b8\") {\n",
       "      outputDiv = document.getElementById(\"altair-viz-d1d2f0fc1f7142cf9c03eabab80127b8\");\n",
       "    }\n",
       "    const paths = {\n",
       "      \"vega\": \"https://cdn.jsdelivr.net/npm//vega@5?noext\",\n",
       "      \"vega-lib\": \"https://cdn.jsdelivr.net/npm//vega-lib?noext\",\n",
       "      \"vega-lite\": \"https://cdn.jsdelivr.net/npm//vega-lite@4.17.0?noext\",\n",
       "      \"vega-embed\": \"https://cdn.jsdelivr.net/npm//vega-embed@6?noext\",\n",
       "    };\n",
       "\n",
       "    function maybeLoadScript(lib, version) {\n",
       "      var key = `${lib.replace(\"-\", \"\")}_version`;\n",
       "      return (VEGA_DEBUG[key] == version) ?\n",
       "        Promise.resolve(paths[lib]) :\n",
       "        new Promise(function(resolve, reject) {\n",
       "          var s = document.createElement('script');\n",
       "          document.getElementsByTagName(\"head\")[0].appendChild(s);\n",
       "          s.async = true;\n",
       "          s.onload = () => {\n",
       "            VEGA_DEBUG[key] = version;\n",
       "            return resolve(paths[lib]);\n",
       "          };\n",
       "          s.onerror = () => reject(`Error loading script: ${paths[lib]}`);\n",
       "          s.src = paths[lib];\n",
       "        });\n",
       "    }\n",
       "\n",
       "    function showError(err) {\n",
       "      outputDiv.innerHTML = `<div class=\"error\" style=\"color:red;\">${err}</div>`;\n",
       "      throw err;\n",
       "    }\n",
       "\n",
       "    function displayChart(vegaEmbed) {\n",
       "      vegaEmbed(outputDiv, spec, embedOpt)\n",
       "        .catch(err => showError(`Javascript Error: ${err.message}<br>This usually means there's a typo in your chart specification. See the javascript console for the full traceback.`));\n",
       "    }\n",
       "\n",
       "    if(typeof define === \"function\" && define.amd) {\n",
       "      requirejs.config({paths});\n",
       "      require([\"vega-embed\"], displayChart, err => showError(`Error loading script: ${err.message}`));\n",
       "    } else {\n",
       "      maybeLoadScript(\"vega\", \"5\")\n",
       "        .then(() => maybeLoadScript(\"vega-lite\", \"4.17.0\"))\n",
       "        .then(() => maybeLoadScript(\"vega-embed\", \"6\"))\n",
       "        .catch(showError)\n",
       "        .then(() => displayChart(vegaEmbed));\n",
       "    }\n",
       "  })({\"config\": {\"view\": {\"continuousWidth\": 400, \"continuousHeight\": 300}}, \"data\": {\"name\": \"data-c25807f9b12a61d613ce63f7613d52ed\"}, \"mark\": \"circle\", \"encoding\": {\"color\": {\"field\": \"pred\", \"type\": \"nominal\"}, \"x\": {\"field\": \"x\", \"type\": \"quantitative\"}, \"y\": {\"field\": \"y\", \"type\": \"quantitative\"}}, \"$schema\": \"https://vega.github.io/schema/vega-lite/v4.17.0.json\", \"datasets\": {\"data-c25807f9b12a61d613ce63f7613d52ed\": [{\"x\": 1.4559540371135231, \"y\": 1.2225321299541925, \"pred\": 1}, {\"x\": 0.14375578038446712, \"y\": 0.9051715331786675, \"pred\": 0}, {\"x\": -0.8670155109522104, \"y\": 0.3711592574799248, \"pred\": 0}, {\"x\": 2.236716247035387, \"y\": 1.7613912870250954, \"pred\": 1}, {\"x\": 1.2839076010237616, \"y\": 1.0493530134308715, \"pred\": 0}, {\"x\": 2.4119441266475636, \"y\": 0.8885655192985291, \"pred\": 1}, {\"x\": 0.6085923102841594, \"y\": -1.393525225748726, \"pred\": 0}, {\"x\": -0.5672394268341736, \"y\": -0.6847900441875194, \"pred\": 0}, {\"x\": 1.3396178056849557, \"y\": 2.444527547552682, \"pred\": 1}, {\"x\": 1.6036421369444245, \"y\": 2.9838660218731716, \"pred\": 1}, {\"x\": 3.2132364327523555, \"y\": 1.3270613788768748, \"pred\": 1}, {\"x\": 3.552345691172357, \"y\": 2.2096037598723535, \"pred\": 1}, {\"x\": 1.762714296497166, \"y\": -1.0740807545618982, \"pred\": 1}, {\"x\": -0.17830606215500272, \"y\": -1.5232135953524801, \"pred\": 0}, {\"x\": 2.765631512603937, \"y\": 2.902379378160018, \"pred\": 1}, {\"x\": 1.710537988461506, \"y\": 3.1701766375339, \"pred\": 1}, {\"x\": -0.20734969827652708, \"y\": -0.37591996120915105, \"pred\": 0}, {\"x\": 1.6145821893115024, \"y\": 2.9366532186221868, \"pred\": 1}, {\"x\": 1.9489926716237493, \"y\": 2.8234675712472987, \"pred\": 1}, {\"x\": 2.710041698724246, \"y\": 2.7724887435364485, \"pred\": 1}, {\"x\": 2.8662962472055105, \"y\": 2.2472179530453955, \"pred\": 1}, {\"x\": -1.2231117488973633, \"y\": 0.3685950822771125, \"pred\": 0}, {\"x\": 0.9425397724411325, \"y\": -0.5351465926388975, \"pred\": 0}, {\"x\": 1.8105902612798963, \"y\": 0.9911354587932695, \"pred\": 1}, {\"x\": 1.2750575903893269, \"y\": 1.2567430683363894, \"pred\": 0}, {\"x\": 1.8496125662057936, \"y\": -0.08165155616424355, \"pred\": 1}, {\"x\": 3.3474469652692624, \"y\": 2.2989958455256603, \"pred\": 1}, {\"x\": -0.404357671797137, \"y\": 1.5418077084686126, \"pred\": 1}, {\"x\": 1.3613709645591259, \"y\": -0.5226347611202428, \"pred\": 0}, {\"x\": 0.01997092245414585, \"y\": 0.8628168935353443, \"pred\": 0}, {\"x\": 3.1409091213318314, \"y\": 1.6155005913792657, \"pred\": 1}, {\"x\": 0.4531586132388156, \"y\": -0.33267577528589565, \"pred\": 0}, {\"x\": 0.014155839014434735, \"y\": 2.4057380021060357, \"pred\": 1}, {\"x\": -0.6209797023155086, \"y\": -0.4537523812416193, \"pred\": 0}, {\"x\": 0.8001528559058803, \"y\": 1.147309002011903, \"pred\": 0}, {\"x\": 0.7061888116045445, \"y\": 0.005043898069076926, \"pred\": 0}, {\"x\": 2.3728809703734113, \"y\": 0.7710822511106976, \"pred\": 1}, {\"x\": 0.9386034698816718, \"y\": -1.1466886495167958, \"pred\": 0}, {\"x\": -0.9041049314828216, \"y\": 0.7027533792191322, \"pred\": 0}, {\"x\": -0.10321862725194576, \"y\": -1.0790126956031663, \"pred\": 0}, {\"x\": -2.187115273247333, \"y\": 0.7219650574076287, \"pred\": 0}, {\"x\": 1.3503059959308692, \"y\": 2.0152208250443837, \"pred\": 1}, {\"x\": -0.5090008972919337, \"y\": 0.7718870234868406, \"pred\": 0}, {\"x\": 0.18070066767270676, \"y\": 2.2999911375745055, \"pred\": 1}, {\"x\": 2.453790011195825, \"y\": 1.363023132904219, \"pred\": 1}, {\"x\": 2.8140013785687983, \"y\": 2.1846723505590755, \"pred\": 1}, {\"x\": 1.360256947928347, \"y\": 2.015146597571547, \"pred\": 1}, {\"x\": 2.2460915770315415, \"y\": 2.7906135726951207, \"pred\": 1}, {\"x\": -1.6495595298995447, \"y\": 0.2754714469462586, \"pred\": 0}, {\"x\": 1.9008108222400648, \"y\": 1.1564180679309823, \"pred\": 1}, {\"x\": 2.664623054390154, \"y\": 4.004287815624176, \"pred\": 1}, {\"x\": -0.6871472120485602, \"y\": 1.8366742207237288, \"pred\": 1}, {\"x\": -0.34112117132031883, \"y\": 1.0898461110532707, \"pred\": 0}, {\"x\": -0.5778416564893406, \"y\": -0.8416715368715004, \"pred\": 0}, {\"x\": -0.31726597100271015, \"y\": 1.1383330474921514, \"pred\": 0}, {\"x\": -0.16224855290821893, \"y\": -1.0747468405930436, \"pred\": 0}, {\"x\": -0.7996871994715307, \"y\": -0.8446924471317016, \"pred\": 0}, {\"x\": 4.533515015693821, \"y\": 2.623685545416536, \"pred\": 1}, {\"x\": 0.35597848750624017, \"y\": 1.343515172028458, \"pred\": 1}, {\"x\": 1.4042924673121555, \"y\": 1.8165586817591046, \"pred\": 1}, {\"x\": 2.5540970339269764, \"y\": 2.4567176993334394, \"pred\": 1}, {\"x\": 0.8829763673845581, \"y\": 3.504528948312634, \"pred\": 1}, {\"x\": 1.9655603796185876, \"y\": 0.32512544079981365, \"pred\": 1}, {\"x\": -0.7209996734353815, \"y\": 0.5622617060581323, \"pred\": 0}, {\"x\": 2.039590841798837, \"y\": 3.4492266397277627, \"pred\": 1}, {\"x\": 0.44976720755395455, \"y\": -1.430396701578305, \"pred\": 0}, {\"x\": 1.7696665248700298, \"y\": 0.847425723606837, \"pred\": 1}, {\"x\": 2.184310481955429, \"y\": 2.502355940359632, \"pred\": 1}, {\"x\": 1.3501878997225267, \"y\": 0.8612113741693206, \"pred\": 0}, {\"x\": 1.9475261519089524, \"y\": 3.2034922322952664, \"pred\": 1}, {\"x\": 0.9031540597999508, \"y\": 2.484118419846157, \"pred\": 1}, {\"x\": 1.3852536804012796, \"y\": 1.7577995454226543, \"pred\": 1}, {\"x\": -1.0670398044692198, \"y\": -0.059260833836361, \"pred\": 0}, {\"x\": -0.19049578315740576, \"y\": 0.6722721224549026, \"pred\": 0}, {\"x\": 1.5606669550207917, \"y\": 1.7147110417443479, \"pred\": 1}, {\"x\": 3.7056421167090754, \"y\": 1.6251868522955508, \"pred\": 1}, {\"x\": -1.1205068713840005, \"y\": -0.3466067875476209, \"pred\": 0}, {\"x\": 0.7909698216528814, \"y\": -1.391766084294036, \"pred\": 0}, {\"x\": 0.6350869000947228, \"y\": -0.2688785015946833, \"pred\": 0}, {\"x\": -0.712390662050588, \"y\": 0.753766378659703, \"pred\": 0}, {\"x\": 2.7678507375866435, \"y\": 1.84486501727544, \"pred\": 1}, {\"x\": -0.13752826816152028, \"y\": -1.8003657016978516, \"pred\": 0}, {\"x\": 0.080866188394344, \"y\": -2.319847554388968, \"pred\": 0}, {\"x\": 0.4979639779852594, \"y\": 2.749678337984768, \"pred\": 1}, {\"x\": 2.1072911932669545, \"y\": 2.4347700117360502, \"pred\": 1}, {\"x\": 1.7496400449660001, \"y\": 1.8036383271590657, \"pred\": 1}, {\"x\": 2.692214884564876, \"y\": 1.187279706485618, \"pred\": 1}, {\"x\": 2.3071132822078066, \"y\": 0.9303479927054046, \"pred\": 1}, {\"x\": 0.4813399523048028, \"y\": 0.3080908624754918, \"pred\": 0}, {\"x\": 1.2022930609701978, \"y\": 2.3357265984452713, \"pred\": 1}, {\"x\": -0.15579970816999872, \"y\": -1.4634777566193453, \"pred\": 0}, {\"x\": -0.9626608287669728, \"y\": -0.7013680441849037, \"pred\": 0}, {\"x\": 0.7435452461317569, \"y\": -0.6625811650314397, \"pred\": 0}, {\"x\": 0.1406138453747909, \"y\": 0.019892207578106016, \"pred\": 0}, {\"x\": 1.7405406203764353, \"y\": 3.3756491396961157, \"pred\": 1}, {\"x\": 0.636539037502539, \"y\": 2.2014015005452823, \"pred\": 1}, {\"x\": 0.8624014081512591, \"y\": 0.5232452162507775, \"pred\": 0}, {\"x\": -0.025645745936127125, \"y\": -0.9590398006025731, \"pred\": 0}, {\"x\": -0.11723949907063196, \"y\": 1.100836264556602, \"pred\": 0}, {\"x\": 2.3927390062646094, \"y\": 0.18548973091234577, \"pred\": 1}, {\"x\": -0.19422133384463808, \"y\": 0.5877885293013254, \"pred\": 0}, {\"x\": -0.2918113875232261, \"y\": 0.12677274472597902, \"pred\": 0}, {\"x\": -1.3825474846365924, \"y\": 0.23254262542334578, \"pred\": 0}, {\"x\": 0.6558615323233493, \"y\": -0.22467908543381457, \"pred\": 0}, {\"x\": 3.870349907724047, \"y\": 3.1109274374798166, \"pred\": 1}, {\"x\": 0.9528306110451948, \"y\": -1.0871815907509188, \"pred\": 0}, {\"x\": -0.4371456556814915, \"y\": 0.5479183096073379, \"pred\": 0}, {\"x\": -0.16127395672832917, \"y\": 0.44951651436299817, \"pred\": 0}, {\"x\": 2.997813029717478, \"y\": 3.231244588814504, \"pred\": 1}, {\"x\": 2.2250075222163606, \"y\": 0.4688637055535052, \"pred\": 1}, {\"x\": 1.853407493274361, \"y\": 2.078487613593274, \"pred\": 1}, {\"x\": -0.7709685285300425, \"y\": -0.41395371382728313, \"pred\": 0}, {\"x\": 0.6129550677145995, \"y\": 0.23966318182680454, \"pred\": 0}, {\"x\": 2.3005952863784875, \"y\": 1.0472838605961088, \"pred\": 1}, {\"x\": 1.436570669708498, \"y\": -0.5795082893291696, \"pred\": 1}, {\"x\": -1.054657177172913, \"y\": -0.9776990052219913, \"pred\": 0}, {\"x\": 1.4798744615901476, \"y\": 1.7356680561833622, \"pred\": 1}, {\"x\": -1.9241594490929896, \"y\": -0.757453225587536, \"pred\": 0}, {\"x\": 2.1563577719221985, \"y\": 4.365673555946404, \"pred\": 1}, {\"x\": 0.7884285840121856, \"y\": 0.5685312896803145, \"pred\": 0}, {\"x\": 3.740933814341995, \"y\": -0.03556415619944708, \"pred\": 1}, {\"x\": 3.38509438533557, \"y\": 1.88933556101016, \"pred\": 1}, {\"x\": -2.4957528823141972, \"y\": 1.3043577797963937, \"pred\": 1}, {\"x\": 2.736058077736053, \"y\": 2.666016362052516, \"pred\": 1}, {\"x\": 1.592827313909267, \"y\": 3.621161963396762, \"pred\": 1}, {\"x\": 2.599269524155709, \"y\": 2.9696621383994226, \"pred\": 1}, {\"x\": 2.271330979002925, \"y\": 4.611365466501027, \"pred\": 1}, {\"x\": 1.2321130918482257, \"y\": 2.772256448671617, \"pred\": 1}, {\"x\": 4.199320450880061, \"y\": 2.7617220943402283, \"pred\": 1}, {\"x\": 4.438510067019951, \"y\": 1.9501456048622783, \"pred\": 1}, {\"x\": 0.9399792195744116, \"y\": 0.9506069961060607, \"pred\": 0}, {\"x\": 0.4403789105928676, \"y\": -0.8384801402483328, \"pred\": 0}, {\"x\": 1.8758843070900657, \"y\": 2.023663980551364, \"pred\": 1}, {\"x\": 1.227322247613268, \"y\": 2.7321707051874116, \"pred\": 1}, {\"x\": -0.3236790297502634, \"y\": -0.11145904212515595, \"pred\": 0}, {\"x\": 2.3338773158710833, \"y\": 2.173174617420775, \"pred\": 1}, {\"x\": 1.3896197630118723, \"y\": 1.8389429159103785, \"pred\": 1}, {\"x\": 1.2655617879171142, \"y\": 1.326472834693644, \"pred\": 1}, {\"x\": 2.6494568961145273, \"y\": 2.034031096576255, \"pred\": 1}, {\"x\": 2.0541840739491852, \"y\": 2.6806681362126463, \"pred\": 1}, {\"x\": 0.47518769779384906, \"y\": -0.07236315822392445, \"pred\": 0}, {\"x\": 1.556495068521696, \"y\": 0.7868004452776833, \"pred\": 1}, {\"x\": 2.4151904657340686, \"y\": 1.3817176162952216, \"pred\": 1}, {\"x\": 2.230402823356569, \"y\": 2.431946895391424, \"pred\": 1}, {\"x\": 0.337447649965678, \"y\": 3.190858387393793, \"pred\": 1}, {\"x\": 1.194687665488288, \"y\": 1.1558162413648083, \"pred\": 0}, {\"x\": -0.34921913811594835, \"y\": 0.843842055045005, \"pred\": 0}, {\"x\": 1.4207461108249517, \"y\": 2.576007496726984, \"pred\": 1}, {\"x\": 0.15647674659188437, \"y\": 0.20425480457441636, \"pred\": 0}, {\"x\": -0.911344781357355, \"y\": -0.7461352526666984, \"pred\": 0}, {\"x\": -0.0012405611429540924, \"y\": 0.08134367638997905, \"pred\": 0}, {\"x\": -0.1522965744944709, \"y\": 0.704626894626221, \"pred\": 0}, {\"x\": 3.178170580363296, \"y\": 1.7109649913220648, \"pred\": 1}, {\"x\": 0.2532205247585785, \"y\": 0.9407870683897978, \"pred\": 0}, {\"x\": 1.1790347434852069, \"y\": -1.0760914658121563, \"pred\": 0}, {\"x\": 0.18494595039221876, \"y\": -0.6510564789536804, \"pred\": 0}, {\"x\": 0.4076688308069256, \"y\": 2.32353471469165, \"pred\": 1}, {\"x\": 1.9642845933830628, \"y\": 3.0039302837615773, \"pred\": 1}, {\"x\": 1.4028588731444431, \"y\": 1.6045726106064209, \"pred\": 1}, {\"x\": 0.8893585338418935, \"y\": 3.717926200674824, \"pred\": 1}, {\"x\": 0.6367185907707327, \"y\": 1.6782942647037324, \"pred\": 1}, {\"x\": -1.0669628403806435, \"y\": 3.4011057189806557, \"pred\": 1}, {\"x\": 0.2673819755787573, \"y\": -1.0319348271510602, \"pred\": 0}, {\"x\": -1.7207954551375861, \"y\": 0.017982138806439393, \"pred\": 0}, {\"x\": 1.4267264504853654, \"y\": -0.048697610640109204, \"pred\": 1}, {\"x\": -0.057532387873538586, \"y\": 0.5646542880869975, \"pred\": 0}, {\"x\": 1.1950253748410917, \"y\": -1.4615058094923734, \"pred\": 0}, {\"x\": 3.068200909048942, \"y\": 3.9006478804863063, \"pred\": 1}, {\"x\": 0.7304710721169607, \"y\": 0.8996130611234683, \"pred\": 0}, {\"x\": 3.0082325821645153, \"y\": 1.1312706815969824, \"pred\": 1}, {\"x\": 4.208480738141941, \"y\": 2.5871061449468176, \"pred\": 1}, {\"x\": 1.3992384201681904, \"y\": -1.6151079632521659, \"pred\": 1}, {\"x\": 0.36003178759974036, \"y\": -0.43820143730669325, \"pred\": 0}, {\"x\": 2.5915110533990484, \"y\": -0.27102844335797016, \"pred\": 1}, {\"x\": 1.3204048067975092, \"y\": 0.04066528515761626, \"pred\": 0}, {\"x\": 0.4394946907472934, \"y\": 1.7672366043893282, \"pred\": 1}, {\"x\": 0.8486534061441413, \"y\": 1.4169071306933088, \"pred\": 1}, {\"x\": 0.9734403648680088, \"y\": 0.9335892631796991, \"pred\": 0}, {\"x\": -0.9738381295272108, \"y\": 0.8048850955179162, \"pred\": 0}, {\"x\": -0.7640339696578627, \"y\": 0.1012697856437548, \"pred\": 0}, {\"x\": 2.8617222068747257, \"y\": 3.849776385866146, \"pred\": 1}, {\"x\": 0.45053117920927527, \"y\": -0.49429864739786794, \"pred\": 0}, {\"x\": -0.7046047621786199, \"y\": 0.4553185270261121, \"pred\": 0}, {\"x\": 0.1486981280629037, \"y\": 1.4460230634069287, \"pred\": 1}, {\"x\": -1.41124263188717, \"y\": 1.2047437309657716, \"pred\": 0}, {\"x\": 0.4820872038580639, \"y\": 3.3317589492355393, \"pred\": 1}, {\"x\": 0.20156945957526934, \"y\": -0.1650355232064671, \"pred\": 0}, {\"x\": -0.14908830964479858, \"y\": 1.8005179738889225, \"pred\": 1}, {\"x\": 1.7941257462609899, \"y\": 1.0823176653816473, \"pred\": 1}, {\"x\": 1.9434940241593952, \"y\": 1.862979444034073, \"pred\": 1}, {\"x\": -0.4192603220087837, \"y\": 2.386745800499031, \"pred\": 1}, {\"x\": 1.5794502314089767, \"y\": 0.8872219039413722, \"pred\": 1}, {\"x\": -0.5534026175135522, \"y\": -0.24150531238917375, \"pred\": 0}, {\"x\": -1.01700202554413, \"y\": -0.5269892532991041, \"pred\": 0}, {\"x\": -1.9453906815188249, \"y\": 0.8309056578021413, \"pred\": 0}, {\"x\": -0.28410380510716565, \"y\": 0.15003366373872756, \"pred\": 0}, {\"x\": 1.9649289132456702, \"y\": 2.321508194455287, \"pred\": 1}, {\"x\": 0.9000849971172967, \"y\": 0.8890323725239309, \"pred\": 0}, {\"x\": -0.644619180730499, \"y\": -1.1702444249284003, \"pred\": 0}, {\"x\": 3.0737033225195978, \"y\": 2.9818520300440294, \"pred\": 1}, {\"x\": 0.2614395928205015, \"y\": 0.46893464927171374, \"pred\": 0}, {\"x\": -0.8444764142538497, \"y\": -0.5164428497021851, \"pred\": 0}, {\"x\": 1.3116180465656415, \"y\": -1.2548603914775587, \"pred\": 0}, {\"x\": -0.5334945027167617, \"y\": -1.9323560015091858, \"pred\": 0}, {\"x\": 1.1384956408918423, \"y\": 1.1258379535900915, \"pred\": 0}, {\"x\": 1.4786857374358966, \"y\": -1.0453771305385342, \"pred\": 1}, {\"x\": 0.7085245177855963, \"y\": -0.9824603525381572, \"pred\": 0}, {\"x\": -1.8552666603782968, \"y\": -0.11032172211623395, \"pred\": 0}, {\"x\": 0.015174920002897885, \"y\": 0.117052488790469, \"pred\": 0}, {\"x\": 1.3823109341357713, \"y\": 1.3211814156031616, \"pred\": 1}, {\"x\": -1.055658897711565, \"y\": -0.308375994286531, \"pred\": 0}, {\"x\": 0.3650517980270081, \"y\": -0.04520588860236072, \"pred\": 0}, {\"x\": 2.6125269393847117, \"y\": 3.085007239316771, \"pred\": 1}, {\"x\": 3.3363234842354315, \"y\": 1.605563899655047, \"pred\": 1}, {\"x\": -0.6779772552780428, \"y\": 0.1106188085540423, \"pred\": 0}, {\"x\": -0.5361687068333683, \"y\": -2.6939563172399312, \"pred\": 0}, {\"x\": -0.7889890249515489, \"y\": -1.261605945319069, \"pred\": 0}, {\"x\": -0.38445768500357647, \"y\": -0.530327407582726, \"pred\": 0}, {\"x\": 0.41730231988738953, \"y\": 0.26955855330903167, \"pred\": 0}, {\"x\": -0.7320583853311774, \"y\": 0.5751509658063075, \"pred\": 0}, {\"x\": 2.226690771658064, \"y\": 2.311882011998303, \"pred\": 1}, {\"x\": -0.19163168438548278, \"y\": 0.4838288394495532, \"pred\": 0}, {\"x\": 1.9680077421958235, \"y\": 3.0527207346654532, \"pred\": 1}, {\"x\": -1.81842142065901, \"y\": 0.05569219339294779, \"pred\": 0}, {\"x\": 2.4473251505619094, \"y\": 1.1594630002615673, \"pred\": 1}, {\"x\": 1.8050515828561202, \"y\": 1.6736370209291347, \"pred\": 1}, {\"x\": 1.214463504631698, \"y\": 2.034938838643822, \"pred\": 1}, {\"x\": 1.8351757766163321, \"y\": 1.7021931993107415, \"pred\": 1}, {\"x\": 3.325466891523719, \"y\": 3.3007610258555466, \"pred\": 1}, {\"x\": 0.44080738731842145, \"y\": -1.812024553173441, \"pred\": 0}, {\"x\": 0.6070648197036337, \"y\": 2.3086244961655735, \"pred\": 1}, {\"x\": -2.3269262116155196, \"y\": -0.4158113660344991, \"pred\": 0}, {\"x\": -0.4654414831035872, \"y\": 0.4004773841168456, \"pred\": 0}, {\"x\": 1.0784289197973278, \"y\": 2.3187895017249587, \"pred\": 1}, {\"x\": 2.428214351090788, \"y\": 2.229010774428565, \"pred\": 1}, {\"x\": 2.300842716403956, \"y\": 2.1974559832484015, \"pred\": 1}, {\"x\": -0.19651664300377936, \"y\": -0.2648908941443411, \"pred\": 0}, {\"x\": 1.6069637071946876, \"y\": 1.429133723362852, \"pred\": 1}, {\"x\": -0.8732591793851744, \"y\": 0.5560180812944249, \"pred\": 0}, {\"x\": 3.853505633543313, \"y\": 3.1507460321250718, \"pred\": 1}, {\"x\": 0.12730328020698067, \"y\": 2.1503829673811126, \"pred\": 1}, {\"x\": 0.35953229551797367, \"y\": -0.511965094194221, \"pred\": 0}, {\"x\": 3.4465143940508334, \"y\": 5.101863538312319, \"pred\": 1}, {\"x\": 0.8579051809684236, \"y\": 0.40976548500449694, \"pred\": 0}, {\"x\": 0.37467317185190585, \"y\": 3.15456589083811, \"pred\": 1}, {\"x\": 1.3406793435446662, \"y\": 1.466546252991804, \"pred\": 1}, {\"x\": 1.4609918659634333, \"y\": 2.0542065312864928, \"pred\": 1}, {\"x\": 0.7420478267454842, \"y\": 1.1114411280385852, \"pred\": 0}, {\"x\": -0.41998581004543123, \"y\": -0.0285337341330573, \"pred\": 0}, {\"x\": 1.8462176390292164, \"y\": 1.0886226105354244, \"pred\": 1}, {\"x\": 0.48039822370628693, \"y\": 2.669508434914504, \"pred\": 1}, {\"x\": -0.5465767417188724, \"y\": 0.29202648981800744, \"pred\": 0}, {\"x\": 0.9962094669993536, \"y\": -0.04995254339686802, \"pred\": 0}, {\"x\": 0.8971332024654173, \"y\": 1.544007515956213, \"pred\": 1}, {\"x\": 2.506356748813186, \"y\": 2.016462481587103, \"pred\": 1}, {\"x\": 0.7133254192320697, \"y\": -0.9466364609859, \"pred\": 0}, {\"x\": 1.2040703250429852, \"y\": 1.3470353682509972, \"pred\": 1}, {\"x\": -1.0526677980507988, \"y\": -0.5586105579100125, \"pred\": 0}, {\"x\": -0.44151223119024857, \"y\": 0.9552466924396553, \"pred\": 0}, {\"x\": 1.6399277115282798, \"y\": 1.5146525907585886, \"pred\": 1}, {\"x\": -1.469634625209567, \"y\": -0.1463693097462854, \"pred\": 0}, {\"x\": 1.0525318150652148, \"y\": -1.5340965702283584, \"pred\": 0}, {\"x\": -1.639093411201915, \"y\": -0.27813451650877447, \"pred\": 0}, {\"x\": 2.135946763233126, \"y\": 2.247660788661511, \"pred\": 1}, {\"x\": 3.8522909678430186, \"y\": 2.3281097780522138, \"pred\": 1}, {\"x\": 3.3594580312665707, \"y\": 1.3844667369168193, \"pred\": 1}, {\"x\": 1.5892922570199843, \"y\": 4.30578448459959, \"pred\": 1}, {\"x\": -2.233052848438117, \"y\": 0.14202678794857176, \"pred\": 0}, {\"x\": 2.429672594447642, \"y\": 2.042853859669679, \"pred\": 1}, {\"x\": 0.9728507916505504, \"y\": 2.6075086014714084, \"pred\": 1}, {\"x\": 2.842312886127444, \"y\": 1.3091502290657346, \"pred\": 1}, {\"x\": -0.06434314961587694, \"y\": 0.7387144235342626, \"pred\": 0}, {\"x\": 0.3487505938690223, \"y\": -0.3386182541020083, \"pred\": 0}, {\"x\": 3.0222386729565907, \"y\": 3.4916874624264516, \"pred\": 1}, {\"x\": -0.45896716822932365, \"y\": 1.1515287731761275, \"pred\": 0}, {\"x\": 0.23082017281823, \"y\": 0.5467579110457865, \"pred\": 0}, {\"x\": 0.6062886568962988, \"y\": -0.026771649986440726, \"pred\": 0}, {\"x\": -0.5956856051072797, \"y\": 0.7958769911591804, \"pred\": 0}, {\"x\": 2.115737227318506, \"y\": 0.36735386905122724, \"pred\": 1}, {\"x\": -0.2642474112620271, \"y\": -0.9323592637202481, \"pred\": 0}, {\"x\": -1.6003841181528236, \"y\": -0.22205672759554324, \"pred\": 0}, {\"x\": 1.3303169236725105, \"y\": -0.6575172676978901, \"pred\": 0}, {\"x\": 3.1000197097589526, \"y\": 4.801153155014196, \"pred\": 1}, {\"x\": -0.928335225810039, \"y\": -0.7746600331288077, \"pred\": 0}, {\"x\": 2.8223656402267268, \"y\": 3.4418656691638247, \"pred\": 1}, {\"x\": 0.946348007431648, \"y\": 0.39254793773535773, \"pred\": 0}, {\"x\": 1.2690580976875576, \"y\": 0.2572490050399525, \"pred\": 0}, {\"x\": 2.032226881139099, \"y\": 4.567122577428944, \"pred\": 1}, {\"x\": -1.220671903715444, \"y\": -0.565046518309226, \"pred\": 0}, {\"x\": 1.1621877051255987, \"y\": 2.8309427428150205, \"pred\": 1}, {\"x\": 1.985355394382256, \"y\": 0.5389091609733734, \"pred\": 1}, {\"x\": 0.9137407048596775, \"y\": 0.31735092273633597, \"pred\": 0}, {\"x\": 3.147812051000587, \"y\": 1.154813468270937, \"pred\": 1}, {\"x\": 1.3978022435984774, \"y\": 1.8396679985237319, \"pred\": 1}, {\"x\": -1.5120214739877849, \"y\": 0.4446977161029871, \"pred\": 0}, {\"x\": 0.1549035962020594, \"y\": 0.277836156413196, \"pred\": 0}, {\"x\": 2.360380445279691, \"y\": 3.368154875156878, \"pred\": 1}, {\"x\": 0.11163027156564224, \"y\": 0.2829905076675621, \"pred\": 0}, {\"x\": 0.1687210624313978, \"y\": -1.4889501692875957, \"pred\": 0}, {\"x\": 0.9118946811654338, \"y\": 2.551469174853076, \"pred\": 1}, {\"x\": 0.747371595544824, \"y\": 1.075681534164297, \"pred\": 0}, {\"x\": 1.2571257313814808, \"y\": 0.18248209713031777, \"pred\": 0}, {\"x\": -0.7574771053093196, \"y\": -0.5108262341824535, \"pred\": 0}, {\"x\": -0.16240072992892313, \"y\": 1.3391315836256719, \"pred\": 1}, {\"x\": 1.0712974056744988, \"y\": 2.124654858947829, \"pred\": 1}, {\"x\": -0.018421809137576996, \"y\": 0.10767464455391365, \"pred\": 0}, {\"x\": 0.5467334374800554, \"y\": 0.750423475071857, \"pred\": 0}, {\"x\": -0.19380492240705713, \"y\": 1.5666402273744786, \"pred\": 1}, {\"x\": 2.3104323874656347, \"y\": 0.22399592783418343, \"pred\": 1}, {\"x\": 0.45348104026746144, \"y\": 0.9223441482568703, \"pred\": 0}, {\"x\": 2.2487456886625603, \"y\": 1.7232575132248926, \"pred\": 1}, {\"x\": -0.33240947257420594, \"y\": 2.0921686012929617, \"pred\": 1}, {\"x\": 0.9929491259546886, \"y\": -0.6437970571220203, \"pred\": 0}, {\"x\": 0.2676098967321498, \"y\": 0.8784598910238555, \"pred\": 0}, {\"x\": 0.9450577461588743, \"y\": 1.8378156974976747, \"pred\": 1}, {\"x\": 0.7571112741306737, \"y\": -1.2085723310812708, \"pred\": 0}, {\"x\": 2.095520834264214, \"y\": 2.3200664601730594, \"pred\": 1}, {\"x\": 0.5253295997343811, \"y\": -1.2768778466596493, \"pred\": 0}, {\"x\": 0.7419006788952703, \"y\": -0.3519968223496652, \"pred\": 0}, {\"x\": -0.044503078338053455, \"y\": 0.45181233874578974, \"pred\": 0}, {\"x\": -0.7068190812919728, \"y\": -0.6861465851073458, \"pred\": 0}, {\"x\": -1.7385178655572635, \"y\": 0.5704933453211514, \"pred\": 0}, {\"x\": 2.998899886332779, \"y\": 0.634248698991208, \"pred\": 1}, {\"x\": 0.15420459268584072, \"y\": 0.8173055190310792, \"pred\": 0}, {\"x\": -1.9774177085108056, \"y\": 2.2386487591829325, \"pred\": 1}, {\"x\": 1.5013438169373443, \"y\": 1.6045531391802799, \"pred\": 1}, {\"x\": -0.2324258720274623, \"y\": 0.7109747948581455, \"pred\": 0}, {\"x\": 2.0551775521900577, \"y\": 2.4190681047807843, \"pred\": 1}, {\"x\": -1.6642564360602479, \"y\": -0.1217464334245328, \"pred\": 0}, {\"x\": -0.23181317888607783, \"y\": -0.1165749870881772, \"pred\": 0}, {\"x\": 3.415864945921144, \"y\": 0.5329883064330754, \"pred\": 1}, {\"x\": -0.407616632784632, \"y\": -0.668307894421939, \"pred\": 0}, {\"x\": 1.7477370760676236, \"y\": 1.20634705787289, \"pred\": 1}, {\"x\": 1.2751258373944747, \"y\": 0.4609946505605043, \"pred\": 0}, {\"x\": 0.31244125715700677, \"y\": 0.21920844617560786, \"pred\": 0}, {\"x\": 0.20522091485414617, \"y\": -0.045963992111946794, \"pred\": 0}, {\"x\": 1.4063603231723563, \"y\": 2.9410600435834002, \"pred\": 1}, {\"x\": 0.5628467852810314, \"y\": -0.24332625188556253, \"pred\": 0}, {\"x\": 0.5011676877836018, \"y\": 0.9199851312920041, \"pred\": 0}, {\"x\": 0.017446916303085782, \"y\": -0.7200583582807348, \"pred\": 0}, {\"x\": -0.3848490502028002, \"y\": -1.5509569211976624, \"pred\": 0}, {\"x\": 2.5005989239578374, \"y\": 1.6544858315564697, \"pred\": 1}, {\"x\": 2.208494645965929, \"y\": 0.9483154856821232, \"pred\": 1}, {\"x\": -0.5351833981652417, \"y\": 0.8683775099508642, \"pred\": 0}, {\"x\": -0.8541429534648363, \"y\": 0.46565797200403236, \"pred\": 0}, {\"x\": 2.5920840674002923, \"y\": 0.37476811336909965, \"pred\": 1}, {\"x\": 3.0388537536498363, \"y\": 1.1822453985407702, \"pred\": 1}, {\"x\": 2.0709735272198517, \"y\": 1.7885843905817853, \"pred\": 1}, {\"x\": 0.35021313455542263, \"y\": 0.47347563519013397, \"pred\": 0}, {\"x\": 0.8917941660323877, \"y\": -1.5390641198540729, \"pred\": 0}, {\"x\": -0.1452113325860197, \"y\": 0.23785783828501061, \"pred\": 0}, {\"x\": -2.2068670954994913, \"y\": -0.4031289968469349, \"pred\": 0}, {\"x\": -0.6359031894503993, \"y\": 0.1997790971313106, \"pred\": 0}, {\"x\": 2.9898112579100316, \"y\": 2.8909152648111034, \"pred\": 1}, {\"x\": -0.01335974789092953, \"y\": 1.2355527522919023, \"pred\": 0}, {\"x\": -0.5083432327925071, \"y\": -0.6862364377992013, \"pred\": 0}, {\"x\": 0.6398839732802036, \"y\": 2.0536932362953815, \"pred\": 1}, {\"x\": 2.5461421558243416, \"y\": 1.2625939497950327, \"pred\": 1}, {\"x\": 1.3052737165412949, \"y\": 4.091883216971763, \"pred\": 1}, {\"x\": 0.9901299572529987, \"y\": 2.0749485504359404, \"pred\": 1}, {\"x\": 0.38411581154380325, \"y\": 1.4122345812397805, \"pred\": 1}, {\"x\": 3.0697263031814166, \"y\": -0.2804598261590847, \"pred\": 1}, {\"x\": 0.35136152893488404, \"y\": 0.788570479116926, \"pred\": 0}, {\"x\": 0.7659110492252689, \"y\": 0.20780005335113885, \"pred\": 0}, {\"x\": 2.2009639538279697, \"y\": 1.272294725099329, \"pred\": 1}, {\"x\": 3.7868569004388535, \"y\": 1.6714447664628662, \"pred\": 1}, {\"x\": 1.6961871140730036, \"y\": 2.699506870262244, \"pred\": 1}, {\"x\": 0.542544026931158, \"y\": 0.6261672937955176, \"pred\": 0}, {\"x\": -0.557684623006479, \"y\": -0.9570655488171265, \"pred\": 0}, {\"x\": 2.1800817394030765, \"y\": 0.37012151528707427, \"pred\": 1}, {\"x\": 2.0854556487772595, \"y\": 3.136275128464981, \"pred\": 1}, {\"x\": 2.3056068400458085, \"y\": 2.3978884495586614, \"pred\": 1}, {\"x\": 2.170329118452739, \"y\": -0.0334652980293213, \"pred\": 1}, {\"x\": -1.0942595125916925, \"y\": 1.982925182595953, \"pred\": 1}, {\"x\": 0.3532107803002698, \"y\": -0.8912937922772961, \"pred\": 0}, {\"x\": 1.3149422380864075, \"y\": 1.8490054305793169, \"pred\": 1}, {\"x\": 0.49223250052885703, \"y\": 1.7253989475688583, \"pred\": 1}, {\"x\": 2.009512655017796, \"y\": 3.5201334154397417, \"pred\": 1}, {\"x\": 1.9980452901555539, \"y\": 2.303724390568587, \"pred\": 1}, {\"x\": 2.5723636214743255, \"y\": 0.7736503599904248, \"pred\": 1}, {\"x\": 1.4844656543417931, \"y\": 2.992559756677755, \"pred\": 1}, {\"x\": 1.9917624296046446, \"y\": 1.679432402454359, \"pred\": 1}, {\"x\": 2.855678786912586, \"y\": 2.292225674252774, \"pred\": 1}, {\"x\": 3.683495929813405, \"y\": 1.3855166043567386, \"pred\": 1}, {\"x\": 1.186979048375644, \"y\": 2.797672569082689, \"pred\": 1}, {\"x\": -1.4141544662915098, \"y\": 0.12673002941390707, \"pred\": 0}, {\"x\": -1.0259108732843625, \"y\": 0.20581615250656984, \"pred\": 0}, {\"x\": 1.7712398465971424, \"y\": 1.481672243119422, \"pred\": 1}, {\"x\": 0.29164051076463826, \"y\": -0.3896555250433101, \"pred\": 0}, {\"x\": 2.7668504972793944, \"y\": 1.5704062429021668, \"pred\": 1}, {\"x\": 1.4739316414007817, \"y\": 2.1693502758148995, \"pred\": 1}, {\"x\": 1.3451017084510097, \"y\": 0.5323378882945463, \"pred\": 0}, {\"x\": 2.202473172070938, \"y\": 1.1927704745729666, \"pred\": 1}, {\"x\": 0.1364330425598168, \"y\": 1.6547766001068898, \"pred\": 1}, {\"x\": 3.7281893840230502, \"y\": 1.1457280642521839, \"pred\": 1}, {\"x\": -0.9841607817725814, \"y\": 1.190705272505982, \"pred\": 0}, {\"x\": 3.052333378588207, \"y\": 1.5469353257425968, \"pred\": 1}, {\"x\": 1.1757285420219539, \"y\": 0.7078651140198504, \"pred\": 0}, {\"x\": 1.8188436537188366, \"y\": -0.0552061713027614, \"pred\": 1}, {\"x\": 3.7848212310913274, \"y\": 1.8713978097811776, \"pred\": 1}, {\"x\": -1.1527257504517598, \"y\": -0.913446285204153, \"pred\": 0}, {\"x\": 1.8260275987189714, \"y\": 0.6650746330128983, \"pred\": 1}, {\"x\": 0.2283352044566521, \"y\": -0.6753750576188053, \"pred\": 0}, {\"x\": 2.4276671452734377, \"y\": 1.793206065362875, \"pred\": 1}, {\"x\": 2.7702785657932285, \"y\": 0.6327607703571645, \"pred\": 1}, {\"x\": 0.9630313786660784, \"y\": -1.9278777352364316, \"pred\": 0}, {\"x\": -0.6191847305942658, \"y\": 1.2125948226530212, \"pred\": 0}, {\"x\": -0.08809626952746996, \"y\": -0.36184796336959735, \"pred\": 0}, {\"x\": 3.723386352013055, \"y\": 0.5734760719351109, \"pred\": 1}, {\"x\": -1.0835914658230943, \"y\": -0.0001493927548569246, \"pred\": 0}, {\"x\": 2.7546480021839517, \"y\": 0.8294406857458252, \"pred\": 1}, {\"x\": 3.548200204010281, \"y\": 1.4076847120803713, \"pred\": 1}, {\"x\": 2.2625682294037417, \"y\": 2.396449917961715, \"pred\": 1}, {\"x\": 1.6380195259704862, \"y\": 2.5114604025401603, \"pred\": 1}, {\"x\": 0.5022857779517222, \"y\": 0.839193535320577, \"pred\": 0}, {\"x\": 2.53313595254121, \"y\": 1.7073139503965051, \"pred\": 1}, {\"x\": -0.5231642148972904, \"y\": -0.48137141579474935, \"pred\": 0}, {\"x\": 1.9906249118224364, \"y\": 0.16605400369245205, \"pred\": 1}, {\"x\": 1.2144508157368235, \"y\": 1.9506801724468557, \"pred\": 1}, {\"x\": 2.534649634454772, \"y\": 0.1469932950896291, \"pred\": 1}, {\"x\": -0.3221236569774085, \"y\": -0.37011607810475444, \"pred\": 0}, {\"x\": 2.7531069136156465, \"y\": 1.4426703238756096, \"pred\": 1}, {\"x\": 1.842865943529341, \"y\": 1.9075822293664888, \"pred\": 1}, {\"x\": 0.8149954430712237, \"y\": -1.185418809153406, \"pred\": 0}, {\"x\": 0.21745165945019368, \"y\": 0.5143288551447859, \"pred\": 0}, {\"x\": 0.35033088498361975, \"y\": 1.8004397115563828, \"pred\": 1}, {\"x\": 1.0942750991001489, \"y\": 0.004613901175436712, \"pred\": 0}, {\"x\": -0.5338435604421259, \"y\": -0.07115124422410989, \"pred\": 0}, {\"x\": -0.4979713554723796, \"y\": 0.9384604688575977, \"pred\": 0}, {\"x\": 1.0172414890962727, \"y\": 0.5529783472619647, \"pred\": 0}, {\"x\": 0.489805675723485, \"y\": 1.3007227251380344, \"pred\": 1}, {\"x\": -0.3148580761325759, \"y\": -0.42989708186880404, \"pred\": 0}, {\"x\": 4.221653853655571, \"y\": 1.8180194889356027, \"pred\": 1}, {\"x\": 3.4145035166500803, \"y\": 1.4537352027795598, \"pred\": 1}, {\"x\": 0.07299114797407072, \"y\": -0.24006071463865328, \"pred\": 0}, {\"x\": -0.9802743185258672, \"y\": -0.002389025600514556, \"pred\": 0}, {\"x\": 1.9176476860844183, \"y\": 0.8990088769612876, \"pred\": 1}, {\"x\": -0.15170019141369395, \"y\": -1.2368377011017966, \"pred\": 0}, {\"x\": 0.9995238627794718, \"y\": 0.33912166991349607, \"pred\": 0}, {\"x\": 2.7971698357380883, \"y\": 0.4284961677589696, \"pred\": 1}, {\"x\": 0.3303022703226134, \"y\": 1.2795087343766578, \"pred\": 0}, {\"x\": 0.6793203874098627, \"y\": 2.4897075316883863, \"pred\": 1}, {\"x\": 3.1801316897135203, \"y\": -0.0025192964192513045, \"pred\": 1}, {\"x\": 0.49087183250951594, \"y\": 1.8927422187767202, \"pred\": 1}, {\"x\": 2.823953492083943, \"y\": 1.8754466148450735, \"pred\": 1}, {\"x\": 0.40865864630465626, \"y\": -0.8677998149261569, \"pred\": 0}, {\"x\": 0.7998766732572836, \"y\": 0.6790266830356967, \"pred\": 0}, {\"x\": 3.16457816375343, \"y\": 2.5299278264194656, \"pred\": 1}, {\"x\": 3.0824789636044114, \"y\": 4.966250097193541, \"pred\": 1}, {\"x\": 1.1722774270578469, \"y\": 1.1490631884147902, \"pred\": 0}, {\"x\": 1.0369968080399357, \"y\": -1.3189645536049885, \"pred\": 0}, {\"x\": 3.7280110563709856, \"y\": 3.6421336258852905, \"pred\": 1}, {\"x\": 0.6386749234055078, \"y\": 0.17851926932176165, \"pred\": 0}, {\"x\": -0.7686270207784495, \"y\": 0.7291654706806434, \"pred\": 0}, {\"x\": 0.4006736681660438, \"y\": -0.764593898622952, \"pred\": 0}, {\"x\": 4.503354046947538, \"y\": 2.838073066693751, \"pred\": 1}, {\"x\": 2.9113751643607433, \"y\": 2.1412893173639698, \"pred\": 1}, {\"x\": 3.294056296712104, \"y\": -0.36469608065789894, \"pred\": 1}, {\"x\": 0.31287871866605876, \"y\": 0.13679032249522113, \"pred\": 0}, {\"x\": 0.5319765561553507, \"y\": -1.3703642428009506, \"pred\": 0}, {\"x\": 0.8672126651998152, \"y\": -0.5209590207114089, \"pred\": 0}, {\"x\": -0.5136792046662925, \"y\": -1.257253734973249, \"pred\": 0}, {\"x\": 2.7212519457943585, \"y\": 0.050249003899367484, \"pred\": 1}, {\"x\": 0.3972413264075336, \"y\": -1.5128451152607716, \"pred\": 0}, {\"x\": 2.531723565932997, \"y\": 2.239581604376858, \"pred\": 1}, {\"x\": -1.830354023073999, \"y\": 0.6019355688249879, \"pred\": 0}, {\"x\": 1.9452558917173377, \"y\": 0.3598283935608044, \"pred\": 1}, {\"x\": 0.7622308225590424, \"y\": -0.25251758817880776, \"pred\": 0}, {\"x\": 1.4977015999604872, \"y\": 0.6446988633003452, \"pred\": 1}, {\"x\": 0.6598257388547495, \"y\": 3.6128983277731725, \"pred\": 1}, {\"x\": 2.0945008750379053, \"y\": 1.267184830290836, \"pred\": 1}, {\"x\": 1.717175959710519, \"y\": 0.7778483925521874, \"pred\": 1}, {\"x\": 2.328566455889293, \"y\": 0.7208853070121146, \"pred\": 1}, {\"x\": 2.921435479755555, \"y\": 1.7071197902880657, \"pred\": 1}, {\"x\": -3.210430797268423, \"y\": 0.4777660895774647, \"pred\": 0}, {\"x\": 1.564791953399383, \"y\": 2.3255322669728162, \"pred\": 1}, {\"x\": 1.0441306350285604, \"y\": 2.1003552832079437, \"pred\": 1}, {\"x\": 1.4992193438668884, \"y\": 4.04414288098479, \"pred\": 1}, {\"x\": 1.749241790081012, \"y\": 0.5011372949374676, \"pred\": 1}, {\"x\": 3.3974402689876415, \"y\": 2.5031037927644775, \"pred\": 1}, {\"x\": 2.379428273695179, \"y\": 2.3775040758320616, \"pred\": 1}, {\"x\": 2.836948426757939, \"y\": 1.1309460946801244, \"pred\": 1}, {\"x\": 0.4349760219816502, \"y\": 0.7588944642911625, \"pred\": 0}, {\"x\": 0.3902203816463774, \"y\": 3.4041647200248475, \"pred\": 1}, {\"x\": 1.1097851050648244, \"y\": 2.856810097997084, \"pred\": 1}, {\"x\": -0.882490391596822, \"y\": -0.6606324986051187, \"pred\": 0}, {\"x\": -0.3051810275934747, \"y\": 0.041447402165011596, \"pred\": 0}, {\"x\": 2.7287649446028355, \"y\": 0.6998183159944318, \"pred\": 1}, {\"x\": -2.236053777261358, \"y\": 0.5833276501518617, \"pred\": 0}, {\"x\": 0.7547050088790299, \"y\": -0.7598847788231394, \"pred\": 0}, {\"x\": -1.247336156644393, \"y\": 0.31717096074155054, \"pred\": 0}, {\"x\": 3.3984769733544002, \"y\": 1.787254142967087, \"pred\": 1}, {\"x\": -0.0051374179562285, \"y\": -0.15956287406705108, \"pred\": 0}, {\"x\": 0.6353546579819151, \"y\": 1.8771104516000663, \"pred\": 1}, {\"x\": 0.5451054177509091, \"y\": 1.3168720121050563, \"pred\": 1}, {\"x\": 0.6586660668217251, \"y\": 1.0461644964376338, \"pred\": 0}, {\"x\": 1.6601644225247327, \"y\": 1.1558746731720393, \"pred\": 1}, {\"x\": 0.6609032917196628, \"y\": 0.8224723016354284, \"pred\": 0}, {\"x\": -0.8135337616981977, \"y\": -0.935955221598663, \"pred\": 0}, {\"x\": -0.030667987475674858, \"y\": -0.8814625655313383, \"pred\": 0}]}}, {\"mode\": \"vega-lite\"});\n",
       "</script>"
      ],
      "text/plain": [
       "alt.Chart(...)"
      ]
     },
     "execution_count": 13,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "make_chart(clf, X)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Here I've added some format specifications `:.1%` which says to convert a probability like 0.92444444 into a percentage with one decimal point, like 92.4%.  It's very convenient that Python can make those conversions for us."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 15,
   "metadata": {
    "cell_id": "0258cb91f4574ad0b13a58c691076867",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 305,
    "execution_start": 1669054366369,
    "source_hash": "6092154",
    "tags": []
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " \n",
      "Train score: 92.4%\n",
      "Test score: 92.0%\n",
      "Train log loss: 0.24577489989714546\n",
      "Test log loss: 0.26162520838554965\n",
      "\n"
     ]
    }
   ],
   "source": [
    "print(f''' \n",
    "Train score: {clf.score(X_train, y_train):.1%}\n",
    "Test score: {clf.score(X_test, y_test):.1%}\n",
    "Train log loss: {log_loss(y_train, clf.predict_proba(X_train))}\n",
    "Test log loss: {log_loss(y_test, clf.predict_proba(X_test))}\n",
    "''')"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "cell_id": "ea54337ca52446708875d71d4e4e5cea",
    "deepnote_cell_type": "markdown",
    "tags": []
   },
   "source": [
    "* Do the same thing with `max_leaf_nodes=28`.\n",
    "\n",
    "What you should imagine here is that this decision tree is more likely to overfit the data (because we are giving the tree so much more flexibility, with the 28 leaf nodes."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 16,
   "metadata": {
    "cell_id": "b85bf3e4b79d4bb587ce30e0e6b89fa4",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 0,
    "execution_start": 1669054414606,
    "source_hash": "7b7949ba",
    "tags": []
   },
   "outputs": [],
   "source": [
    "clf = DecisionTreeClassifier(max_leaf_nodes=28)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 17,
   "metadata": {
    "cell_id": "f83398bd081c4dc289449695614942cb",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 6,
    "execution_start": 1669054457099,
    "source_hash": "e7844c31",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<style>#sk-container-id-2 {color: black;background-color: white;}#sk-container-id-2 pre{padding: 0;}#sk-container-id-2 div.sk-toggleable {background-color: white;}#sk-container-id-2 label.sk-toggleable__label {cursor: pointer;display: block;width: 100%;margin-bottom: 0;padding: 0.3em;box-sizing: border-box;text-align: center;}#sk-container-id-2 label.sk-toggleable__label-arrow:before {content: \"▸\";float: left;margin-right: 0.25em;color: #696969;}#sk-container-id-2 label.sk-toggleable__label-arrow:hover:before {color: black;}#sk-container-id-2 div.sk-estimator:hover label.sk-toggleable__label-arrow:before {color: black;}#sk-container-id-2 div.sk-toggleable__content {max-height: 0;max-width: 0;overflow: hidden;text-align: left;background-color: #f0f8ff;}#sk-container-id-2 div.sk-toggleable__content pre {margin: 0.2em;color: black;border-radius: 0.25em;background-color: #f0f8ff;}#sk-container-id-2 input.sk-toggleable__control:checked~div.sk-toggleable__content {max-height: 200px;max-width: 100%;overflow: auto;}#sk-container-id-2 input.sk-toggleable__control:checked~label.sk-toggleable__label-arrow:before {content: \"▾\";}#sk-container-id-2 div.sk-estimator input.sk-toggleable__control:checked~label.sk-toggleable__label {background-color: #d4ebff;}#sk-container-id-2 div.sk-label input.sk-toggleable__control:checked~label.sk-toggleable__label {background-color: #d4ebff;}#sk-container-id-2 input.sk-hidden--visually {border: 0;clip: rect(1px 1px 1px 1px);clip: rect(1px, 1px, 1px, 1px);height: 1px;margin: -1px;overflow: hidden;padding: 0;position: absolute;width: 1px;}#sk-container-id-2 div.sk-estimator {font-family: monospace;background-color: #f0f8ff;border: 1px dotted black;border-radius: 0.25em;box-sizing: border-box;margin-bottom: 0.5em;}#sk-container-id-2 div.sk-estimator:hover {background-color: #d4ebff;}#sk-container-id-2 div.sk-parallel-item::after {content: \"\";width: 100%;border-bottom: 1px solid gray;flex-grow: 1;}#sk-container-id-2 div.sk-label:hover label.sk-toggleable__label {background-color: #d4ebff;}#sk-container-id-2 div.sk-serial::before {content: \"\";position: absolute;border-left: 1px solid gray;box-sizing: border-box;top: 0;bottom: 0;left: 50%;z-index: 0;}#sk-container-id-2 div.sk-serial {display: flex;flex-direction: column;align-items: center;background-color: white;padding-right: 0.2em;padding-left: 0.2em;position: relative;}#sk-container-id-2 div.sk-item {position: relative;z-index: 1;}#sk-container-id-2 div.sk-parallel {display: flex;align-items: stretch;justify-content: center;background-color: white;position: relative;}#sk-container-id-2 div.sk-item::before, #sk-container-id-2 div.sk-parallel-item::before {content: \"\";position: absolute;border-left: 1px solid gray;box-sizing: border-box;top: 0;bottom: 0;left: 50%;z-index: -1;}#sk-container-id-2 div.sk-parallel-item {display: flex;flex-direction: column;z-index: 1;position: relative;background-color: white;}#sk-container-id-2 div.sk-parallel-item:first-child::after {align-self: flex-end;width: 50%;}#sk-container-id-2 div.sk-parallel-item:last-child::after {align-self: flex-start;width: 50%;}#sk-container-id-2 div.sk-parallel-item:only-child::after {width: 0;}#sk-container-id-2 div.sk-dashed-wrapped {border: 1px dashed gray;margin: 0 0.4em 0.5em 0.4em;box-sizing: border-box;padding-bottom: 0.4em;background-color: white;}#sk-container-id-2 div.sk-label label {font-family: monospace;font-weight: bold;display: inline-block;line-height: 1.2em;}#sk-container-id-2 div.sk-label-container {text-align: center;}#sk-container-id-2 div.sk-container {/* jupyter's `normalize.less` sets `[hidden] { display: none; }` but bootstrap.min.css set `[hidden] { display: none !important; }` so we also need the `!important` here to be able to override the default hidden behavior on the sphinx rendered scikit-learn.org. See: https://github.com/scikit-learn/scikit-learn/issues/21755 */display: inline-block !important;position: relative;}#sk-container-id-2 div.sk-text-repr-fallback {display: none;}</style><div id=\"sk-container-id-2\" class=\"sk-top-container\"><div class=\"sk-text-repr-fallback\"><pre>DecisionTreeClassifier(max_leaf_nodes=28)</pre><b>In a Jupyter environment, please rerun this cell to show the HTML representation or trust the notebook. <br />On GitHub, the HTML representation is unable to render, please try loading this page with nbviewer.org.</b></div><div class=\"sk-container\" hidden><div class=\"sk-item\"><div class=\"sk-estimator sk-toggleable\"><input class=\"sk-toggleable__control sk-hidden--visually\" id=\"sk-estimator-id-2\" type=\"checkbox\" checked><label for=\"sk-estimator-id-2\" class=\"sk-toggleable__label sk-toggleable__label-arrow\">DecisionTreeClassifier</label><div class=\"sk-toggleable__content\"><pre>DecisionTreeClassifier(max_leaf_nodes=28)</pre></div></div></div></div></div>"
      ],
      "text/plain": [
       "DecisionTreeClassifier(max_leaf_nodes=28)"
      ]
     },
     "execution_count": 17,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "clf.fit(X_train, y_train)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "This chart looks almost identical to the true data.  Even though the boundaries are linear, some of the regions are so small that we can't even tell where the boundaries are.  (Here we are coloring the true input points.  It would also be interesting to color many more random points in this area... then some of the boundaries would be more apparent.  That is what we were rushing through at the end of class last Friday.)  Because this picture looks pretty complicated, that is evidence of overfitting."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 19,
   "metadata": {
    "cell_id": "984c530eccb34a6c89e454f63e01fdb0",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 8,
    "execution_start": 1669054470560,
    "source_hash": "14535e27",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "\n",
       "<div id=\"altair-viz-8099e38166c34acb9942284170e9b1ef\"></div>\n",
       "<script type=\"text/javascript\">\n",
       "  var VEGA_DEBUG = (typeof VEGA_DEBUG == \"undefined\") ? {} : VEGA_DEBUG;\n",
       "  (function(spec, embedOpt){\n",
       "    let outputDiv = document.currentScript.previousElementSibling;\n",
       "    if (outputDiv.id !== \"altair-viz-8099e38166c34acb9942284170e9b1ef\") {\n",
       "      outputDiv = document.getElementById(\"altair-viz-8099e38166c34acb9942284170e9b1ef\");\n",
       "    }\n",
       "    const paths = {\n",
       "      \"vega\": \"https://cdn.jsdelivr.net/npm//vega@5?noext\",\n",
       "      \"vega-lib\": \"https://cdn.jsdelivr.net/npm//vega-lib?noext\",\n",
       "      \"vega-lite\": \"https://cdn.jsdelivr.net/npm//vega-lite@4.17.0?noext\",\n",
       "      \"vega-embed\": \"https://cdn.jsdelivr.net/npm//vega-embed@6?noext\",\n",
       "    };\n",
       "\n",
       "    function maybeLoadScript(lib, version) {\n",
       "      var key = `${lib.replace(\"-\", \"\")}_version`;\n",
       "      return (VEGA_DEBUG[key] == version) ?\n",
       "        Promise.resolve(paths[lib]) :\n",
       "        new Promise(function(resolve, reject) {\n",
       "          var s = document.createElement('script');\n",
       "          document.getElementsByTagName(\"head\")[0].appendChild(s);\n",
       "          s.async = true;\n",
       "          s.onload = () => {\n",
       "            VEGA_DEBUG[key] = version;\n",
       "            return resolve(paths[lib]);\n",
       "          };\n",
       "          s.onerror = () => reject(`Error loading script: ${paths[lib]}`);\n",
       "          s.src = paths[lib];\n",
       "        });\n",
       "    }\n",
       "\n",
       "    function showError(err) {\n",
       "      outputDiv.innerHTML = `<div class=\"error\" style=\"color:red;\">${err}</div>`;\n",
       "      throw err;\n",
       "    }\n",
       "\n",
       "    function displayChart(vegaEmbed) {\n",
       "      vegaEmbed(outputDiv, spec, embedOpt)\n",
       "        .catch(err => showError(`Javascript Error: ${err.message}<br>This usually means there's a typo in your chart specification. See the javascript console for the full traceback.`));\n",
       "    }\n",
       "\n",
       "    if(typeof define === \"function\" && define.amd) {\n",
       "      requirejs.config({paths});\n",
       "      require([\"vega-embed\"], displayChart, err => showError(`Error loading script: ${err.message}`));\n",
       "    } else {\n",
       "      maybeLoadScript(\"vega\", \"5\")\n",
       "        .then(() => maybeLoadScript(\"vega-lite\", \"4.17.0\"))\n",
       "        .then(() => maybeLoadScript(\"vega-embed\", \"6\"))\n",
       "        .catch(showError)\n",
       "        .then(() => displayChart(vegaEmbed));\n",
       "    }\n",
       "  })({\"config\": {\"view\": {\"continuousWidth\": 400, \"continuousHeight\": 300}}, \"data\": {\"name\": \"data-a80448a47969f700a18a847c16b5210f\"}, \"mark\": \"circle\", \"encoding\": {\"color\": {\"field\": \"pred\", \"type\": \"nominal\"}, \"x\": {\"field\": \"x\", \"type\": \"quantitative\"}, \"y\": {\"field\": \"y\", \"type\": \"quantitative\"}}, \"$schema\": \"https://vega.github.io/schema/vega-lite/v4.17.0.json\", \"datasets\": {\"data-a80448a47969f700a18a847c16b5210f\": [{\"x\": 1.4559540371135231, \"y\": 1.2225321299541925, \"pred\": 1}, {\"x\": 0.14375578038446712, \"y\": 0.9051715331786675, \"pred\": 0}, {\"x\": -0.8670155109522104, \"y\": 0.3711592574799248, \"pred\": 0}, {\"x\": 2.236716247035387, \"y\": 1.7613912870250954, \"pred\": 1}, {\"x\": 1.2839076010237616, \"y\": 1.0493530134308715, \"pred\": 1}, {\"x\": 2.4119441266475636, \"y\": 0.8885655192985291, \"pred\": 1}, {\"x\": 0.6085923102841594, \"y\": -1.393525225748726, \"pred\": 0}, {\"x\": -0.5672394268341736, \"y\": -0.6847900441875194, \"pred\": 0}, {\"x\": 1.3396178056849557, \"y\": 2.444527547552682, \"pred\": 1}, {\"x\": 1.6036421369444245, \"y\": 2.9838660218731716, \"pred\": 1}, {\"x\": 3.2132364327523555, \"y\": 1.3270613788768748, \"pred\": 1}, {\"x\": 3.552345691172357, \"y\": 2.2096037598723535, \"pred\": 1}, {\"x\": 1.762714296497166, \"y\": -1.0740807545618982, \"pred\": 0}, {\"x\": -0.17830606215500272, \"y\": -1.5232135953524801, \"pred\": 0}, {\"x\": 2.765631512603937, \"y\": 2.902379378160018, \"pred\": 1}, {\"x\": 1.710537988461506, \"y\": 3.1701766375339, \"pred\": 1}, {\"x\": -0.20734969827652708, \"y\": -0.37591996120915105, \"pred\": 0}, {\"x\": 1.6145821893115024, \"y\": 2.9366532186221868, \"pred\": 1}, {\"x\": 1.9489926716237493, \"y\": 2.8234675712472987, \"pred\": 1}, {\"x\": 2.710041698724246, \"y\": 2.7724887435364485, \"pred\": 1}, {\"x\": 2.8662962472055105, \"y\": 2.2472179530453955, \"pred\": 1}, {\"x\": -1.2231117488973633, \"y\": 0.3685950822771125, \"pred\": 0}, {\"x\": 0.9425397724411325, \"y\": -0.5351465926388975, \"pred\": 0}, {\"x\": 1.8105902612798963, \"y\": 0.9911354587932695, \"pred\": 1}, {\"x\": 1.2750575903893269, \"y\": 1.2567430683363894, \"pred\": 0}, {\"x\": 1.8496125662057936, \"y\": -0.08165155616424355, \"pred\": 0}, {\"x\": 3.3474469652692624, \"y\": 2.2989958455256603, \"pred\": 1}, {\"x\": -0.404357671797137, \"y\": 1.5418077084686126, \"pred\": 0}, {\"x\": 1.3613709645591259, \"y\": -0.5226347611202428, \"pred\": 0}, {\"x\": 0.01997092245414585, \"y\": 0.8628168935353443, \"pred\": 0}, {\"x\": 3.1409091213318314, \"y\": 1.6155005913792657, \"pred\": 1}, {\"x\": 0.4531586132388156, \"y\": -0.33267577528589565, \"pred\": 0}, {\"x\": 0.014155839014434735, \"y\": 2.4057380021060357, \"pred\": 1}, {\"x\": -0.6209797023155086, \"y\": -0.4537523812416193, \"pred\": 0}, {\"x\": 0.8001528559058803, \"y\": 1.147309002011903, \"pred\": 0}, {\"x\": 0.7061888116045445, \"y\": 0.005043898069076926, \"pred\": 0}, {\"x\": 2.3728809703734113, \"y\": 0.7710822511106976, \"pred\": 1}, {\"x\": 0.9386034698816718, \"y\": -1.1466886495167958, \"pred\": 0}, {\"x\": -0.9041049314828216, \"y\": 0.7027533792191322, \"pred\": 0}, {\"x\": -0.10321862725194576, \"y\": -1.0790126956031663, \"pred\": 0}, {\"x\": -2.187115273247333, \"y\": 0.7219650574076287, \"pred\": 0}, {\"x\": 1.3503059959308692, \"y\": 2.0152208250443837, \"pred\": 0}, {\"x\": -0.5090008972919337, \"y\": 0.7718870234868406, \"pred\": 0}, {\"x\": 0.18070066767270676, \"y\": 2.2999911375745055, \"pred\": 1}, {\"x\": 2.453790011195825, \"y\": 1.363023132904219, \"pred\": 1}, {\"x\": 2.8140013785687983, \"y\": 2.1846723505590755, \"pred\": 1}, {\"x\": 1.360256947928347, \"y\": 2.015146597571547, \"pred\": 0}, {\"x\": 2.2460915770315415, \"y\": 2.7906135726951207, \"pred\": 1}, {\"x\": -1.6495595298995447, \"y\": 0.2754714469462586, \"pred\": 0}, {\"x\": 1.9008108222400648, \"y\": 1.1564180679309823, \"pred\": 1}, {\"x\": 2.664623054390154, \"y\": 4.004287815624176, \"pred\": 1}, {\"x\": -0.6871472120485602, \"y\": 1.8366742207237288, \"pred\": 0}, {\"x\": -0.34112117132031883, \"y\": 1.0898461110532707, \"pred\": 0}, {\"x\": -0.5778416564893406, \"y\": -0.8416715368715004, \"pred\": 0}, {\"x\": -0.31726597100271015, \"y\": 1.1383330474921514, \"pred\": 0}, {\"x\": -0.16224855290821893, \"y\": -1.0747468405930436, \"pred\": 0}, {\"x\": -0.7996871994715307, \"y\": -0.8446924471317016, \"pred\": 0}, {\"x\": 4.533515015693821, \"y\": 2.623685545416536, \"pred\": 1}, {\"x\": 0.35597848750624017, \"y\": 1.343515172028458, \"pred\": 1}, {\"x\": 1.4042924673121555, \"y\": 1.8165586817591046, \"pred\": 1}, {\"x\": 2.5540970339269764, \"y\": 2.4567176993334394, \"pred\": 1}, {\"x\": 0.8829763673845581, \"y\": 3.504528948312634, \"pred\": 1}, {\"x\": 1.9655603796185876, \"y\": 0.32512544079981365, \"pred\": 1}, {\"x\": -0.7209996734353815, \"y\": 0.5622617060581323, \"pred\": 0}, {\"x\": 2.039590841798837, \"y\": 3.4492266397277627, \"pred\": 1}, {\"x\": 0.44976720755395455, \"y\": -1.430396701578305, \"pred\": 0}, {\"x\": 1.7696665248700298, \"y\": 0.847425723606837, \"pred\": 1}, {\"x\": 2.184310481955429, \"y\": 2.502355940359632, \"pred\": 1}, {\"x\": 1.3501878997225267, \"y\": 0.8612113741693206, \"pred\": 0}, {\"x\": 1.9475261519089524, \"y\": 3.2034922322952664, \"pred\": 1}, {\"x\": 0.9031540597999508, \"y\": 2.484118419846157, \"pred\": 1}, {\"x\": 1.3852536804012796, \"y\": 1.7577995454226543, \"pred\": 1}, {\"x\": -1.0670398044692198, \"y\": -0.059260833836361, \"pred\": 0}, {\"x\": -0.19049578315740576, \"y\": 0.6722721224549026, \"pred\": 0}, {\"x\": 1.5606669550207917, \"y\": 1.7147110417443479, \"pred\": 1}, {\"x\": 3.7056421167090754, \"y\": 1.6251868522955508, \"pred\": 1}, {\"x\": -1.1205068713840005, \"y\": -0.3466067875476209, \"pred\": 0}, {\"x\": 0.7909698216528814, \"y\": -1.391766084294036, \"pred\": 0}, {\"x\": 0.6350869000947228, \"y\": -0.2688785015946833, \"pred\": 0}, {\"x\": -0.712390662050588, \"y\": 0.753766378659703, \"pred\": 0}, {\"x\": 2.7678507375866435, \"y\": 1.84486501727544, \"pred\": 1}, {\"x\": -0.13752826816152028, \"y\": -1.8003657016978516, \"pred\": 0}, {\"x\": 0.080866188394344, \"y\": -2.319847554388968, \"pred\": 0}, {\"x\": 0.4979639779852594, \"y\": 2.749678337984768, \"pred\": 1}, {\"x\": 2.1072911932669545, \"y\": 2.4347700117360502, \"pred\": 1}, {\"x\": 1.7496400449660001, \"y\": 1.8036383271590657, \"pred\": 1}, {\"x\": 2.692214884564876, \"y\": 1.187279706485618, \"pred\": 1}, {\"x\": 2.3071132822078066, \"y\": 0.9303479927054046, \"pred\": 1}, {\"x\": 0.4813399523048028, \"y\": 0.3080908624754918, \"pred\": 0}, {\"x\": 1.2022930609701978, \"y\": 2.3357265984452713, \"pred\": 1}, {\"x\": -0.15579970816999872, \"y\": -1.4634777566193453, \"pred\": 0}, {\"x\": -0.9626608287669728, \"y\": -0.7013680441849037, \"pred\": 0}, {\"x\": 0.7435452461317569, \"y\": -0.6625811650314397, \"pred\": 0}, {\"x\": 0.1406138453747909, \"y\": 0.019892207578106016, \"pred\": 0}, {\"x\": 1.7405406203764353, \"y\": 3.3756491396961157, \"pred\": 1}, {\"x\": 0.636539037502539, \"y\": 2.2014015005452823, \"pred\": 1}, {\"x\": 0.8624014081512591, \"y\": 0.5232452162507775, \"pred\": 0}, {\"x\": -0.025645745936127125, \"y\": -0.9590398006025731, \"pred\": 0}, {\"x\": -0.11723949907063196, \"y\": 1.100836264556602, \"pred\": 0}, {\"x\": 2.3927390062646094, \"y\": 0.18548973091234577, \"pred\": 1}, {\"x\": -0.19422133384463808, \"y\": 0.5877885293013254, \"pred\": 0}, {\"x\": -0.2918113875232261, \"y\": 0.12677274472597902, \"pred\": 0}, {\"x\": -1.3825474846365924, \"y\": 0.23254262542334578, \"pred\": 0}, {\"x\": 0.6558615323233493, \"y\": -0.22467908543381457, \"pred\": 0}, {\"x\": 3.870349907724047, \"y\": 3.1109274374798166, \"pred\": 1}, {\"x\": 0.9528306110451948, \"y\": -1.0871815907509188, \"pred\": 0}, {\"x\": -0.4371456556814915, \"y\": 0.5479183096073379, \"pred\": 0}, {\"x\": -0.16127395672832917, \"y\": 0.44951651436299817, \"pred\": 0}, {\"x\": 2.997813029717478, \"y\": 3.231244588814504, \"pred\": 1}, {\"x\": 2.2250075222163606, \"y\": 0.4688637055535052, \"pred\": 1}, {\"x\": 1.853407493274361, \"y\": 2.078487613593274, \"pred\": 1}, {\"x\": -0.7709685285300425, \"y\": -0.41395371382728313, \"pred\": 0}, {\"x\": 0.6129550677145995, \"y\": 0.23966318182680454, \"pred\": 0}, {\"x\": 2.3005952863784875, \"y\": 1.0472838605961088, \"pred\": 1}, {\"x\": 1.436570669708498, \"y\": -0.5795082893291696, \"pred\": 0}, {\"x\": -1.054657177172913, \"y\": -0.9776990052219913, \"pred\": 0}, {\"x\": 1.4798744615901476, \"y\": 1.7356680561833622, \"pred\": 1}, {\"x\": -1.9241594490929896, \"y\": -0.757453225587536, \"pred\": 0}, {\"x\": 2.1563577719221985, \"y\": 4.365673555946404, \"pred\": 1}, {\"x\": 0.7884285840121856, \"y\": 0.5685312896803145, \"pred\": 1}, {\"x\": 3.740933814341995, \"y\": -0.03556415619944708, \"pred\": 1}, {\"x\": 3.38509438533557, \"y\": 1.88933556101016, \"pred\": 1}, {\"x\": -2.4957528823141972, \"y\": 1.3043577797963937, \"pred\": 0}, {\"x\": 2.736058077736053, \"y\": 2.666016362052516, \"pred\": 1}, {\"x\": 1.592827313909267, \"y\": 3.621161963396762, \"pred\": 1}, {\"x\": 2.599269524155709, \"y\": 2.9696621383994226, \"pred\": 1}, {\"x\": 2.271330979002925, \"y\": 4.611365466501027, \"pred\": 1}, {\"x\": 1.2321130918482257, \"y\": 2.772256448671617, \"pred\": 1}, {\"x\": 4.199320450880061, \"y\": 2.7617220943402283, \"pred\": 1}, {\"x\": 4.438510067019951, \"y\": 1.9501456048622783, \"pred\": 1}, {\"x\": 0.9399792195744116, \"y\": 0.9506069961060607, \"pred\": 0}, {\"x\": 0.4403789105928676, \"y\": -0.8384801402483328, \"pred\": 0}, {\"x\": 1.8758843070900657, \"y\": 2.023663980551364, \"pred\": 1}, {\"x\": 1.227322247613268, \"y\": 2.7321707051874116, \"pred\": 1}, {\"x\": -0.3236790297502634, \"y\": -0.11145904212515595, \"pred\": 0}, {\"x\": 2.3338773158710833, \"y\": 2.173174617420775, \"pred\": 1}, {\"x\": 1.3896197630118723, \"y\": 1.8389429159103785, \"pred\": 1}, {\"x\": 1.2655617879171142, \"y\": 1.326472834693644, \"pred\": 1}, {\"x\": 2.6494568961145273, \"y\": 2.034031096576255, \"pred\": 1}, {\"x\": 2.0541840739491852, \"y\": 2.6806681362126463, \"pred\": 1}, {\"x\": 0.47518769779384906, \"y\": -0.07236315822392445, \"pred\": 0}, {\"x\": 1.556495068521696, \"y\": 0.7868004452776833, \"pred\": 1}, {\"x\": 2.4151904657340686, \"y\": 1.3817176162952216, \"pred\": 1}, {\"x\": 2.230402823356569, \"y\": 2.431946895391424, \"pred\": 1}, {\"x\": 0.337447649965678, \"y\": 3.190858387393793, \"pred\": 1}, {\"x\": 1.194687665488288, \"y\": 1.1558162413648083, \"pred\": 0}, {\"x\": -0.34921913811594835, \"y\": 0.843842055045005, \"pred\": 0}, {\"x\": 1.4207461108249517, \"y\": 2.576007496726984, \"pred\": 1}, {\"x\": 0.15647674659188437, \"y\": 0.20425480457441636, \"pred\": 0}, {\"x\": -0.911344781357355, \"y\": -0.7461352526666984, \"pred\": 0}, {\"x\": -0.0012405611429540924, \"y\": 0.08134367638997905, \"pred\": 0}, {\"x\": -0.1522965744944709, \"y\": 0.704626894626221, \"pred\": 0}, {\"x\": 3.178170580363296, \"y\": 1.7109649913220648, \"pred\": 1}, {\"x\": 0.2532205247585785, \"y\": 0.9407870683897978, \"pred\": 0}, {\"x\": 1.1790347434852069, \"y\": -1.0760914658121563, \"pred\": 0}, {\"x\": 0.18494595039221876, \"y\": -0.6510564789536804, \"pred\": 0}, {\"x\": 0.4076688308069256, \"y\": 2.32353471469165, \"pred\": 1}, {\"x\": 1.9642845933830628, \"y\": 3.0039302837615773, \"pred\": 1}, {\"x\": 1.4028588731444431, \"y\": 1.6045726106064209, \"pred\": 1}, {\"x\": 0.8893585338418935, \"y\": 3.717926200674824, \"pred\": 1}, {\"x\": 0.6367185907707327, \"y\": 1.6782942647037324, \"pred\": 1}, {\"x\": -1.0669628403806435, \"y\": 3.4011057189806557, \"pred\": 0}, {\"x\": 0.2673819755787573, \"y\": -1.0319348271510602, \"pred\": 0}, {\"x\": -1.7207954551375861, \"y\": 0.017982138806439393, \"pred\": 0}, {\"x\": 1.4267264504853654, \"y\": -0.048697610640109204, \"pred\": 0}, {\"x\": -0.057532387873538586, \"y\": 0.5646542880869975, \"pred\": 0}, {\"x\": 1.1950253748410917, \"y\": -1.4615058094923734, \"pred\": 0}, {\"x\": 3.068200909048942, \"y\": 3.9006478804863063, \"pred\": 1}, {\"x\": 0.7304710721169607, \"y\": 0.8996130611234683, \"pred\": 0}, {\"x\": 3.0082325821645153, \"y\": 1.1312706815969824, \"pred\": 1}, {\"x\": 4.208480738141941, \"y\": 2.5871061449468176, \"pred\": 1}, {\"x\": 1.3992384201681904, \"y\": -1.6151079632521659, \"pred\": 0}, {\"x\": 0.36003178759974036, \"y\": -0.43820143730669325, \"pred\": 0}, {\"x\": 2.5915110533990484, \"y\": -0.27102844335797016, \"pred\": 1}, {\"x\": 1.3204048067975092, \"y\": 0.04066528515761626, \"pred\": 0}, {\"x\": 0.4394946907472934, \"y\": 1.7672366043893282, \"pred\": 1}, {\"x\": 0.8486534061441413, \"y\": 1.4169071306933088, \"pred\": 1}, {\"x\": 0.9734403648680088, \"y\": 0.9335892631796991, \"pred\": 1}, {\"x\": -0.9738381295272108, \"y\": 0.8048850955179162, \"pred\": 0}, {\"x\": -0.7640339696578627, \"y\": 0.1012697856437548, \"pred\": 0}, {\"x\": 2.8617222068747257, \"y\": 3.849776385866146, \"pred\": 1}, {\"x\": 0.45053117920927527, \"y\": -0.49429864739786794, \"pred\": 0}, {\"x\": -0.7046047621786199, \"y\": 0.4553185270261121, \"pred\": 0}, {\"x\": 0.1486981280629037, \"y\": 1.4460230634069287, \"pred\": 1}, {\"x\": -1.41124263188717, \"y\": 1.2047437309657716, \"pred\": 0}, {\"x\": 0.4820872038580639, \"y\": 3.3317589492355393, \"pred\": 1}, {\"x\": 0.20156945957526934, \"y\": -0.1650355232064671, \"pred\": 0}, {\"x\": -0.14908830964479858, \"y\": 1.8005179738889225, \"pred\": 1}, {\"x\": 1.7941257462609899, \"y\": 1.0823176653816473, \"pred\": 1}, {\"x\": 1.9434940241593952, \"y\": 1.862979444034073, \"pred\": 1}, {\"x\": -0.4192603220087837, \"y\": 2.386745800499031, \"pred\": 0}, {\"x\": 1.5794502314089767, \"y\": 0.8872219039413722, \"pred\": 1}, {\"x\": -0.5534026175135522, \"y\": -0.24150531238917375, \"pred\": 0}, {\"x\": -1.01700202554413, \"y\": -0.5269892532991041, \"pred\": 0}, {\"x\": -1.9453906815188249, \"y\": 0.8309056578021413, \"pred\": 0}, {\"x\": -0.28410380510716565, \"y\": 0.15003366373872756, \"pred\": 0}, {\"x\": 1.9649289132456702, \"y\": 2.321508194455287, \"pred\": 1}, {\"x\": 0.9000849971172967, \"y\": 0.8890323725239309, \"pred\": 0}, {\"x\": -0.644619180730499, \"y\": -1.1702444249284003, \"pred\": 0}, {\"x\": 3.0737033225195978, \"y\": 2.9818520300440294, \"pred\": 1}, {\"x\": 0.2614395928205015, \"y\": 0.46893464927171374, \"pred\": 0}, {\"x\": -0.8444764142538497, \"y\": -0.5164428497021851, \"pred\": 0}, {\"x\": 1.3116180465656415, \"y\": -1.2548603914775587, \"pred\": 0}, {\"x\": -0.5334945027167617, \"y\": -1.9323560015091858, \"pred\": 0}, {\"x\": 1.1384956408918423, \"y\": 1.1258379535900915, \"pred\": 1}, {\"x\": 1.4786857374358966, \"y\": -1.0453771305385342, \"pred\": 0}, {\"x\": 0.7085245177855963, \"y\": -0.9824603525381572, \"pred\": 0}, {\"x\": -1.8552666603782968, \"y\": -0.11032172211623395, \"pred\": 0}, {\"x\": 0.015174920002897885, \"y\": 0.117052488790469, \"pred\": 0}, {\"x\": 1.3823109341357713, \"y\": 1.3211814156031616, \"pred\": 1}, {\"x\": -1.055658897711565, \"y\": -0.308375994286531, \"pred\": 0}, {\"x\": 0.3650517980270081, \"y\": -0.04520588860236072, \"pred\": 0}, {\"x\": 2.6125269393847117, \"y\": 3.085007239316771, \"pred\": 1}, {\"x\": 3.3363234842354315, \"y\": 1.605563899655047, \"pred\": 1}, {\"x\": -0.6779772552780428, \"y\": 0.1106188085540423, \"pred\": 0}, {\"x\": -0.5361687068333683, \"y\": -2.6939563172399312, \"pred\": 0}, {\"x\": -0.7889890249515489, \"y\": -1.261605945319069, \"pred\": 0}, {\"x\": -0.38445768500357647, \"y\": -0.530327407582726, \"pred\": 0}, {\"x\": 0.41730231988738953, \"y\": 0.26955855330903167, \"pred\": 0}, {\"x\": -0.7320583853311774, \"y\": 0.5751509658063075, \"pred\": 0}, {\"x\": 2.226690771658064, \"y\": 2.311882011998303, \"pred\": 1}, {\"x\": -0.19163168438548278, \"y\": 0.4838288394495532, \"pred\": 0}, {\"x\": 1.9680077421958235, \"y\": 3.0527207346654532, \"pred\": 1}, {\"x\": -1.81842142065901, \"y\": 0.05569219339294779, \"pred\": 0}, {\"x\": 2.4473251505619094, \"y\": 1.1594630002615673, \"pred\": 1}, {\"x\": 1.8050515828561202, \"y\": 1.6736370209291347, \"pred\": 1}, {\"x\": 1.214463504631698, \"y\": 2.034938838643822, \"pred\": 1}, {\"x\": 1.8351757766163321, \"y\": 1.7021931993107415, \"pred\": 1}, {\"x\": 3.325466891523719, \"y\": 3.3007610258555466, \"pred\": 1}, {\"x\": 0.44080738731842145, \"y\": -1.812024553173441, \"pred\": 0}, {\"x\": 0.6070648197036337, \"y\": 2.3086244961655735, \"pred\": 1}, {\"x\": -2.3269262116155196, \"y\": -0.4158113660344991, \"pred\": 0}, {\"x\": -0.4654414831035872, \"y\": 0.4004773841168456, \"pred\": 0}, {\"x\": 1.0784289197973278, \"y\": 2.3187895017249587, \"pred\": 1}, {\"x\": 2.428214351090788, \"y\": 2.229010774428565, \"pred\": 1}, {\"x\": 2.300842716403956, \"y\": 2.1974559832484015, \"pred\": 1}, {\"x\": -0.19651664300377936, \"y\": -0.2648908941443411, \"pred\": 0}, {\"x\": 1.6069637071946876, \"y\": 1.429133723362852, \"pred\": 1}, {\"x\": -0.8732591793851744, \"y\": 0.5560180812944249, \"pred\": 0}, {\"x\": 3.853505633543313, \"y\": 3.1507460321250718, \"pred\": 1}, {\"x\": 0.12730328020698067, \"y\": 2.1503829673811126, \"pred\": 1}, {\"x\": 0.35953229551797367, \"y\": -0.511965094194221, \"pred\": 0}, {\"x\": 3.4465143940508334, \"y\": 5.101863538312319, \"pred\": 1}, {\"x\": 0.8579051809684236, \"y\": 0.40976548500449694, \"pred\": 0}, {\"x\": 0.37467317185190585, \"y\": 3.15456589083811, \"pred\": 1}, {\"x\": 1.3406793435446662, \"y\": 1.466546252991804, \"pred\": 1}, {\"x\": 1.4609918659634333, \"y\": 2.0542065312864928, \"pred\": 1}, {\"x\": 0.7420478267454842, \"y\": 1.1114411280385852, \"pred\": 0}, {\"x\": -0.41998581004543123, \"y\": -0.0285337341330573, \"pred\": 0}, {\"x\": 1.8462176390292164, \"y\": 1.0886226105354244, \"pred\": 1}, {\"x\": 0.48039822370628693, \"y\": 2.669508434914504, \"pred\": 1}, {\"x\": -0.5465767417188724, \"y\": 0.29202648981800744, \"pred\": 0}, {\"x\": 0.9962094669993536, \"y\": -0.04995254339686802, \"pred\": 0}, {\"x\": 0.8971332024654173, \"y\": 1.544007515956213, \"pred\": 1}, {\"x\": 2.506356748813186, \"y\": 2.016462481587103, \"pred\": 1}, {\"x\": 0.7133254192320697, \"y\": -0.9466364609859, \"pred\": 0}, {\"x\": 1.2040703250429852, \"y\": 1.3470353682509972, \"pred\": 1}, {\"x\": -1.0526677980507988, \"y\": -0.5586105579100125, \"pred\": 0}, {\"x\": -0.44151223119024857, \"y\": 0.9552466924396553, \"pred\": 0}, {\"x\": 1.6399277115282798, \"y\": 1.5146525907585886, \"pred\": 1}, {\"x\": -1.469634625209567, \"y\": -0.1463693097462854, \"pred\": 0}, {\"x\": 1.0525318150652148, \"y\": -1.5340965702283584, \"pred\": 0}, {\"x\": -1.639093411201915, \"y\": -0.27813451650877447, \"pred\": 0}, {\"x\": 2.135946763233126, \"y\": 2.247660788661511, \"pred\": 1}, {\"x\": 3.8522909678430186, \"y\": 2.3281097780522138, \"pred\": 1}, {\"x\": 3.3594580312665707, \"y\": 1.3844667369168193, \"pred\": 1}, {\"x\": 1.5892922570199843, \"y\": 4.30578448459959, \"pred\": 1}, {\"x\": -2.233052848438117, \"y\": 0.14202678794857176, \"pred\": 0}, {\"x\": 2.429672594447642, \"y\": 2.042853859669679, \"pred\": 1}, {\"x\": 0.9728507916505504, \"y\": 2.6075086014714084, \"pred\": 1}, {\"x\": 2.842312886127444, \"y\": 1.3091502290657346, \"pred\": 1}, {\"x\": -0.06434314961587694, \"y\": 0.7387144235342626, \"pred\": 0}, {\"x\": 0.3487505938690223, \"y\": -0.3386182541020083, \"pred\": 0}, {\"x\": 3.0222386729565907, \"y\": 3.4916874624264516, \"pred\": 1}, {\"x\": -0.45896716822932365, \"y\": 1.1515287731761275, \"pred\": 0}, {\"x\": 0.23082017281823, \"y\": 0.5467579110457865, \"pred\": 0}, {\"x\": 0.6062886568962988, \"y\": -0.026771649986440726, \"pred\": 0}, {\"x\": -0.5956856051072797, \"y\": 0.7958769911591804, \"pred\": 0}, {\"x\": 2.115737227318506, \"y\": 0.36735386905122724, \"pred\": 1}, {\"x\": -0.2642474112620271, \"y\": -0.9323592637202481, \"pred\": 0}, {\"x\": -1.6003841181528236, \"y\": -0.22205672759554324, \"pred\": 0}, {\"x\": 1.3303169236725105, \"y\": -0.6575172676978901, \"pred\": 0}, {\"x\": 3.1000197097589526, \"y\": 4.801153155014196, \"pred\": 1}, {\"x\": -0.928335225810039, \"y\": -0.7746600331288077, \"pred\": 0}, {\"x\": 2.8223656402267268, \"y\": 3.4418656691638247, \"pred\": 1}, {\"x\": 0.946348007431648, \"y\": 0.39254793773535773, \"pred\": 0}, {\"x\": 1.2690580976875576, \"y\": 0.2572490050399525, \"pred\": 0}, {\"x\": 2.032226881139099, \"y\": 4.567122577428944, \"pred\": 1}, {\"x\": -1.220671903715444, \"y\": -0.565046518309226, \"pred\": 0}, {\"x\": 1.1621877051255987, \"y\": 2.8309427428150205, \"pred\": 1}, {\"x\": 1.985355394382256, \"y\": 0.5389091609733734, \"pred\": 1}, {\"x\": 0.9137407048596775, \"y\": 0.31735092273633597, \"pred\": 0}, {\"x\": 3.147812051000587, \"y\": 1.154813468270937, \"pred\": 1}, {\"x\": 1.3978022435984774, \"y\": 1.8396679985237319, \"pred\": 1}, {\"x\": -1.5120214739877849, \"y\": 0.4446977161029871, \"pred\": 0}, {\"x\": 0.1549035962020594, \"y\": 0.277836156413196, \"pred\": 0}, {\"x\": 2.360380445279691, \"y\": 3.368154875156878, \"pred\": 1}, {\"x\": 0.11163027156564224, \"y\": 0.2829905076675621, \"pred\": 0}, {\"x\": 0.1687210624313978, \"y\": -1.4889501692875957, \"pred\": 0}, {\"x\": 0.9118946811654338, \"y\": 2.551469174853076, \"pred\": 1}, {\"x\": 0.747371595544824, \"y\": 1.075681534164297, \"pred\": 0}, {\"x\": 1.2571257313814808, \"y\": 0.18248209713031777, \"pred\": 0}, {\"x\": -0.7574771053093196, \"y\": -0.5108262341824535, \"pred\": 0}, {\"x\": -0.16240072992892313, \"y\": 1.3391315836256719, \"pred\": 0}, {\"x\": 1.0712974056744988, \"y\": 2.124654858947829, \"pred\": 1}, {\"x\": -0.018421809137576996, \"y\": 0.10767464455391365, \"pred\": 0}, {\"x\": 0.5467334374800554, \"y\": 0.750423475071857, \"pred\": 1}, {\"x\": -0.19380492240705713, \"y\": 1.5666402273744786, \"pred\": 0}, {\"x\": 2.3104323874656347, \"y\": 0.22399592783418343, \"pred\": 1}, {\"x\": 0.45348104026746144, \"y\": 0.9223441482568703, \"pred\": 0}, {\"x\": 2.2487456886625603, \"y\": 1.7232575132248926, \"pred\": 1}, {\"x\": -0.33240947257420594, \"y\": 2.0921686012929617, \"pred\": 0}, {\"x\": 0.9929491259546886, \"y\": -0.6437970571220203, \"pred\": 0}, {\"x\": 0.2676098967321498, \"y\": 0.8784598910238555, \"pred\": 0}, {\"x\": 0.9450577461588743, \"y\": 1.8378156974976747, \"pred\": 1}, {\"x\": 0.7571112741306737, \"y\": -1.2085723310812708, \"pred\": 0}, {\"x\": 2.095520834264214, \"y\": 2.3200664601730594, \"pred\": 1}, {\"x\": 0.5253295997343811, \"y\": -1.2768778466596493, \"pred\": 0}, {\"x\": 0.7419006788952703, \"y\": -0.3519968223496652, \"pred\": 0}, {\"x\": -0.044503078338053455, \"y\": 0.45181233874578974, \"pred\": 0}, {\"x\": -0.7068190812919728, \"y\": -0.6861465851073458, \"pred\": 0}, {\"x\": -1.7385178655572635, \"y\": 0.5704933453211514, \"pred\": 0}, {\"x\": 2.998899886332779, \"y\": 0.634248698991208, \"pred\": 1}, {\"x\": 0.15420459268584072, \"y\": 0.8173055190310792, \"pred\": 0}, {\"x\": -1.9774177085108056, \"y\": 2.2386487591829325, \"pred\": 0}, {\"x\": 1.5013438169373443, \"y\": 1.6045531391802799, \"pred\": 1}, {\"x\": -0.2324258720274623, \"y\": 0.7109747948581455, \"pred\": 0}, {\"x\": 2.0551775521900577, \"y\": 2.4190681047807843, \"pred\": 1}, {\"x\": -1.6642564360602479, \"y\": -0.1217464334245328, \"pred\": 0}, {\"x\": -0.23181317888607783, \"y\": -0.1165749870881772, \"pred\": 0}, {\"x\": 3.415864945921144, \"y\": 0.5329883064330754, \"pred\": 1}, {\"x\": -0.407616632784632, \"y\": -0.668307894421939, \"pred\": 0}, {\"x\": 1.7477370760676236, \"y\": 1.20634705787289, \"pred\": 1}, {\"x\": 1.2751258373944747, \"y\": 0.4609946505605043, \"pred\": 0}, {\"x\": 0.31244125715700677, \"y\": 0.21920844617560786, \"pred\": 1}, {\"x\": 0.20522091485414617, \"y\": -0.045963992111946794, \"pred\": 1}, {\"x\": 1.4063603231723563, \"y\": 2.9410600435834002, \"pred\": 1}, {\"x\": 0.5628467852810314, \"y\": -0.24332625188556253, \"pred\": 0}, {\"x\": 0.5011676877836018, \"y\": 0.9199851312920041, \"pred\": 0}, {\"x\": 0.017446916303085782, \"y\": -0.7200583582807348, \"pred\": 0}, {\"x\": -0.3848490502028002, \"y\": -1.5509569211976624, \"pred\": 0}, {\"x\": 2.5005989239578374, \"y\": 1.6544858315564697, \"pred\": 1}, {\"x\": 2.208494645965929, \"y\": 0.9483154856821232, \"pred\": 1}, {\"x\": -0.5351833981652417, \"y\": 0.8683775099508642, \"pred\": 0}, {\"x\": -0.8541429534648363, \"y\": 0.46565797200403236, \"pred\": 0}, {\"x\": 2.5920840674002923, \"y\": 0.37476811336909965, \"pred\": 1}, {\"x\": 3.0388537536498363, \"y\": 1.1822453985407702, \"pred\": 1}, {\"x\": 2.0709735272198517, \"y\": 1.7885843905817853, \"pred\": 1}, {\"x\": 0.35021313455542263, \"y\": 0.47347563519013397, \"pred\": 0}, {\"x\": 0.8917941660323877, \"y\": -1.5390641198540729, \"pred\": 0}, {\"x\": -0.1452113325860197, \"y\": 0.23785783828501061, \"pred\": 0}, {\"x\": -2.2068670954994913, \"y\": -0.4031289968469349, \"pred\": 0}, {\"x\": -0.6359031894503993, \"y\": 0.1997790971313106, \"pred\": 0}, {\"x\": 2.9898112579100316, \"y\": 2.8909152648111034, \"pred\": 1}, {\"x\": -0.01335974789092953, \"y\": 1.2355527522919023, \"pred\": 1}, {\"x\": -0.5083432327925071, \"y\": -0.6862364377992013, \"pred\": 0}, {\"x\": 0.6398839732802036, \"y\": 2.0536932362953815, \"pred\": 0}, {\"x\": 2.5461421558243416, \"y\": 1.2625939497950327, \"pred\": 1}, {\"x\": 1.3052737165412949, \"y\": 4.091883216971763, \"pred\": 1}, {\"x\": 0.9901299572529987, \"y\": 2.0749485504359404, \"pred\": 1}, {\"x\": 0.38411581154380325, \"y\": 1.4122345812397805, \"pred\": 1}, {\"x\": 3.0697263031814166, \"y\": -0.2804598261590847, \"pred\": 1}, {\"x\": 0.35136152893488404, \"y\": 0.788570479116926, \"pred\": 0}, {\"x\": 0.7659110492252689, \"y\": 0.20780005335113885, \"pred\": 0}, {\"x\": 2.2009639538279697, \"y\": 1.272294725099329, \"pred\": 1}, {\"x\": 3.7868569004388535, \"y\": 1.6714447664628662, \"pred\": 1}, {\"x\": 1.6961871140730036, \"y\": 2.699506870262244, \"pred\": 1}, {\"x\": 0.542544026931158, \"y\": 0.6261672937955176, \"pred\": 1}, {\"x\": -0.557684623006479, \"y\": -0.9570655488171265, \"pred\": 0}, {\"x\": 2.1800817394030765, \"y\": 0.37012151528707427, \"pred\": 1}, {\"x\": 2.0854556487772595, \"y\": 3.136275128464981, \"pred\": 1}, {\"x\": 2.3056068400458085, \"y\": 2.3978884495586614, \"pred\": 1}, {\"x\": 2.170329118452739, \"y\": -0.0334652980293213, \"pred\": 1}, {\"x\": -1.0942595125916925, \"y\": 1.982925182595953, \"pred\": 0}, {\"x\": 0.3532107803002698, \"y\": -0.8912937922772961, \"pred\": 0}, {\"x\": 1.3149422380864075, \"y\": 1.8490054305793169, \"pred\": 1}, {\"x\": 0.49223250052885703, \"y\": 1.7253989475688583, \"pred\": 1}, {\"x\": 2.009512655017796, \"y\": 3.5201334154397417, \"pred\": 1}, {\"x\": 1.9980452901555539, \"y\": 2.303724390568587, \"pred\": 1}, {\"x\": 2.5723636214743255, \"y\": 0.7736503599904248, \"pred\": 1}, {\"x\": 1.4844656543417931, \"y\": 2.992559756677755, \"pred\": 1}, {\"x\": 1.9917624296046446, \"y\": 1.679432402454359, \"pred\": 1}, {\"x\": 2.855678786912586, \"y\": 2.292225674252774, \"pred\": 1}, {\"x\": 3.683495929813405, \"y\": 1.3855166043567386, \"pred\": 1}, {\"x\": 1.186979048375644, \"y\": 2.797672569082689, \"pred\": 1}, {\"x\": -1.4141544662915098, \"y\": 0.12673002941390707, \"pred\": 0}, {\"x\": -1.0259108732843625, \"y\": 0.20581615250656984, \"pred\": 0}, {\"x\": 1.7712398465971424, \"y\": 1.481672243119422, \"pred\": 1}, {\"x\": 0.29164051076463826, \"y\": -0.3896555250433101, \"pred\": 0}, {\"x\": 2.7668504972793944, \"y\": 1.5704062429021668, \"pred\": 1}, {\"x\": 1.4739316414007817, \"y\": 2.1693502758148995, \"pred\": 1}, {\"x\": 1.3451017084510097, \"y\": 0.5323378882945463, \"pred\": 0}, {\"x\": 2.202473172070938, \"y\": 1.1927704745729666, \"pred\": 1}, {\"x\": 0.1364330425598168, \"y\": 1.6547766001068898, \"pred\": 1}, {\"x\": 3.7281893840230502, \"y\": 1.1457280642521839, \"pred\": 1}, {\"x\": -0.9841607817725814, \"y\": 1.190705272505982, \"pred\": 0}, {\"x\": 3.052333378588207, \"y\": 1.5469353257425968, \"pred\": 1}, {\"x\": 1.1757285420219539, \"y\": 0.7078651140198504, \"pred\": 1}, {\"x\": 1.8188436537188366, \"y\": -0.0552061713027614, \"pred\": 1}, {\"x\": 3.7848212310913274, \"y\": 1.8713978097811776, \"pred\": 1}, {\"x\": -1.1527257504517598, \"y\": -0.913446285204153, \"pred\": 0}, {\"x\": 1.8260275987189714, \"y\": 0.6650746330128983, \"pred\": 1}, {\"x\": 0.2283352044566521, \"y\": -0.6753750576188053, \"pred\": 0}, {\"x\": 2.4276671452734377, \"y\": 1.793206065362875, \"pred\": 1}, {\"x\": 2.7702785657932285, \"y\": 0.6327607703571645, \"pred\": 1}, {\"x\": 0.9630313786660784, \"y\": -1.9278777352364316, \"pred\": 0}, {\"x\": -0.6191847305942658, \"y\": 1.2125948226530212, \"pred\": 0}, {\"x\": -0.08809626952746996, \"y\": -0.36184796336959735, \"pred\": 0}, {\"x\": 3.723386352013055, \"y\": 0.5734760719351109, \"pred\": 1}, {\"x\": -1.0835914658230943, \"y\": -0.0001493927548569246, \"pred\": 0}, {\"x\": 2.7546480021839517, \"y\": 0.8294406857458252, \"pred\": 1}, {\"x\": 3.548200204010281, \"y\": 1.4076847120803713, \"pred\": 1}, {\"x\": 2.2625682294037417, \"y\": 2.396449917961715, \"pred\": 1}, {\"x\": 1.6380195259704862, \"y\": 2.5114604025401603, \"pred\": 1}, {\"x\": 0.5022857779517222, \"y\": 0.839193535320577, \"pred\": 0}, {\"x\": 2.53313595254121, \"y\": 1.7073139503965051, \"pred\": 1}, {\"x\": -0.5231642148972904, \"y\": -0.48137141579474935, \"pred\": 0}, {\"x\": 1.9906249118224364, \"y\": 0.16605400369245205, \"pred\": 1}, {\"x\": 1.2144508157368235, \"y\": 1.9506801724468557, \"pred\": 1}, {\"x\": 2.534649634454772, \"y\": 0.1469932950896291, \"pred\": 1}, {\"x\": -0.3221236569774085, \"y\": -0.37011607810475444, \"pred\": 0}, {\"x\": 2.7531069136156465, \"y\": 1.4426703238756096, \"pred\": 1}, {\"x\": 1.842865943529341, \"y\": 1.9075822293664888, \"pred\": 1}, {\"x\": 0.8149954430712237, \"y\": -1.185418809153406, \"pred\": 0}, {\"x\": 0.21745165945019368, \"y\": 0.5143288551447859, \"pred\": 0}, {\"x\": 0.35033088498361975, \"y\": 1.8004397115563828, \"pred\": 1}, {\"x\": 1.0942750991001489, \"y\": 0.004613901175436712, \"pred\": 0}, {\"x\": -0.5338435604421259, \"y\": -0.07115124422410989, \"pred\": 0}, {\"x\": -0.4979713554723796, \"y\": 0.9384604688575977, \"pred\": 0}, {\"x\": 1.0172414890962727, \"y\": 0.5529783472619647, \"pred\": 1}, {\"x\": 0.489805675723485, \"y\": 1.3007227251380344, \"pred\": 1}, {\"x\": -0.3148580761325759, \"y\": -0.42989708186880404, \"pred\": 0}, {\"x\": 4.221653853655571, \"y\": 1.8180194889356027, \"pred\": 1}, {\"x\": 3.4145035166500803, \"y\": 1.4537352027795598, \"pred\": 1}, {\"x\": 0.07299114797407072, \"y\": -0.24006071463865328, \"pred\": 0}, {\"x\": -0.9802743185258672, \"y\": -0.002389025600514556, \"pred\": 0}, {\"x\": 1.9176476860844183, \"y\": 0.8990088769612876, \"pred\": 1}, {\"x\": -0.15170019141369395, \"y\": -1.2368377011017966, \"pred\": 0}, {\"x\": 0.9995238627794718, \"y\": 0.33912166991349607, \"pred\": 0}, {\"x\": 2.7971698357380883, \"y\": 0.4284961677589696, \"pred\": 1}, {\"x\": 0.3303022703226134, \"y\": 1.2795087343766578, \"pred\": 0}, {\"x\": 0.6793203874098627, \"y\": 2.4897075316883863, \"pred\": 0}, {\"x\": 3.1801316897135203, \"y\": -0.0025192964192513045, \"pred\": 1}, {\"x\": 0.49087183250951594, \"y\": 1.8927422187767202, \"pred\": 1}, {\"x\": 2.823953492083943, \"y\": 1.8754466148450735, \"pred\": 1}, {\"x\": 0.40865864630465626, \"y\": -0.8677998149261569, \"pred\": 0}, {\"x\": 0.7998766732572836, \"y\": 0.6790266830356967, \"pred\": 0}, {\"x\": 3.16457816375343, \"y\": 2.5299278264194656, \"pred\": 1}, {\"x\": 3.0824789636044114, \"y\": 4.966250097193541, \"pred\": 1}, {\"x\": 1.1722774270578469, \"y\": 1.1490631884147902, \"pred\": 0}, {\"x\": 1.0369968080399357, \"y\": -1.3189645536049885, \"pred\": 0}, {\"x\": 3.7280110563709856, \"y\": 3.6421336258852905, \"pred\": 1}, {\"x\": 0.6386749234055078, \"y\": 0.17851926932176165, \"pred\": 1}, {\"x\": -0.7686270207784495, \"y\": 0.7291654706806434, \"pred\": 0}, {\"x\": 0.4006736681660438, \"y\": -0.764593898622952, \"pred\": 0}, {\"x\": 4.503354046947538, \"y\": 2.838073066693751, \"pred\": 1}, {\"x\": 2.9113751643607433, \"y\": 2.1412893173639698, \"pred\": 1}, {\"x\": 3.294056296712104, \"y\": -0.36469608065789894, \"pred\": 1}, {\"x\": 0.31287871866605876, \"y\": 0.13679032249522113, \"pred\": 0}, {\"x\": 0.5319765561553507, \"y\": -1.3703642428009506, \"pred\": 0}, {\"x\": 0.8672126651998152, \"y\": -0.5209590207114089, \"pred\": 0}, {\"x\": -0.5136792046662925, \"y\": -1.257253734973249, \"pred\": 0}, {\"x\": 2.7212519457943585, \"y\": 0.050249003899367484, \"pred\": 1}, {\"x\": 0.3972413264075336, \"y\": -1.5128451152607716, \"pred\": 0}, {\"x\": 2.531723565932997, \"y\": 2.239581604376858, \"pred\": 1}, {\"x\": -1.830354023073999, \"y\": 0.6019355688249879, \"pred\": 0}, {\"x\": 1.9452558917173377, \"y\": 0.3598283935608044, \"pred\": 1}, {\"x\": 0.7622308225590424, \"y\": -0.25251758817880776, \"pred\": 0}, {\"x\": 1.4977015999604872, \"y\": 0.6446988633003452, \"pred\": 0}, {\"x\": 0.6598257388547495, \"y\": 3.6128983277731725, \"pred\": 1}, {\"x\": 2.0945008750379053, \"y\": 1.267184830290836, \"pred\": 1}, {\"x\": 1.717175959710519, \"y\": 0.7778483925521874, \"pred\": 0}, {\"x\": 2.328566455889293, \"y\": 0.7208853070121146, \"pred\": 1}, {\"x\": 2.921435479755555, \"y\": 1.7071197902880657, \"pred\": 1}, {\"x\": -3.210430797268423, \"y\": 0.4777660895774647, \"pred\": 0}, {\"x\": 1.564791953399383, \"y\": 2.3255322669728162, \"pred\": 1}, {\"x\": 1.0441306350285604, \"y\": 2.1003552832079437, \"pred\": 1}, {\"x\": 1.4992193438668884, \"y\": 4.04414288098479, \"pred\": 1}, {\"x\": 1.749241790081012, \"y\": 0.5011372949374676, \"pred\": 0}, {\"x\": 3.3974402689876415, \"y\": 2.5031037927644775, \"pred\": 1}, {\"x\": 2.379428273695179, \"y\": 2.3775040758320616, \"pred\": 1}, {\"x\": 2.836948426757939, \"y\": 1.1309460946801244, \"pred\": 1}, {\"x\": 0.4349760219816502, \"y\": 0.7588944642911625, \"pred\": 0}, {\"x\": 0.3902203816463774, \"y\": 3.4041647200248475, \"pred\": 1}, {\"x\": 1.1097851050648244, \"y\": 2.856810097997084, \"pred\": 1}, {\"x\": -0.882490391596822, \"y\": -0.6606324986051187, \"pred\": 0}, {\"x\": -0.3051810275934747, \"y\": 0.041447402165011596, \"pred\": 0}, {\"x\": 2.7287649446028355, \"y\": 0.6998183159944318, \"pred\": 1}, {\"x\": -2.236053777261358, \"y\": 0.5833276501518617, \"pred\": 0}, {\"x\": 0.7547050088790299, \"y\": -0.7598847788231394, \"pred\": 0}, {\"x\": -1.247336156644393, \"y\": 0.31717096074155054, \"pred\": 0}, {\"x\": 3.3984769733544002, \"y\": 1.787254142967087, \"pred\": 1}, {\"x\": -0.0051374179562285, \"y\": -0.15956287406705108, \"pred\": 0}, {\"x\": 0.6353546579819151, \"y\": 1.8771104516000663, \"pred\": 1}, {\"x\": 0.5451054177509091, \"y\": 1.3168720121050563, \"pred\": 1}, {\"x\": 0.6586660668217251, \"y\": 1.0461644964376338, \"pred\": 0}, {\"x\": 1.6601644225247327, \"y\": 1.1558746731720393, \"pred\": 1}, {\"x\": 0.6609032917196628, \"y\": 0.8224723016354284, \"pred\": 0}, {\"x\": -0.8135337616981977, \"y\": -0.935955221598663, \"pred\": 0}, {\"x\": -0.030667987475674858, \"y\": -0.8814625655313383, \"pred\": 0}]}}, {\"mode\": \"vega-lite\"});\n",
       "</script>"
      ],
      "text/plain": [
       "alt.Chart(...)"
      ]
     },
     "execution_count": 19,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "make_chart(clf, X)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Notice how much more these numbers suggest overfitting: the score is significantly better (i.e., larger) on the training set, and the loss is significantly better (i.e., smaller) on the training set.  There is no precise meaning here to \"significantly better\", but if you compare these numbers to the numbers with 3 leaf nodes, I think you'll see a big difference."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 21,
   "metadata": {
    "cell_id": "567b9b0e0da140049b2b2cc1a98706ae",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 4651,
    "execution_start": 1669054568655,
    "source_hash": "6092154",
    "tags": []
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " \n",
      "Train score: 98.9%\n",
      "Test score: 92.0%\n",
      "Train log loss: 0.034770278973321876\n",
      "Test log loss: 2.123777374229206\n",
      "\n"
     ]
    }
   ],
   "source": [
    "print(f''' \n",
    "Train score: {clf.score(X_train, y_train):.1%}\n",
    "Test score: {clf.score(X_test, y_test):.1%}\n",
    "Train log loss: {log_loss(y_train, clf.predict_proba(X_train))}\n",
    "Test log loss: {log_loss(y_test, clf.predict_proba(X_test))}\n",
    "''')"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "cell_id": "cb4c5ba98fab4caba7ed22d6ea3dd760",
    "deepnote_cell_type": "markdown",
    "tags": []
   },
   "source": [
    "## A random forest for the above data\n",
    "\n",
    "* A random forest is made up of multiple decision trees; the keyword argument `n_estimators` determins how many trees to use.\n",
    "* If we were to fit many trees using the same parameters and data, they would all look very similar.  The trick with random forests is that when we call `rfc.fit(X_train, y_train)`, the individual trees are fit using different samples of `X_train` and `y_train` (different trees receive different samples).\n",
    "* Another source of randomness is to only allow splitting at certain features (columns) at each step.  That doesn't make as much sense with our data, which only has two columns, but for something like handwritten digits, which has 784 columns, it would make more sense, but we won't use that approach."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 22,
   "metadata": {
    "cell_id": "e4b9d3de5f244c519e1990b6564ecfd5",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 3,
    "execution_start": 1669054850432,
    "source_hash": "39ef4b5b",
    "tags": []
   },
   "outputs": [],
   "source": [
    "from sklearn.ensemble import RandomForestClassifier"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Random forests take many of the same keyword arguments as decision trees, like `max_leaf_nodes`, and also some extra arguments.  Here we are using `n_estimators=1000` to put 1000 trees into this random forest.  Each of the decision trees is restricted to having at most 28 leaves.  (I would usually use the variable name `rfc` for \"random forest classifier\", but here I am using `clf`, so that I can use the same f-string code as above.)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 24,
   "metadata": {
    "cell_id": "1d68ba74e2fd4a2280387a83393c906c",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 1,
    "execution_start": 1669054936272,
    "source_hash": "40901718",
    "tags": []
   },
   "outputs": [],
   "source": [
    "clf = RandomForestClassifier(n_estimators=1000, max_leaf_nodes=28)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Once we have our random forest classifier, we can do fitting and prediction just like for other supervised machine learning models in scikit-learn."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 25,
   "metadata": {
    "cell_id": "1ec1e72a8e9046008e1c636c4c5b32e9",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 1583,
    "execution_start": 1669054979113,
    "source_hash": "e7844c31",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<style>#sk-container-id-3 {color: black;background-color: white;}#sk-container-id-3 pre{padding: 0;}#sk-container-id-3 div.sk-toggleable {background-color: white;}#sk-container-id-3 label.sk-toggleable__label {cursor: pointer;display: block;width: 100%;margin-bottom: 0;padding: 0.3em;box-sizing: border-box;text-align: center;}#sk-container-id-3 label.sk-toggleable__label-arrow:before {content: \"▸\";float: left;margin-right: 0.25em;color: #696969;}#sk-container-id-3 label.sk-toggleable__label-arrow:hover:before {color: black;}#sk-container-id-3 div.sk-estimator:hover label.sk-toggleable__label-arrow:before {color: black;}#sk-container-id-3 div.sk-toggleable__content {max-height: 0;max-width: 0;overflow: hidden;text-align: left;background-color: #f0f8ff;}#sk-container-id-3 div.sk-toggleable__content pre {margin: 0.2em;color: black;border-radius: 0.25em;background-color: #f0f8ff;}#sk-container-id-3 input.sk-toggleable__control:checked~div.sk-toggleable__content {max-height: 200px;max-width: 100%;overflow: auto;}#sk-container-id-3 input.sk-toggleable__control:checked~label.sk-toggleable__label-arrow:before {content: \"▾\";}#sk-container-id-3 div.sk-estimator input.sk-toggleable__control:checked~label.sk-toggleable__label {background-color: #d4ebff;}#sk-container-id-3 div.sk-label input.sk-toggleable__control:checked~label.sk-toggleable__label {background-color: #d4ebff;}#sk-container-id-3 input.sk-hidden--visually {border: 0;clip: rect(1px 1px 1px 1px);clip: rect(1px, 1px, 1px, 1px);height: 1px;margin: -1px;overflow: hidden;padding: 0;position: absolute;width: 1px;}#sk-container-id-3 div.sk-estimator {font-family: monospace;background-color: #f0f8ff;border: 1px dotted black;border-radius: 0.25em;box-sizing: border-box;margin-bottom: 0.5em;}#sk-container-id-3 div.sk-estimator:hover {background-color: #d4ebff;}#sk-container-id-3 div.sk-parallel-item::after {content: \"\";width: 100%;border-bottom: 1px solid gray;flex-grow: 1;}#sk-container-id-3 div.sk-label:hover label.sk-toggleable__label {background-color: #d4ebff;}#sk-container-id-3 div.sk-serial::before {content: \"\";position: absolute;border-left: 1px solid gray;box-sizing: border-box;top: 0;bottom: 0;left: 50%;z-index: 0;}#sk-container-id-3 div.sk-serial {display: flex;flex-direction: column;align-items: center;background-color: white;padding-right: 0.2em;padding-left: 0.2em;position: relative;}#sk-container-id-3 div.sk-item {position: relative;z-index: 1;}#sk-container-id-3 div.sk-parallel {display: flex;align-items: stretch;justify-content: center;background-color: white;position: relative;}#sk-container-id-3 div.sk-item::before, #sk-container-id-3 div.sk-parallel-item::before {content: \"\";position: absolute;border-left: 1px solid gray;box-sizing: border-box;top: 0;bottom: 0;left: 50%;z-index: -1;}#sk-container-id-3 div.sk-parallel-item {display: flex;flex-direction: column;z-index: 1;position: relative;background-color: white;}#sk-container-id-3 div.sk-parallel-item:first-child::after {align-self: flex-end;width: 50%;}#sk-container-id-3 div.sk-parallel-item:last-child::after {align-self: flex-start;width: 50%;}#sk-container-id-3 div.sk-parallel-item:only-child::after {width: 0;}#sk-container-id-3 div.sk-dashed-wrapped {border: 1px dashed gray;margin: 0 0.4em 0.5em 0.4em;box-sizing: border-box;padding-bottom: 0.4em;background-color: white;}#sk-container-id-3 div.sk-label label {font-family: monospace;font-weight: bold;display: inline-block;line-height: 1.2em;}#sk-container-id-3 div.sk-label-container {text-align: center;}#sk-container-id-3 div.sk-container {/* jupyter's `normalize.less` sets `[hidden] { display: none; }` but bootstrap.min.css set `[hidden] { display: none !important; }` so we also need the `!important` here to be able to override the default hidden behavior on the sphinx rendered scikit-learn.org. See: https://github.com/scikit-learn/scikit-learn/issues/21755 */display: inline-block !important;position: relative;}#sk-container-id-3 div.sk-text-repr-fallback {display: none;}</style><div id=\"sk-container-id-3\" class=\"sk-top-container\"><div class=\"sk-text-repr-fallback\"><pre>RandomForestClassifier(max_leaf_nodes=28, n_estimators=1000)</pre><b>In a Jupyter environment, please rerun this cell to show the HTML representation or trust the notebook. <br />On GitHub, the HTML representation is unable to render, please try loading this page with nbviewer.org.</b></div><div class=\"sk-container\" hidden><div class=\"sk-item\"><div class=\"sk-estimator sk-toggleable\"><input class=\"sk-toggleable__control sk-hidden--visually\" id=\"sk-estimator-id-3\" type=\"checkbox\" checked><label for=\"sk-estimator-id-3\" class=\"sk-toggleable__label sk-toggleable__label-arrow\">RandomForestClassifier</label><div class=\"sk-toggleable__content\"><pre>RandomForestClassifier(max_leaf_nodes=28, n_estimators=1000)</pre></div></div></div></div></div>"
      ],
      "text/plain": [
       "RandomForestClassifier(max_leaf_nodes=28, n_estimators=1000)"
      ]
     },
     "execution_count": 25,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "clf.fit(X_train, y_train)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Here is the corresponding predictions.  Based on this chart alone, I would be worried about overfitting, but we will see below that overfitting has been reduced significantly from the decision tree example."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 26,
   "metadata": {
    "cell_id": "b22002eed436425bb548bfdf8b16a86d",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 1057,
    "execution_start": 1669054989052,
    "source_hash": "14535e27",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "\n",
       "<div id=\"altair-viz-77aa7d83decf427997df4a2d5b933b9c\"></div>\n",
       "<script type=\"text/javascript\">\n",
       "  var VEGA_DEBUG = (typeof VEGA_DEBUG == \"undefined\") ? {} : VEGA_DEBUG;\n",
       "  (function(spec, embedOpt){\n",
       "    let outputDiv = document.currentScript.previousElementSibling;\n",
       "    if (outputDiv.id !== \"altair-viz-77aa7d83decf427997df4a2d5b933b9c\") {\n",
       "      outputDiv = document.getElementById(\"altair-viz-77aa7d83decf427997df4a2d5b933b9c\");\n",
       "    }\n",
       "    const paths = {\n",
       "      \"vega\": \"https://cdn.jsdelivr.net/npm//vega@5?noext\",\n",
       "      \"vega-lib\": \"https://cdn.jsdelivr.net/npm//vega-lib?noext\",\n",
       "      \"vega-lite\": \"https://cdn.jsdelivr.net/npm//vega-lite@4.17.0?noext\",\n",
       "      \"vega-embed\": \"https://cdn.jsdelivr.net/npm//vega-embed@6?noext\",\n",
       "    };\n",
       "\n",
       "    function maybeLoadScript(lib, version) {\n",
       "      var key = `${lib.replace(\"-\", \"\")}_version`;\n",
       "      return (VEGA_DEBUG[key] == version) ?\n",
       "        Promise.resolve(paths[lib]) :\n",
       "        new Promise(function(resolve, reject) {\n",
       "          var s = document.createElement('script');\n",
       "          document.getElementsByTagName(\"head\")[0].appendChild(s);\n",
       "          s.async = true;\n",
       "          s.onload = () => {\n",
       "            VEGA_DEBUG[key] = version;\n",
       "            return resolve(paths[lib]);\n",
       "          };\n",
       "          s.onerror = () => reject(`Error loading script: ${paths[lib]}`);\n",
       "          s.src = paths[lib];\n",
       "        });\n",
       "    }\n",
       "\n",
       "    function showError(err) {\n",
       "      outputDiv.innerHTML = `<div class=\"error\" style=\"color:red;\">${err}</div>`;\n",
       "      throw err;\n",
       "    }\n",
       "\n",
       "    function displayChart(vegaEmbed) {\n",
       "      vegaEmbed(outputDiv, spec, embedOpt)\n",
       "        .catch(err => showError(`Javascript Error: ${err.message}<br>This usually means there's a typo in your chart specification. See the javascript console for the full traceback.`));\n",
       "    }\n",
       "\n",
       "    if(typeof define === \"function\" && define.amd) {\n",
       "      requirejs.config({paths});\n",
       "      require([\"vega-embed\"], displayChart, err => showError(`Error loading script: ${err.message}`));\n",
       "    } else {\n",
       "      maybeLoadScript(\"vega\", \"5\")\n",
       "        .then(() => maybeLoadScript(\"vega-lite\", \"4.17.0\"))\n",
       "        .then(() => maybeLoadScript(\"vega-embed\", \"6\"))\n",
       "        .catch(showError)\n",
       "        .then(() => displayChart(vegaEmbed));\n",
       "    }\n",
       "  })({\"config\": {\"view\": {\"continuousWidth\": 400, \"continuousHeight\": 300}}, \"data\": {\"name\": \"data-bac277474aa331c8cb01422ca4185a84\"}, \"mark\": \"circle\", \"encoding\": {\"color\": {\"field\": \"pred\", \"type\": \"nominal\"}, \"x\": {\"field\": \"x\", \"type\": \"quantitative\"}, \"y\": {\"field\": \"y\", \"type\": \"quantitative\"}}, \"$schema\": \"https://vega.github.io/schema/vega-lite/v4.17.0.json\", \"datasets\": {\"data-bac277474aa331c8cb01422ca4185a84\": [{\"x\": 1.4559540371135231, \"y\": 1.2225321299541925, \"pred\": 1}, {\"x\": 0.14375578038446712, \"y\": 0.9051715331786675, \"pred\": 0}, {\"x\": -0.8670155109522104, \"y\": 0.3711592574799248, \"pred\": 0}, {\"x\": 2.236716247035387, \"y\": 1.7613912870250954, \"pred\": 1}, {\"x\": 1.2839076010237616, \"y\": 1.0493530134308715, \"pred\": 1}, {\"x\": 2.4119441266475636, \"y\": 0.8885655192985291, \"pred\": 1}, {\"x\": 0.6085923102841594, \"y\": -1.393525225748726, \"pred\": 0}, {\"x\": -0.5672394268341736, \"y\": -0.6847900441875194, \"pred\": 0}, {\"x\": 1.3396178056849557, \"y\": 2.444527547552682, \"pred\": 1}, {\"x\": 1.6036421369444245, \"y\": 2.9838660218731716, \"pred\": 1}, {\"x\": 3.2132364327523555, \"y\": 1.3270613788768748, \"pred\": 1}, {\"x\": 3.552345691172357, \"y\": 2.2096037598723535, \"pred\": 1}, {\"x\": 1.762714296497166, \"y\": -1.0740807545618982, \"pred\": 0}, {\"x\": -0.17830606215500272, \"y\": -1.5232135953524801, \"pred\": 0}, {\"x\": 2.765631512603937, \"y\": 2.902379378160018, \"pred\": 1}, {\"x\": 1.710537988461506, \"y\": 3.1701766375339, \"pred\": 1}, {\"x\": -0.20734969827652708, \"y\": -0.37591996120915105, \"pred\": 0}, {\"x\": 1.6145821893115024, \"y\": 2.9366532186221868, \"pred\": 1}, {\"x\": 1.9489926716237493, \"y\": 2.8234675712472987, \"pred\": 1}, {\"x\": 2.710041698724246, \"y\": 2.7724887435364485, \"pred\": 1}, {\"x\": 2.8662962472055105, \"y\": 2.2472179530453955, \"pred\": 1}, {\"x\": -1.2231117488973633, \"y\": 0.3685950822771125, \"pred\": 0}, {\"x\": 0.9425397724411325, \"y\": -0.5351465926388975, \"pred\": 0}, {\"x\": 1.8105902612798963, \"y\": 0.9911354587932695, \"pred\": 1}, {\"x\": 1.2750575903893269, \"y\": 1.2567430683363894, \"pred\": 0}, {\"x\": 1.8496125662057936, \"y\": -0.08165155616424355, \"pred\": 0}, {\"x\": 3.3474469652692624, \"y\": 2.2989958455256603, \"pred\": 1}, {\"x\": -0.404357671797137, \"y\": 1.5418077084686126, \"pred\": 0}, {\"x\": 1.3613709645591259, \"y\": -0.5226347611202428, \"pred\": 0}, {\"x\": 0.01997092245414585, \"y\": 0.8628168935353443, \"pred\": 0}, {\"x\": 3.1409091213318314, \"y\": 1.6155005913792657, \"pred\": 1}, {\"x\": 0.4531586132388156, \"y\": -0.33267577528589565, \"pred\": 0}, {\"x\": 0.014155839014434735, \"y\": 2.4057380021060357, \"pred\": 1}, {\"x\": -0.6209797023155086, \"y\": -0.4537523812416193, \"pred\": 0}, {\"x\": 0.8001528559058803, \"y\": 1.147309002011903, \"pred\": 0}, {\"x\": 0.7061888116045445, \"y\": 0.005043898069076926, \"pred\": 0}, {\"x\": 2.3728809703734113, \"y\": 0.7710822511106976, \"pred\": 1}, {\"x\": 0.9386034698816718, \"y\": -1.1466886495167958, \"pred\": 0}, {\"x\": -0.9041049314828216, \"y\": 0.7027533792191322, \"pred\": 0}, {\"x\": -0.10321862725194576, \"y\": -1.0790126956031663, \"pred\": 0}, {\"x\": -2.187115273247333, \"y\": 0.7219650574076287, \"pred\": 0}, {\"x\": 1.3503059959308692, \"y\": 2.0152208250443837, \"pred\": 0}, {\"x\": -0.5090008972919337, \"y\": 0.7718870234868406, \"pred\": 0}, {\"x\": 0.18070066767270676, \"y\": 2.2999911375745055, \"pred\": 1}, {\"x\": 2.453790011195825, \"y\": 1.363023132904219, \"pred\": 1}, {\"x\": 2.8140013785687983, \"y\": 2.1846723505590755, \"pred\": 1}, {\"x\": 1.360256947928347, \"y\": 2.015146597571547, \"pred\": 0}, {\"x\": 2.2460915770315415, \"y\": 2.7906135726951207, \"pred\": 1}, {\"x\": -1.6495595298995447, \"y\": 0.2754714469462586, \"pred\": 0}, {\"x\": 1.9008108222400648, \"y\": 1.1564180679309823, \"pred\": 1}, {\"x\": 2.664623054390154, \"y\": 4.004287815624176, \"pred\": 1}, {\"x\": -0.6871472120485602, \"y\": 1.8366742207237288, \"pred\": 0}, {\"x\": -0.34112117132031883, \"y\": 1.0898461110532707, \"pred\": 0}, {\"x\": -0.5778416564893406, \"y\": -0.8416715368715004, \"pred\": 0}, {\"x\": -0.31726597100271015, \"y\": 1.1383330474921514, \"pred\": 0}, {\"x\": -0.16224855290821893, \"y\": -1.0747468405930436, \"pred\": 0}, {\"x\": -0.7996871994715307, \"y\": -0.8446924471317016, \"pred\": 0}, {\"x\": 4.533515015693821, \"y\": 2.623685545416536, \"pred\": 1}, {\"x\": 0.35597848750624017, \"y\": 1.343515172028458, \"pred\": 1}, {\"x\": 1.4042924673121555, \"y\": 1.8165586817591046, \"pred\": 1}, {\"x\": 2.5540970339269764, \"y\": 2.4567176993334394, \"pred\": 1}, {\"x\": 0.8829763673845581, \"y\": 3.504528948312634, \"pred\": 1}, {\"x\": 1.9655603796185876, \"y\": 0.32512544079981365, \"pred\": 1}, {\"x\": -0.7209996734353815, \"y\": 0.5622617060581323, \"pred\": 0}, {\"x\": 2.039590841798837, \"y\": 3.4492266397277627, \"pred\": 1}, {\"x\": 0.44976720755395455, \"y\": -1.430396701578305, \"pred\": 0}, {\"x\": 1.7696665248700298, \"y\": 0.847425723606837, \"pred\": 1}, {\"x\": 2.184310481955429, \"y\": 2.502355940359632, \"pred\": 1}, {\"x\": 1.3501878997225267, \"y\": 0.8612113741693206, \"pred\": 0}, {\"x\": 1.9475261519089524, \"y\": 3.2034922322952664, \"pred\": 1}, {\"x\": 0.9031540597999508, \"y\": 2.484118419846157, \"pred\": 1}, {\"x\": 1.3852536804012796, \"y\": 1.7577995454226543, \"pred\": 1}, {\"x\": -1.0670398044692198, \"y\": -0.059260833836361, \"pred\": 0}, {\"x\": -0.19049578315740576, \"y\": 0.6722721224549026, \"pred\": 0}, {\"x\": 1.5606669550207917, \"y\": 1.7147110417443479, \"pred\": 1}, {\"x\": 3.7056421167090754, \"y\": 1.6251868522955508, \"pred\": 1}, {\"x\": -1.1205068713840005, \"y\": -0.3466067875476209, \"pred\": 0}, {\"x\": 0.7909698216528814, \"y\": -1.391766084294036, \"pred\": 0}, {\"x\": 0.6350869000947228, \"y\": -0.2688785015946833, \"pred\": 0}, {\"x\": -0.712390662050588, \"y\": 0.753766378659703, \"pred\": 0}, {\"x\": 2.7678507375866435, \"y\": 1.84486501727544, \"pred\": 1}, {\"x\": -0.13752826816152028, \"y\": -1.8003657016978516, \"pred\": 0}, {\"x\": 0.080866188394344, \"y\": -2.319847554388968, \"pred\": 0}, {\"x\": 0.4979639779852594, \"y\": 2.749678337984768, \"pred\": 1}, {\"x\": 2.1072911932669545, \"y\": 2.4347700117360502, \"pred\": 1}, {\"x\": 1.7496400449660001, \"y\": 1.8036383271590657, \"pred\": 1}, {\"x\": 2.692214884564876, \"y\": 1.187279706485618, \"pred\": 1}, {\"x\": 2.3071132822078066, \"y\": 0.9303479927054046, \"pred\": 1}, {\"x\": 0.4813399523048028, \"y\": 0.3080908624754918, \"pred\": 0}, {\"x\": 1.2022930609701978, \"y\": 2.3357265984452713, \"pred\": 1}, {\"x\": -0.15579970816999872, \"y\": -1.4634777566193453, \"pred\": 0}, {\"x\": -0.9626608287669728, \"y\": -0.7013680441849037, \"pred\": 0}, {\"x\": 0.7435452461317569, \"y\": -0.6625811650314397, \"pred\": 0}, {\"x\": 0.1406138453747909, \"y\": 0.019892207578106016, \"pred\": 0}, {\"x\": 1.7405406203764353, \"y\": 3.3756491396961157, \"pred\": 1}, {\"x\": 0.636539037502539, \"y\": 2.2014015005452823, \"pred\": 1}, {\"x\": 0.8624014081512591, \"y\": 0.5232452162507775, \"pred\": 0}, {\"x\": -0.025645745936127125, \"y\": -0.9590398006025731, \"pred\": 0}, {\"x\": -0.11723949907063196, \"y\": 1.100836264556602, \"pred\": 0}, {\"x\": 2.3927390062646094, \"y\": 0.18548973091234577, \"pred\": 1}, {\"x\": -0.19422133384463808, \"y\": 0.5877885293013254, \"pred\": 0}, {\"x\": -0.2918113875232261, \"y\": 0.12677274472597902, \"pred\": 0}, {\"x\": -1.3825474846365924, \"y\": 0.23254262542334578, \"pred\": 0}, {\"x\": 0.6558615323233493, \"y\": -0.22467908543381457, \"pred\": 0}, {\"x\": 3.870349907724047, \"y\": 3.1109274374798166, \"pred\": 1}, {\"x\": 0.9528306110451948, \"y\": -1.0871815907509188, \"pred\": 0}, {\"x\": -0.4371456556814915, \"y\": 0.5479183096073379, \"pred\": 0}, {\"x\": -0.16127395672832917, \"y\": 0.44951651436299817, \"pred\": 0}, {\"x\": 2.997813029717478, \"y\": 3.231244588814504, \"pred\": 1}, {\"x\": 2.2250075222163606, \"y\": 0.4688637055535052, \"pred\": 1}, {\"x\": 1.853407493274361, \"y\": 2.078487613593274, \"pred\": 1}, {\"x\": -0.7709685285300425, \"y\": -0.41395371382728313, \"pred\": 0}, {\"x\": 0.6129550677145995, \"y\": 0.23966318182680454, \"pred\": 0}, {\"x\": 2.3005952863784875, \"y\": 1.0472838605961088, \"pred\": 1}, {\"x\": 1.436570669708498, \"y\": -0.5795082893291696, \"pred\": 0}, {\"x\": -1.054657177172913, \"y\": -0.9776990052219913, \"pred\": 0}, {\"x\": 1.4798744615901476, \"y\": 1.7356680561833622, \"pred\": 1}, {\"x\": -1.9241594490929896, \"y\": -0.757453225587536, \"pred\": 0}, {\"x\": 2.1563577719221985, \"y\": 4.365673555946404, \"pred\": 1}, {\"x\": 0.7884285840121856, \"y\": 0.5685312896803145, \"pred\": 1}, {\"x\": 3.740933814341995, \"y\": -0.03556415619944708, \"pred\": 1}, {\"x\": 3.38509438533557, \"y\": 1.88933556101016, \"pred\": 1}, {\"x\": -2.4957528823141972, \"y\": 1.3043577797963937, \"pred\": 0}, {\"x\": 2.736058077736053, \"y\": 2.666016362052516, \"pred\": 1}, {\"x\": 1.592827313909267, \"y\": 3.621161963396762, \"pred\": 1}, {\"x\": 2.599269524155709, \"y\": 2.9696621383994226, \"pred\": 1}, {\"x\": 2.271330979002925, \"y\": 4.611365466501027, \"pred\": 1}, {\"x\": 1.2321130918482257, \"y\": 2.772256448671617, \"pred\": 1}, {\"x\": 4.199320450880061, \"y\": 2.7617220943402283, \"pred\": 1}, {\"x\": 4.438510067019951, \"y\": 1.9501456048622783, \"pred\": 1}, {\"x\": 0.9399792195744116, \"y\": 0.9506069961060607, \"pred\": 0}, {\"x\": 0.4403789105928676, \"y\": -0.8384801402483328, \"pred\": 0}, {\"x\": 1.8758843070900657, \"y\": 2.023663980551364, \"pred\": 1}, {\"x\": 1.227322247613268, \"y\": 2.7321707051874116, \"pred\": 1}, {\"x\": -0.3236790297502634, \"y\": -0.11145904212515595, \"pred\": 0}, {\"x\": 2.3338773158710833, \"y\": 2.173174617420775, \"pred\": 1}, {\"x\": 1.3896197630118723, \"y\": 1.8389429159103785, \"pred\": 1}, {\"x\": 1.2655617879171142, \"y\": 1.326472834693644, \"pred\": 1}, {\"x\": 2.6494568961145273, \"y\": 2.034031096576255, \"pred\": 1}, {\"x\": 2.0541840739491852, \"y\": 2.6806681362126463, \"pred\": 1}, {\"x\": 0.47518769779384906, \"y\": -0.07236315822392445, \"pred\": 0}, {\"x\": 1.556495068521696, \"y\": 0.7868004452776833, \"pred\": 1}, {\"x\": 2.4151904657340686, \"y\": 1.3817176162952216, \"pred\": 1}, {\"x\": 2.230402823356569, \"y\": 2.431946895391424, \"pred\": 1}, {\"x\": 0.337447649965678, \"y\": 3.190858387393793, \"pred\": 1}, {\"x\": 1.194687665488288, \"y\": 1.1558162413648083, \"pred\": 1}, {\"x\": -0.34921913811594835, \"y\": 0.843842055045005, \"pred\": 0}, {\"x\": 1.4207461108249517, \"y\": 2.576007496726984, \"pred\": 1}, {\"x\": 0.15647674659188437, \"y\": 0.20425480457441636, \"pred\": 0}, {\"x\": -0.911344781357355, \"y\": -0.7461352526666984, \"pred\": 0}, {\"x\": -0.0012405611429540924, \"y\": 0.08134367638997905, \"pred\": 0}, {\"x\": -0.1522965744944709, \"y\": 0.704626894626221, \"pred\": 0}, {\"x\": 3.178170580363296, \"y\": 1.7109649913220648, \"pred\": 1}, {\"x\": 0.2532205247585785, \"y\": 0.9407870683897978, \"pred\": 0}, {\"x\": 1.1790347434852069, \"y\": -1.0760914658121563, \"pred\": 0}, {\"x\": 0.18494595039221876, \"y\": -0.6510564789536804, \"pred\": 0}, {\"x\": 0.4076688308069256, \"y\": 2.32353471469165, \"pred\": 1}, {\"x\": 1.9642845933830628, \"y\": 3.0039302837615773, \"pred\": 1}, {\"x\": 1.4028588731444431, \"y\": 1.6045726106064209, \"pred\": 1}, {\"x\": 0.8893585338418935, \"y\": 3.717926200674824, \"pred\": 1}, {\"x\": 0.6367185907707327, \"y\": 1.6782942647037324, \"pred\": 1}, {\"x\": -1.0669628403806435, \"y\": 3.4011057189806557, \"pred\": 0}, {\"x\": 0.2673819755787573, \"y\": -1.0319348271510602, \"pred\": 0}, {\"x\": -1.7207954551375861, \"y\": 0.017982138806439393, \"pred\": 0}, {\"x\": 1.4267264504853654, \"y\": -0.048697610640109204, \"pred\": 0}, {\"x\": -0.057532387873538586, \"y\": 0.5646542880869975, \"pred\": 0}, {\"x\": 1.1950253748410917, \"y\": -1.4615058094923734, \"pred\": 0}, {\"x\": 3.068200909048942, \"y\": 3.9006478804863063, \"pred\": 1}, {\"x\": 0.7304710721169607, \"y\": 0.8996130611234683, \"pred\": 1}, {\"x\": 3.0082325821645153, \"y\": 1.1312706815969824, \"pred\": 1}, {\"x\": 4.208480738141941, \"y\": 2.5871061449468176, \"pred\": 1}, {\"x\": 1.3992384201681904, \"y\": -1.6151079632521659, \"pred\": 0}, {\"x\": 0.36003178759974036, \"y\": -0.43820143730669325, \"pred\": 0}, {\"x\": 2.5915110533990484, \"y\": -0.27102844335797016, \"pred\": 1}, {\"x\": 1.3204048067975092, \"y\": 0.04066528515761626, \"pred\": 0}, {\"x\": 0.4394946907472934, \"y\": 1.7672366043893282, \"pred\": 1}, {\"x\": 0.8486534061441413, \"y\": 1.4169071306933088, \"pred\": 1}, {\"x\": 0.9734403648680088, \"y\": 0.9335892631796991, \"pred\": 1}, {\"x\": -0.9738381295272108, \"y\": 0.8048850955179162, \"pred\": 0}, {\"x\": -0.7640339696578627, \"y\": 0.1012697856437548, \"pred\": 0}, {\"x\": 2.8617222068747257, \"y\": 3.849776385866146, \"pred\": 1}, {\"x\": 0.45053117920927527, \"y\": -0.49429864739786794, \"pred\": 0}, {\"x\": -0.7046047621786199, \"y\": 0.4553185270261121, \"pred\": 0}, {\"x\": 0.1486981280629037, \"y\": 1.4460230634069287, \"pred\": 0}, {\"x\": -1.41124263188717, \"y\": 1.2047437309657716, \"pred\": 0}, {\"x\": 0.4820872038580639, \"y\": 3.3317589492355393, \"pred\": 1}, {\"x\": 0.20156945957526934, \"y\": -0.1650355232064671, \"pred\": 0}, {\"x\": -0.14908830964479858, \"y\": 1.8005179738889225, \"pred\": 1}, {\"x\": 1.7941257462609899, \"y\": 1.0823176653816473, \"pred\": 1}, {\"x\": 1.9434940241593952, \"y\": 1.862979444034073, \"pred\": 1}, {\"x\": -0.4192603220087837, \"y\": 2.386745800499031, \"pred\": 0}, {\"x\": 1.5794502314089767, \"y\": 0.8872219039413722, \"pred\": 1}, {\"x\": -0.5534026175135522, \"y\": -0.24150531238917375, \"pred\": 0}, {\"x\": -1.01700202554413, \"y\": -0.5269892532991041, \"pred\": 0}, {\"x\": -1.9453906815188249, \"y\": 0.8309056578021413, \"pred\": 0}, {\"x\": -0.28410380510716565, \"y\": 0.15003366373872756, \"pred\": 0}, {\"x\": 1.9649289132456702, \"y\": 2.321508194455287, \"pred\": 1}, {\"x\": 0.9000849971172967, \"y\": 0.8890323725239309, \"pred\": 0}, {\"x\": -0.644619180730499, \"y\": -1.1702444249284003, \"pred\": 0}, {\"x\": 3.0737033225195978, \"y\": 2.9818520300440294, \"pred\": 1}, {\"x\": 0.2614395928205015, \"y\": 0.46893464927171374, \"pred\": 0}, {\"x\": -0.8444764142538497, \"y\": -0.5164428497021851, \"pred\": 0}, {\"x\": 1.3116180465656415, \"y\": -1.2548603914775587, \"pred\": 0}, {\"x\": -0.5334945027167617, \"y\": -1.9323560015091858, \"pred\": 0}, {\"x\": 1.1384956408918423, \"y\": 1.1258379535900915, \"pred\": 1}, {\"x\": 1.4786857374358966, \"y\": -1.0453771305385342, \"pred\": 0}, {\"x\": 0.7085245177855963, \"y\": -0.9824603525381572, \"pred\": 0}, {\"x\": -1.8552666603782968, \"y\": -0.11032172211623395, \"pred\": 0}, {\"x\": 0.015174920002897885, \"y\": 0.117052488790469, \"pred\": 0}, {\"x\": 1.3823109341357713, \"y\": 1.3211814156031616, \"pred\": 1}, {\"x\": -1.055658897711565, \"y\": -0.308375994286531, \"pred\": 0}, {\"x\": 0.3650517980270081, \"y\": -0.04520588860236072, \"pred\": 0}, {\"x\": 2.6125269393847117, \"y\": 3.085007239316771, \"pred\": 1}, {\"x\": 3.3363234842354315, \"y\": 1.605563899655047, \"pred\": 1}, {\"x\": -0.6779772552780428, \"y\": 0.1106188085540423, \"pred\": 0}, {\"x\": -0.5361687068333683, \"y\": -2.6939563172399312, \"pred\": 0}, {\"x\": -0.7889890249515489, \"y\": -1.261605945319069, \"pred\": 0}, {\"x\": -0.38445768500357647, \"y\": -0.530327407582726, \"pred\": 0}, {\"x\": 0.41730231988738953, \"y\": 0.26955855330903167, \"pred\": 0}, {\"x\": -0.7320583853311774, \"y\": 0.5751509658063075, \"pred\": 0}, {\"x\": 2.226690771658064, \"y\": 2.311882011998303, \"pred\": 1}, {\"x\": -0.19163168438548278, \"y\": 0.4838288394495532, \"pred\": 0}, {\"x\": 1.9680077421958235, \"y\": 3.0527207346654532, \"pred\": 1}, {\"x\": -1.81842142065901, \"y\": 0.05569219339294779, \"pred\": 0}, {\"x\": 2.4473251505619094, \"y\": 1.1594630002615673, \"pred\": 1}, {\"x\": 1.8050515828561202, \"y\": 1.6736370209291347, \"pred\": 1}, {\"x\": 1.214463504631698, \"y\": 2.034938838643822, \"pred\": 1}, {\"x\": 1.8351757766163321, \"y\": 1.7021931993107415, \"pred\": 1}, {\"x\": 3.325466891523719, \"y\": 3.3007610258555466, \"pred\": 1}, {\"x\": 0.44080738731842145, \"y\": -1.812024553173441, \"pred\": 0}, {\"x\": 0.6070648197036337, \"y\": 2.3086244961655735, \"pred\": 1}, {\"x\": -2.3269262116155196, \"y\": -0.4158113660344991, \"pred\": 0}, {\"x\": -0.4654414831035872, \"y\": 0.4004773841168456, \"pred\": 0}, {\"x\": 1.0784289197973278, \"y\": 2.3187895017249587, \"pred\": 1}, {\"x\": 2.428214351090788, \"y\": 2.229010774428565, \"pred\": 1}, {\"x\": 2.300842716403956, \"y\": 2.1974559832484015, \"pred\": 1}, {\"x\": -0.19651664300377936, \"y\": -0.2648908941443411, \"pred\": 0}, {\"x\": 1.6069637071946876, \"y\": 1.429133723362852, \"pred\": 1}, {\"x\": -0.8732591793851744, \"y\": 0.5560180812944249, \"pred\": 0}, {\"x\": 3.853505633543313, \"y\": 3.1507460321250718, \"pred\": 1}, {\"x\": 0.12730328020698067, \"y\": 2.1503829673811126, \"pred\": 1}, {\"x\": 0.35953229551797367, \"y\": -0.511965094194221, \"pred\": 0}, {\"x\": 3.4465143940508334, \"y\": 5.101863538312319, \"pred\": 1}, {\"x\": 0.8579051809684236, \"y\": 0.40976548500449694, \"pred\": 0}, {\"x\": 0.37467317185190585, \"y\": 3.15456589083811, \"pred\": 1}, {\"x\": 1.3406793435446662, \"y\": 1.466546252991804, \"pred\": 1}, {\"x\": 1.4609918659634333, \"y\": 2.0542065312864928, \"pred\": 1}, {\"x\": 0.7420478267454842, \"y\": 1.1114411280385852, \"pred\": 0}, {\"x\": -0.41998581004543123, \"y\": -0.0285337341330573, \"pred\": 0}, {\"x\": 1.8462176390292164, \"y\": 1.0886226105354244, \"pred\": 1}, {\"x\": 0.48039822370628693, \"y\": 2.669508434914504, \"pred\": 1}, {\"x\": -0.5465767417188724, \"y\": 0.29202648981800744, \"pred\": 0}, {\"x\": 0.9962094669993536, \"y\": -0.04995254339686802, \"pred\": 0}, {\"x\": 0.8971332024654173, \"y\": 1.544007515956213, \"pred\": 1}, {\"x\": 2.506356748813186, \"y\": 2.016462481587103, \"pred\": 1}, {\"x\": 0.7133254192320697, \"y\": -0.9466364609859, \"pred\": 0}, {\"x\": 1.2040703250429852, \"y\": 1.3470353682509972, \"pred\": 1}, {\"x\": -1.0526677980507988, \"y\": -0.5586105579100125, \"pred\": 0}, {\"x\": -0.44151223119024857, \"y\": 0.9552466924396553, \"pred\": 0}, {\"x\": 1.6399277115282798, \"y\": 1.5146525907585886, \"pred\": 1}, {\"x\": -1.469634625209567, \"y\": -0.1463693097462854, \"pred\": 0}, {\"x\": 1.0525318150652148, \"y\": -1.5340965702283584, \"pred\": 0}, {\"x\": -1.639093411201915, \"y\": -0.27813451650877447, \"pred\": 0}, {\"x\": 2.135946763233126, \"y\": 2.247660788661511, \"pred\": 1}, {\"x\": 3.8522909678430186, \"y\": 2.3281097780522138, \"pred\": 1}, {\"x\": 3.3594580312665707, \"y\": 1.3844667369168193, \"pred\": 1}, {\"x\": 1.5892922570199843, \"y\": 4.30578448459959, \"pred\": 1}, {\"x\": -2.233052848438117, \"y\": 0.14202678794857176, \"pred\": 0}, {\"x\": 2.429672594447642, \"y\": 2.042853859669679, \"pred\": 1}, {\"x\": 0.9728507916505504, \"y\": 2.6075086014714084, \"pred\": 1}, {\"x\": 2.842312886127444, \"y\": 1.3091502290657346, \"pred\": 1}, {\"x\": -0.06434314961587694, \"y\": 0.7387144235342626, \"pred\": 0}, {\"x\": 0.3487505938690223, \"y\": -0.3386182541020083, \"pred\": 0}, {\"x\": 3.0222386729565907, \"y\": 3.4916874624264516, \"pred\": 1}, {\"x\": -0.45896716822932365, \"y\": 1.1515287731761275, \"pred\": 0}, {\"x\": 0.23082017281823, \"y\": 0.5467579110457865, \"pred\": 0}, {\"x\": 0.6062886568962988, \"y\": -0.026771649986440726, \"pred\": 0}, {\"x\": -0.5956856051072797, \"y\": 0.7958769911591804, \"pred\": 0}, {\"x\": 2.115737227318506, \"y\": 0.36735386905122724, \"pred\": 1}, {\"x\": -0.2642474112620271, \"y\": -0.9323592637202481, \"pred\": 0}, {\"x\": -1.6003841181528236, \"y\": -0.22205672759554324, \"pred\": 0}, {\"x\": 1.3303169236725105, \"y\": -0.6575172676978901, \"pred\": 0}, {\"x\": 3.1000197097589526, \"y\": 4.801153155014196, \"pred\": 1}, {\"x\": -0.928335225810039, \"y\": -0.7746600331288077, \"pred\": 0}, {\"x\": 2.8223656402267268, \"y\": 3.4418656691638247, \"pred\": 1}, {\"x\": 0.946348007431648, \"y\": 0.39254793773535773, \"pred\": 0}, {\"x\": 1.2690580976875576, \"y\": 0.2572490050399525, \"pred\": 0}, {\"x\": 2.032226881139099, \"y\": 4.567122577428944, \"pred\": 1}, {\"x\": -1.220671903715444, \"y\": -0.565046518309226, \"pred\": 0}, {\"x\": 1.1621877051255987, \"y\": 2.8309427428150205, \"pred\": 1}, {\"x\": 1.985355394382256, \"y\": 0.5389091609733734, \"pred\": 1}, {\"x\": 0.9137407048596775, \"y\": 0.31735092273633597, \"pred\": 0}, {\"x\": 3.147812051000587, \"y\": 1.154813468270937, \"pred\": 1}, {\"x\": 1.3978022435984774, \"y\": 1.8396679985237319, \"pred\": 1}, {\"x\": -1.5120214739877849, \"y\": 0.4446977161029871, \"pred\": 0}, {\"x\": 0.1549035962020594, \"y\": 0.277836156413196, \"pred\": 0}, {\"x\": 2.360380445279691, \"y\": 3.368154875156878, \"pred\": 1}, {\"x\": 0.11163027156564224, \"y\": 0.2829905076675621, \"pred\": 0}, {\"x\": 0.1687210624313978, \"y\": -1.4889501692875957, \"pred\": 0}, {\"x\": 0.9118946811654338, \"y\": 2.551469174853076, \"pred\": 1}, {\"x\": 0.747371595544824, \"y\": 1.075681534164297, \"pred\": 0}, {\"x\": 1.2571257313814808, \"y\": 0.18248209713031777, \"pred\": 0}, {\"x\": -0.7574771053093196, \"y\": -0.5108262341824535, \"pred\": 0}, {\"x\": -0.16240072992892313, \"y\": 1.3391315836256719, \"pred\": 0}, {\"x\": 1.0712974056744988, \"y\": 2.124654858947829, \"pred\": 1}, {\"x\": -0.018421809137576996, \"y\": 0.10767464455391365, \"pred\": 0}, {\"x\": 0.5467334374800554, \"y\": 0.750423475071857, \"pred\": 1}, {\"x\": -0.19380492240705713, \"y\": 1.5666402273744786, \"pred\": 0}, {\"x\": 2.3104323874656347, \"y\": 0.22399592783418343, \"pred\": 1}, {\"x\": 0.45348104026746144, \"y\": 0.9223441482568703, \"pred\": 0}, {\"x\": 2.2487456886625603, \"y\": 1.7232575132248926, \"pred\": 1}, {\"x\": -0.33240947257420594, \"y\": 2.0921686012929617, \"pred\": 0}, {\"x\": 0.9929491259546886, \"y\": -0.6437970571220203, \"pred\": 0}, {\"x\": 0.2676098967321498, \"y\": 0.8784598910238555, \"pred\": 0}, {\"x\": 0.9450577461588743, \"y\": 1.8378156974976747, \"pred\": 1}, {\"x\": 0.7571112741306737, \"y\": -1.2085723310812708, \"pred\": 0}, {\"x\": 2.095520834264214, \"y\": 2.3200664601730594, \"pred\": 1}, {\"x\": 0.5253295997343811, \"y\": -1.2768778466596493, \"pred\": 0}, {\"x\": 0.7419006788952703, \"y\": -0.3519968223496652, \"pred\": 0}, {\"x\": -0.044503078338053455, \"y\": 0.45181233874578974, \"pred\": 0}, {\"x\": -0.7068190812919728, \"y\": -0.6861465851073458, \"pred\": 0}, {\"x\": -1.7385178655572635, \"y\": 0.5704933453211514, \"pred\": 0}, {\"x\": 2.998899886332779, \"y\": 0.634248698991208, \"pred\": 1}, {\"x\": 0.15420459268584072, \"y\": 0.8173055190310792, \"pred\": 0}, {\"x\": -1.9774177085108056, \"y\": 2.2386487591829325, \"pred\": 0}, {\"x\": 1.5013438169373443, \"y\": 1.6045531391802799, \"pred\": 1}, {\"x\": -0.2324258720274623, \"y\": 0.7109747948581455, \"pred\": 0}, {\"x\": 2.0551775521900577, \"y\": 2.4190681047807843, \"pred\": 1}, {\"x\": -1.6642564360602479, \"y\": -0.1217464334245328, \"pred\": 0}, {\"x\": -0.23181317888607783, \"y\": -0.1165749870881772, \"pred\": 0}, {\"x\": 3.415864945921144, \"y\": 0.5329883064330754, \"pred\": 1}, {\"x\": -0.407616632784632, \"y\": -0.668307894421939, \"pred\": 0}, {\"x\": 1.7477370760676236, \"y\": 1.20634705787289, \"pred\": 1}, {\"x\": 1.2751258373944747, \"y\": 0.4609946505605043, \"pred\": 0}, {\"x\": 0.31244125715700677, \"y\": 0.21920844617560786, \"pred\": 1}, {\"x\": 0.20522091485414617, \"y\": -0.045963992111946794, \"pred\": 1}, {\"x\": 1.4063603231723563, \"y\": 2.9410600435834002, \"pred\": 1}, {\"x\": 0.5628467852810314, \"y\": -0.24332625188556253, \"pred\": 0}, {\"x\": 0.5011676877836018, \"y\": 0.9199851312920041, \"pred\": 0}, {\"x\": 0.017446916303085782, \"y\": -0.7200583582807348, \"pred\": 0}, {\"x\": -0.3848490502028002, \"y\": -1.5509569211976624, \"pred\": 0}, {\"x\": 2.5005989239578374, \"y\": 1.6544858315564697, \"pred\": 1}, {\"x\": 2.208494645965929, \"y\": 0.9483154856821232, \"pred\": 1}, {\"x\": -0.5351833981652417, \"y\": 0.8683775099508642, \"pred\": 0}, {\"x\": -0.8541429534648363, \"y\": 0.46565797200403236, \"pred\": 0}, {\"x\": 2.5920840674002923, \"y\": 0.37476811336909965, \"pred\": 1}, {\"x\": 3.0388537536498363, \"y\": 1.1822453985407702, \"pred\": 1}, {\"x\": 2.0709735272198517, \"y\": 1.7885843905817853, \"pred\": 1}, {\"x\": 0.35021313455542263, \"y\": 0.47347563519013397, \"pred\": 0}, {\"x\": 0.8917941660323877, \"y\": -1.5390641198540729, \"pred\": 0}, {\"x\": -0.1452113325860197, \"y\": 0.23785783828501061, \"pred\": 0}, {\"x\": -2.2068670954994913, \"y\": -0.4031289968469349, \"pred\": 0}, {\"x\": -0.6359031894503993, \"y\": 0.1997790971313106, \"pred\": 0}, {\"x\": 2.9898112579100316, \"y\": 2.8909152648111034, \"pred\": 1}, {\"x\": -0.01335974789092953, \"y\": 1.2355527522919023, \"pred\": 1}, {\"x\": -0.5083432327925071, \"y\": -0.6862364377992013, \"pred\": 0}, {\"x\": 0.6398839732802036, \"y\": 2.0536932362953815, \"pred\": 0}, {\"x\": 2.5461421558243416, \"y\": 1.2625939497950327, \"pred\": 1}, {\"x\": 1.3052737165412949, \"y\": 4.091883216971763, \"pred\": 1}, {\"x\": 0.9901299572529987, \"y\": 2.0749485504359404, \"pred\": 1}, {\"x\": 0.38411581154380325, \"y\": 1.4122345812397805, \"pred\": 1}, {\"x\": 3.0697263031814166, \"y\": -0.2804598261590847, \"pred\": 1}, {\"x\": 0.35136152893488404, \"y\": 0.788570479116926, \"pred\": 0}, {\"x\": 0.7659110492252689, \"y\": 0.20780005335113885, \"pred\": 0}, {\"x\": 2.2009639538279697, \"y\": 1.272294725099329, \"pred\": 1}, {\"x\": 3.7868569004388535, \"y\": 1.6714447664628662, \"pred\": 1}, {\"x\": 1.6961871140730036, \"y\": 2.699506870262244, \"pred\": 1}, {\"x\": 0.542544026931158, \"y\": 0.6261672937955176, \"pred\": 0}, {\"x\": -0.557684623006479, \"y\": -0.9570655488171265, \"pred\": 0}, {\"x\": 2.1800817394030765, \"y\": 0.37012151528707427, \"pred\": 1}, {\"x\": 2.0854556487772595, \"y\": 3.136275128464981, \"pred\": 1}, {\"x\": 2.3056068400458085, \"y\": 2.3978884495586614, \"pred\": 1}, {\"x\": 2.170329118452739, \"y\": -0.0334652980293213, \"pred\": 1}, {\"x\": -1.0942595125916925, \"y\": 1.982925182595953, \"pred\": 0}, {\"x\": 0.3532107803002698, \"y\": -0.8912937922772961, \"pred\": 0}, {\"x\": 1.3149422380864075, \"y\": 1.8490054305793169, \"pred\": 1}, {\"x\": 0.49223250052885703, \"y\": 1.7253989475688583, \"pred\": 1}, {\"x\": 2.009512655017796, \"y\": 3.5201334154397417, \"pred\": 1}, {\"x\": 1.9980452901555539, \"y\": 2.303724390568587, \"pred\": 1}, {\"x\": 2.5723636214743255, \"y\": 0.7736503599904248, \"pred\": 1}, {\"x\": 1.4844656543417931, \"y\": 2.992559756677755, \"pred\": 1}, {\"x\": 1.9917624296046446, \"y\": 1.679432402454359, \"pred\": 1}, {\"x\": 2.855678786912586, \"y\": 2.292225674252774, \"pred\": 1}, {\"x\": 3.683495929813405, \"y\": 1.3855166043567386, \"pred\": 1}, {\"x\": 1.186979048375644, \"y\": 2.797672569082689, \"pred\": 1}, {\"x\": -1.4141544662915098, \"y\": 0.12673002941390707, \"pred\": 0}, {\"x\": -1.0259108732843625, \"y\": 0.20581615250656984, \"pred\": 0}, {\"x\": 1.7712398465971424, \"y\": 1.481672243119422, \"pred\": 1}, {\"x\": 0.29164051076463826, \"y\": -0.3896555250433101, \"pred\": 0}, {\"x\": 2.7668504972793944, \"y\": 1.5704062429021668, \"pred\": 1}, {\"x\": 1.4739316414007817, \"y\": 2.1693502758148995, \"pred\": 1}, {\"x\": 1.3451017084510097, \"y\": 0.5323378882945463, \"pred\": 0}, {\"x\": 2.202473172070938, \"y\": 1.1927704745729666, \"pred\": 1}, {\"x\": 0.1364330425598168, \"y\": 1.6547766001068898, \"pred\": 1}, {\"x\": 3.7281893840230502, \"y\": 1.1457280642521839, \"pred\": 1}, {\"x\": -0.9841607817725814, \"y\": 1.190705272505982, \"pred\": 0}, {\"x\": 3.052333378588207, \"y\": 1.5469353257425968, \"pred\": 1}, {\"x\": 1.1757285420219539, \"y\": 0.7078651140198504, \"pred\": 1}, {\"x\": 1.8188436537188366, \"y\": -0.0552061713027614, \"pred\": 1}, {\"x\": 3.7848212310913274, \"y\": 1.8713978097811776, \"pred\": 1}, {\"x\": -1.1527257504517598, \"y\": -0.913446285204153, \"pred\": 0}, {\"x\": 1.8260275987189714, \"y\": 0.6650746330128983, \"pred\": 1}, {\"x\": 0.2283352044566521, \"y\": -0.6753750576188053, \"pred\": 0}, {\"x\": 2.4276671452734377, \"y\": 1.793206065362875, \"pred\": 1}, {\"x\": 2.7702785657932285, \"y\": 0.6327607703571645, \"pred\": 1}, {\"x\": 0.9630313786660784, \"y\": -1.9278777352364316, \"pred\": 0}, {\"x\": -0.6191847305942658, \"y\": 1.2125948226530212, \"pred\": 0}, {\"x\": -0.08809626952746996, \"y\": -0.36184796336959735, \"pred\": 0}, {\"x\": 3.723386352013055, \"y\": 0.5734760719351109, \"pred\": 1}, {\"x\": -1.0835914658230943, \"y\": -0.0001493927548569246, \"pred\": 0}, {\"x\": 2.7546480021839517, \"y\": 0.8294406857458252, \"pred\": 1}, {\"x\": 3.548200204010281, \"y\": 1.4076847120803713, \"pred\": 1}, {\"x\": 2.2625682294037417, \"y\": 2.396449917961715, \"pred\": 1}, {\"x\": 1.6380195259704862, \"y\": 2.5114604025401603, \"pred\": 1}, {\"x\": 0.5022857779517222, \"y\": 0.839193535320577, \"pred\": 0}, {\"x\": 2.53313595254121, \"y\": 1.7073139503965051, \"pred\": 1}, {\"x\": -0.5231642148972904, \"y\": -0.48137141579474935, \"pred\": 0}, {\"x\": 1.9906249118224364, \"y\": 0.16605400369245205, \"pred\": 1}, {\"x\": 1.2144508157368235, \"y\": 1.9506801724468557, \"pred\": 1}, {\"x\": 2.534649634454772, \"y\": 0.1469932950896291, \"pred\": 1}, {\"x\": -0.3221236569774085, \"y\": -0.37011607810475444, \"pred\": 0}, {\"x\": 2.7531069136156465, \"y\": 1.4426703238756096, \"pred\": 1}, {\"x\": 1.842865943529341, \"y\": 1.9075822293664888, \"pred\": 1}, {\"x\": 0.8149954430712237, \"y\": -1.185418809153406, \"pred\": 0}, {\"x\": 0.21745165945019368, \"y\": 0.5143288551447859, \"pred\": 0}, {\"x\": 0.35033088498361975, \"y\": 1.8004397115563828, \"pred\": 1}, {\"x\": 1.0942750991001489, \"y\": 0.004613901175436712, \"pred\": 0}, {\"x\": -0.5338435604421259, \"y\": -0.07115124422410989, \"pred\": 0}, {\"x\": -0.4979713554723796, \"y\": 0.9384604688575977, \"pred\": 0}, {\"x\": 1.0172414890962727, \"y\": 0.5529783472619647, \"pred\": 1}, {\"x\": 0.489805675723485, \"y\": 1.3007227251380344, \"pred\": 1}, {\"x\": -0.3148580761325759, \"y\": -0.42989708186880404, \"pred\": 0}, {\"x\": 4.221653853655571, \"y\": 1.8180194889356027, \"pred\": 1}, {\"x\": 3.4145035166500803, \"y\": 1.4537352027795598, \"pred\": 1}, {\"x\": 0.07299114797407072, \"y\": -0.24006071463865328, \"pred\": 0}, {\"x\": -0.9802743185258672, \"y\": -0.002389025600514556, \"pred\": 0}, {\"x\": 1.9176476860844183, \"y\": 0.8990088769612876, \"pred\": 1}, {\"x\": -0.15170019141369395, \"y\": -1.2368377011017966, \"pred\": 0}, {\"x\": 0.9995238627794718, \"y\": 0.33912166991349607, \"pred\": 0}, {\"x\": 2.7971698357380883, \"y\": 0.4284961677589696, \"pred\": 1}, {\"x\": 0.3303022703226134, \"y\": 1.2795087343766578, \"pred\": 0}, {\"x\": 0.6793203874098627, \"y\": 2.4897075316883863, \"pred\": 0}, {\"x\": 3.1801316897135203, \"y\": -0.0025192964192513045, \"pred\": 1}, {\"x\": 0.49087183250951594, \"y\": 1.8927422187767202, \"pred\": 0}, {\"x\": 2.823953492083943, \"y\": 1.8754466148450735, \"pred\": 1}, {\"x\": 0.40865864630465626, \"y\": -0.8677998149261569, \"pred\": 0}, {\"x\": 0.7998766732572836, \"y\": 0.6790266830356967, \"pred\": 0}, {\"x\": 3.16457816375343, \"y\": 2.5299278264194656, \"pred\": 1}, {\"x\": 3.0824789636044114, \"y\": 4.966250097193541, \"pred\": 1}, {\"x\": 1.1722774270578469, \"y\": 1.1490631884147902, \"pred\": 0}, {\"x\": 1.0369968080399357, \"y\": -1.3189645536049885, \"pred\": 0}, {\"x\": 3.7280110563709856, \"y\": 3.6421336258852905, \"pred\": 1}, {\"x\": 0.6386749234055078, \"y\": 0.17851926932176165, \"pred\": 1}, {\"x\": -0.7686270207784495, \"y\": 0.7291654706806434, \"pred\": 0}, {\"x\": 0.4006736681660438, \"y\": -0.764593898622952, \"pred\": 0}, {\"x\": 4.503354046947538, \"y\": 2.838073066693751, \"pred\": 1}, {\"x\": 2.9113751643607433, \"y\": 2.1412893173639698, \"pred\": 1}, {\"x\": 3.294056296712104, \"y\": -0.36469608065789894, \"pred\": 1}, {\"x\": 0.31287871866605876, \"y\": 0.13679032249522113, \"pred\": 0}, {\"x\": 0.5319765561553507, \"y\": -1.3703642428009506, \"pred\": 0}, {\"x\": 0.8672126651998152, \"y\": -0.5209590207114089, \"pred\": 0}, {\"x\": -0.5136792046662925, \"y\": -1.257253734973249, \"pred\": 0}, {\"x\": 2.7212519457943585, \"y\": 0.050249003899367484, \"pred\": 1}, {\"x\": 0.3972413264075336, \"y\": -1.5128451152607716, \"pred\": 0}, {\"x\": 2.531723565932997, \"y\": 2.239581604376858, \"pred\": 1}, {\"x\": -1.830354023073999, \"y\": 0.6019355688249879, \"pred\": 0}, {\"x\": 1.9452558917173377, \"y\": 0.3598283935608044, \"pred\": 1}, {\"x\": 0.7622308225590424, \"y\": -0.25251758817880776, \"pred\": 0}, {\"x\": 1.4977015999604872, \"y\": 0.6446988633003452, \"pred\": 1}, {\"x\": 0.6598257388547495, \"y\": 3.6128983277731725, \"pred\": 1}, {\"x\": 2.0945008750379053, \"y\": 1.267184830290836, \"pred\": 1}, {\"x\": 1.717175959710519, \"y\": 0.7778483925521874, \"pred\": 0}, {\"x\": 2.328566455889293, \"y\": 0.7208853070121146, \"pred\": 1}, {\"x\": 2.921435479755555, \"y\": 1.7071197902880657, \"pred\": 1}, {\"x\": -3.210430797268423, \"y\": 0.4777660895774647, \"pred\": 0}, {\"x\": 1.564791953399383, \"y\": 2.3255322669728162, \"pred\": 1}, {\"x\": 1.0441306350285604, \"y\": 2.1003552832079437, \"pred\": 1}, {\"x\": 1.4992193438668884, \"y\": 4.04414288098479, \"pred\": 1}, {\"x\": 1.749241790081012, \"y\": 0.5011372949374676, \"pred\": 0}, {\"x\": 3.3974402689876415, \"y\": 2.5031037927644775, \"pred\": 1}, {\"x\": 2.379428273695179, \"y\": 2.3775040758320616, \"pred\": 1}, {\"x\": 2.836948426757939, \"y\": 1.1309460946801244, \"pred\": 1}, {\"x\": 0.4349760219816502, \"y\": 0.7588944642911625, \"pred\": 0}, {\"x\": 0.3902203816463774, \"y\": 3.4041647200248475, \"pred\": 1}, {\"x\": 1.1097851050648244, \"y\": 2.856810097997084, \"pred\": 1}, {\"x\": -0.882490391596822, \"y\": -0.6606324986051187, \"pred\": 0}, {\"x\": -0.3051810275934747, \"y\": 0.041447402165011596, \"pred\": 0}, {\"x\": 2.7287649446028355, \"y\": 0.6998183159944318, \"pred\": 1}, {\"x\": -2.236053777261358, \"y\": 0.5833276501518617, \"pred\": 0}, {\"x\": 0.7547050088790299, \"y\": -0.7598847788231394, \"pred\": 0}, {\"x\": -1.247336156644393, \"y\": 0.31717096074155054, \"pred\": 0}, {\"x\": 3.3984769733544002, \"y\": 1.787254142967087, \"pred\": 1}, {\"x\": -0.0051374179562285, \"y\": -0.15956287406705108, \"pred\": 0}, {\"x\": 0.6353546579819151, \"y\": 1.8771104516000663, \"pred\": 1}, {\"x\": 0.5451054177509091, \"y\": 1.3168720121050563, \"pred\": 1}, {\"x\": 0.6586660668217251, \"y\": 1.0461644964376338, \"pred\": 0}, {\"x\": 1.6601644225247327, \"y\": 1.1558746731720393, \"pred\": 1}, {\"x\": 0.6609032917196628, \"y\": 0.8224723016354284, \"pred\": 0}, {\"x\": -0.8135337616981977, \"y\": -0.935955221598663, \"pred\": 0}, {\"x\": -0.030667987475674858, \"y\": -0.8814625655313383, \"pred\": 0}]}}, {\"mode\": \"vega-lite\"});\n",
       "</script>"
      ],
      "text/plain": [
       "alt.Chart(...)"
      ]
     },
     "execution_count": 26,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "make_chart(clf, X)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "There is still some overfitting, but that's not necessarily a bad thing, and the numbers are much better than in the decision tree examples."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 27,
   "metadata": {
    "cell_id": "88b8ab1535924aba94171442c0c4f96e",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 987,
    "execution_start": 1669055029083,
    "source_hash": "6092154",
    "tags": []
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " \n",
      "Train score: 99.8%\n",
      "Test score: 96.0%\n",
      "Train log loss: 0.05109014429942453\n",
      "Test log loss: 0.11127556952266289\n",
      "\n"
     ]
    }
   ],
   "source": [
    "print(f''' \n",
    "Train score: {clf.score(X_train, y_train):.1%}\n",
    "Test score: {clf.score(X_test, y_test):.1%}\n",
    "Train log loss: {log_loss(y_train, clf.predict_proba(X_train))}\n",
    "Test log loss: {log_loss(y_test, clf.predict_proba(X_test))}\n",
    "''')"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "It is very impressive that we can get such a good test score and such a good test log loss using decision trees like in the previous section.  We have access to these 1000 individual decision trees via the `estimators_` attribute."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 28,
   "metadata": {
    "cell_id": "70e3b1da2c5b4c02b47c36a9f7352341",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 7,
    "execution_start": 1669055085251,
    "source_hash": "470ec688",
    "tags": []
   },
   "outputs": [],
   "source": [
    "z = clf.estimators_"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 29,
   "metadata": {
    "cell_id": "063fd53128a642b8a50df171bb62b882",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 5,
    "execution_start": 1669055100265,
    "source_hash": "e38715a6",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "list"
      ]
     },
     "execution_count": 29,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "type(z)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "This list contains the 1000 individual decision trees in our random forest."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 30,
   "metadata": {
    "cell_id": "65c3231b276f42ee88f0ecc48559d814",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 5,
    "execution_start": 1669055103633,
    "source_hash": "57108c64",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "1000"
      ]
     },
     "execution_count": 30,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "len(z)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 31,
   "metadata": {
    "cell_id": "5c2eeb3a2cfd4ee18acb9db8bc747aa6",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 2,
    "execution_start": 1669055143385,
    "source_hash": "46069e16",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "sklearn.tree._classes.DecisionTreeClassifier"
      ]
     },
     "execution_count": 31,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "type(z[40])"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "It can be counter-intuitive that our accuracy on the random forest (whose predictions correspond to an average of the predictions for the individual decision trees) can be better than most of the accuracies for the individual trees."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 32,
   "metadata": {
    "cell_id": "c6046209cddb4c84b39fcabdb26dd366",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 5,
    "execution_start": 1669055159637,
    "source_hash": "47b67d99",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "0.92"
      ]
     },
     "execution_count": 32,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "z[40].score(X_test, y_test)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 33,
   "metadata": {
    "cell_id": "aea50ba67fec4841a88e01760ad14b0d",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 893,
    "execution_start": 1669055195391,
    "source_hash": "c68db39b",
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "0.94"
      ]
     },
     "execution_count": 33,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "z[41].score(X_test, y_test)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Most of the individual trees have an accuracy of less than 96%, but the overall random forest has an accuracy of 96%.  Try to make this same sort of list, but using `log_loss`.  I think you will find the same sort of results, that the random forest has a much better (i.e., lower) log loss than most of the individual trees.  (I think this distinction will be even more pronounced for log loss than it was for score, because log loss is a more refined measure.)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 35,
   "metadata": {
    "cell_id": "afc20159320948fabd4c3ec57da730c9",
    "deepnote_cell_type": "code",
    "deepnote_to_be_reexecuted": false,
    "execution_millis": 17,
    "execution_start": 1669055276141,
    "source_hash": "1ed54e2c",
    "tags": [
     "output_scroll"
    ]
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "[0.92,\n",
       " 0.9,\n",
       " 0.96,\n",
       " 0.9,\n",
       " 0.9,\n",
       " 0.86,\n",
       " 0.9,\n",
       " 0.98,\n",
       " 0.98,\n",
       " 0.92,\n",
       " 0.88,\n",
       " 0.88,\n",
       " 0.84,\n",
       " 0.94,\n",
       " 0.92,\n",
       " 0.92,\n",
       " 0.9,\n",
       " 0.94,\n",
       " 0.88,\n",
       " 0.94,\n",
       " 0.92,\n",
       " 0.92,\n",
       " 0.92,\n",
       " 0.92,\n",
       " 0.88,\n",
       " 0.88,\n",
       " 0.96,\n",
       " 0.92,\n",
       " 0.94,\n",
       " 0.88,\n",
       " 0.92,\n",
       " 0.94,\n",
       " 0.98,\n",
       " 0.92,\n",
       " 0.86,\n",
       " 0.94,\n",
       " 0.96,\n",
       " 0.9,\n",
       " 0.96,\n",
       " 0.9,\n",
       " 0.92,\n",
       " 0.94,\n",
       " 0.92,\n",
       " 0.9,\n",
       " 0.92]"
      ]
     },
     "execution_count": 35,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "[clf_tree.score(X_test, y_test) for clf_tree in z[:45]]"
   ]
  }
 ],
 "metadata": {
  "deepnote": {},
  "deepnote_execution_queue": [],
  "deepnote_notebook_id": "ea11da455a794b1f92189af8e735a6c6",
  "kernelspec": {
   "display_name": "Python 3 (ipykernel)",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.9.13"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 4
}
